from typing import Any, Dict, Tuple

import numpy as np
from numpy import sqrt


w3j: Dict[Tuple[int, int, int], Any] = {
    # split

    (0, 0, 0): np.array([
        1,
    ]),
    # split

    (0, 1, 1): np.array([
        1/sqrt(3), 0, 0, 0, 1/sqrt(3), 0, 0, 0, 1/sqrt(3),
    ]),
    # split

    (1, 1, 1): np.array([
        0, 0, 0, 0, 0, 1/sqrt(6), 0, -(1/sqrt(6)), 0, 0, 0, -(1/sqrt(6)), 0, 0, 0, 1/sqrt(6), 0, 0, 0, 1/sqrt(6),
        0, -(1/sqrt(6)), 0, 0, 0, 0, 0,
    ]),
    # split

    (0, 2, 2): np.array([
        1/sqrt(5), 0, 0, 0, 0, 0, 1/sqrt(5), 0, 0, 0, 0, 0, 1/sqrt(5), 0, 0, 0, 0, 0, 1/sqrt(5), 0,
        0, 0, 0, 0, 1/sqrt(5),
    ]),
    # split

    (1, 1, 2): np.array([
        0, 0, -(1/sqrt(30)), 0, -(1/sqrt(10)), 0, 1/sqrt(10), 0, 0, 0, 1/sqrt(10), 0, 0, 0, 0, 0, 1/sqrt(10), 0, 0, 0,
        0, 0, sqrt(2/15), 0, 0, 0, 0, 0, 1/sqrt(10), 0, 1/sqrt(10), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(10), 0,
        0, 0, -(1/sqrt(30)), 0, 1/sqrt(10),
    ]),
    # split

    (1, 2, 2): np.array([
        0, 1/sqrt(30), 0, 0, 0, -(1/sqrt(30)), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(10)), 0, 0, 0, 1/sqrt(10), 0, -(1/sqrt(30)),
        0, 0, 0, 1/sqrt(30), 0, 0, 0, 0, 0, sqrt(2/15), 0, 0, 0, 1/sqrt(30), 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(30)), 0, 0, 0, -sqrt(2/15), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(30)), 0, 0, 0, -(1/sqrt(10)), 0, -(1/sqrt(30)),
        0, 1/sqrt(10), 0, 0, 0, 1/sqrt(30), 0, 0, 0, 0, 0, 1/sqrt(30), 0, 0, 0,
    ]),
    # split

    (2, 2, 2): np.array([
        0, 0, -sqrt(2/35), 0, 0, 0, 0, 0, sqrt(3/70), 0, -sqrt(2/35), 0, 0, 0, 0, 0, sqrt(3/70), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/70), 0, 0, 0, 1/sqrt(70), 0, -sqrt(3/70), 0, 1/sqrt(70), 0, 0, 0,
        sqrt(3/70), 0, 0, 0, 0, 0, -sqrt(3/70), 0, 0, 0, -sqrt(2/35), 0, 0, 0, 0, 0, 1/sqrt(70), 0, 0, 0,
        0, 0, sqrt(2/35), 0, 0, 0, 0, 0, 1/sqrt(70), 0, 0, 0, 0, 0, -sqrt(2/35), 0, sqrt(3/70), 0, 0, 0,
        sqrt(3/70), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(70), 0, 0, 0, 1/sqrt(70), 0, sqrt(3/70), 0, 0, 0, sqrt(3/70), 0,
        0, 0, 0, 0, 0, 0, -sqrt(3/70), 0, 0, 0, 0, 0, 0, 0, -sqrt(2/35), 0, 0, 0, sqrt(3/70), 0,
        0, 0, -sqrt(2/35), 0, 0,
    ]),
    # split

    (0, 3, 3): np.array([
        1/sqrt(7), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(7), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(7), 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(7), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(7), 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(7), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(7),
    ]),
    # split

    (1, 2, 3): np.array([
        0, 0, 0, 0, -(1/sqrt(210)), 0, -(1/sqrt(14)), 0, 0, 0, -(1/sqrt(35)), 0, -(1/sqrt(21)), 0, 0, 0, sqrt(2/35), 0, 0, 0,
        0, 0, 1/sqrt(21), 0, 0, 0, 0, 0, 1/sqrt(14), 0, 1/sqrt(210), 0, 0, 0, 0, 0, 1/sqrt(21), 0, 0, 0,
        0, 0, 0, 0, 2*sqrt(2/105), 0, 0, 0, 0, 0, 0, 0, sqrt(3/35), 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(2/105), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(21), 0, 1/sqrt(14), 0, -(1/sqrt(210)), 0, 0, 0, 0, 0, 1/sqrt(21), 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/35), 0, 0, 0, 0, 0, -(1/sqrt(35)), 0, 1/sqrt(21), 0, 0, 0,
        0, 0, -(1/sqrt(210)), 0, 1/sqrt(14),
    ]),
    # split

    (1, 3, 3): np.array([
        0, 1/(2*sqrt(14)), 0, 0, 0, 0, 0, -1/2*1/sqrt(14), 0, sqrt(5/42)/2, 0, 0, 0, 0, 0, -1/2*sqrt(5/42), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(14)), 0, 0, 0, 0, 0, 1/sqrt(14), 0, -1/2*sqrt(5/42), 0, 0, 0, 0, 0, sqrt(5/42)/2,
        0, -1/2*1/sqrt(14), 0, 0, 0, 0, 0, 1/(2*sqrt(14)), 0, 0, 0, 0, 0, 0, 0, sqrt(3/7)/2, 0, 0, 0, 0,
        0, 1/sqrt(21), 0, 0, 0, 0, 0, 1/(2*sqrt(21)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(21),
        0, 0, 0, 0, 0, -(1/sqrt(21)), 0, 0, 0, 0, 0, -1/2*sqrt(3/7), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*1/sqrt(14), 0, 0, 0, 0, 0, -1/2*sqrt(5/42), 0, -1/2*1/sqrt(14), 0, 0, 0, -(1/sqrt(14)), 0, -1/2*sqrt(5/42), 0, 0,
        0, 1/sqrt(14), 0, 0, 0, 0, 0, sqrt(5/42)/2, 0, 0, 0, 0, 0, 1/(2*sqrt(14)), 0, sqrt(5/42)/2, 0, 0, 0, 0,
        0, 1/(2*sqrt(14)), 0, 0, 0, 0, 0,
    ]),
    # split

    (2, 2, 3): np.array([
        0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(7)), 0, sqrt(3/35)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(14),
        0, 0, 0, 0, 0, -1/2*sqrt(3/35), 0, 1/(2*sqrt(7)), 0, 0, 0, 1/sqrt(70), 0, 0, 0, -1/2*1/sqrt(7), 0, -1/2*sqrt(3/35), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(35), 0, 0, 0, 0, 0, -sqrt(2/35),
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/35), 0, -1/2*1/sqrt(7), 0, 0, 0, 0, 0, -(1/sqrt(14)), 0, 0, 0, 0,
        0, -(1/sqrt(35)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(35), 0, 0, 0, 0, 0, 1/sqrt(14),
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/35)/2, 0, -1/2*1/sqrt(7), 0, 0, 0, sqrt(2/35), 0, 0, 0, 0,
        0, -(1/sqrt(35)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(7)), 0, -1/2*sqrt(3/35), 0, 0, 0, 0,
        0, 0, 0, -(1/sqrt(70)), 0, 0, 0, 0, 0, 0, 0, sqrt(3/35)/2, 0, 1/(2*sqrt(7)), 0, -(1/sqrt(14)), 0, 0, 0, 0,
        0, -1/2*1/sqrt(7), 0, sqrt(3/35)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (2, 3, 3): np.array([
        0, 0, 0, 0, -1/2*1/sqrt(21), 0, 0, 0, 0, 0, -(1/sqrt(21)), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(35), 0,
        1/(2*sqrt(21)), 0, -(1/sqrt(21)), 0, 0, 0, 0, 0, -1/2*1/sqrt(21), 0, 1/sqrt(35), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/(2*sqrt(21)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/42)/2, 0, 0, 0, 0, 0,
        1/(2*sqrt(14)), 0, -1/2*sqrt(5/42), 0, 0, 0, 1/sqrt(210), 0, -1/2*1/sqrt(14), 0, 0, 0, 1/sqrt(210), 0, 0, 0, 0, 0, 1/(2*sqrt(14)), 0,
        0, 0, 0, 0, sqrt(5/42)/2, 0, -1/2*1/sqrt(14), 0, 0, 0, 0, 0, -1/2*sqrt(5/42), 0, 0, 0, 0, 0, -1/2*sqrt(5/21), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/35)/2, 0, 0, 0, 0, 0,
        0, 0, 2/sqrt(105), 0, 0, 0, 0, 0, 0, 0, sqrt(3/35)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(5/21), 0, sqrt(5/42)/2, 0, 0, 0, 0, 0, sqrt(5/42)/2, 0, 1/(2*sqrt(14)), 0, 0, 0,
        0, 0, 1/(2*sqrt(14)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(210), 0, 0, 0, 0, 0, 1/sqrt(210), 0,
        1/(2*sqrt(14)), 0, 0, 0, 0, 0, 1/(2*sqrt(14)), 0, sqrt(5/42)/2, 0, 0, 0, 0, 0, sqrt(5/42)/2, 0, 0, 0, -1/2*1/sqrt(21), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(21), 0, -(1/sqrt(35)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(21)), 0, 0, 0, 0, 0, 1/sqrt(35), 0, -1/2*1/sqrt(21), 0, 0, 0, -(1/sqrt(21)), 0, 0, 0, 0, 0,
        0, 0, -1/2*1/sqrt(21), 0, 0,
    ]),
    # split

    (3, 3, 3): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, -(1/sqrt(42)),
        0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(42), 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 1/sqrt(42),
        0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(42)),
        0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, -(1/sqrt(42)),
        0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0,
        0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, -(1/sqrt(42)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/sqrt(42), 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 0,
        0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, 1/sqrt(42), 0, 0, 0, 0,
        0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0,
    ]),
    # split

    (0, 4, 4): np.array([
        1/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/3, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/3, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/3, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/3, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/3,
    ]),
    # split

    (1, 3, 4): np.array([
        0, 0, 0, 0, 0, 0, -1/6*1/sqrt(14), 0, -1/3*1/sqrt(2), 0, 0, 0, 0, 0, -1/2*1/sqrt(42), 0, -1/2*1/sqrt(6), 0, 0, 0,
        0, 0, -(1/sqrt(42)), 0, -1/2*sqrt(5/42), 0, 0, 0, 0, 0, sqrt(5/14)/3, 0, 0, 0, 0, 0, 0, 0, sqrt(5/42)/2, 0,
        0, 0, 0, 0, 0, 0, 1/(2*sqrt(6)), 0, 1/(2*sqrt(42)), 0, 0, 0, 0, 0, 1/(3*sqrt(2)), 0, 1/(6*sqrt(14)), 0, 0, 0,
        0, 0, 0, 0, 1/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(21), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/21)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/(3*sqrt(7)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/21)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(21), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/6, 0, 1/(3*sqrt(2)), 0, -1/6*1/sqrt(14), 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(6)), 0, -1/2*1/sqrt(42), 0,
        0, 0, 0, 0, 0, 0, sqrt(5/42)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/14)/3, 0,
        0, 0, 0, 0, 0, 0, -(1/sqrt(42)), 0, sqrt(5/42)/2, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(42), 0, 1/(2*sqrt(6)), 0,
        0, 0, 0, 0, 0, 0, -1/6*1/sqrt(14), 0, 1/(3*sqrt(2)),
    ]),
    # split

    (1, 4, 4): np.array([
        0, 1/(3*sqrt(10)), 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(10), 0, sqrt(7/10)/6, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(7/10),
        0, 1/(2*sqrt(10)), 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(10), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/3*1/sqrt(2), 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(2)), 0, -1/2*1/sqrt(10), 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(10)),
        0, -1/6*sqrt(7/10), 0, 0, 0, 0, 0, 0, 0, sqrt(7/10)/6, 0, -1/3*1/sqrt(10), 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(10)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 2/(3*sqrt(5)), 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(5)), 0, 0,
        0, 0, 0, 0, 0, 1/(3*sqrt(5)), 0, 0, 0, 0, 0, 0, 0, 1/(6*sqrt(5)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*1/sqrt(5), 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(5), 0, 0,
        0, 0, 0, 0, 0, -1/2*1/sqrt(5), 0, 0, 0, 0, 0, 0, 0, -2/(3*sqrt(5)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(10), 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(7/10), 0, -1/3*1/sqrt(10),
        0, 0, 0, 0, 0, -1/2*1/sqrt(10), 0, -1/6*sqrt(7/10), 0, 0, 0, 0, 0, -1/3*1/sqrt(2), 0, -1/2*1/sqrt(10), 0, 0, 0, 0,
        0, 1/(3*sqrt(2)), 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(10)), 0, 0, 0, 0, 0, 0, 0, sqrt(7/10)/6, 0, 1/(2*sqrt(10)),
        0, 0, 0, 0, 0, 1/(3*sqrt(10)), 0, sqrt(7/10)/6, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(10)), 0, 0, 0, 0,
        0, 0, 0,
    ]),
    # split

    (2, 2, 4): np.array([
        0, 0, 0, 0, 1/(3*sqrt(70)), 0, 0, 0, -1/3*1/sqrt(2), 0, 0, 0, 0, 0, -1/6*1/sqrt(7), 0, -1/6, 0, 0, 0,
        1/sqrt(42), 0, 0, 0, 0, 0, 0, 0, 1/6, 0, -1/6*1/sqrt(7), 0, 0, 0, 0, 0, 1/(3*sqrt(2)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*1/sqrt(7), 0, -1/6, 0, 0, 0, 0, 0, (-2*sqrt(2/35))/3, 0,
        -1/3*sqrt(2/7), 0, 0, 0, 0, 0, 1/sqrt(21), 0, 0, 0, 0, 0, 0, 0, sqrt(2/7)/3, 0, 0, 0, 0, 0,
        0, 0, 1/6, 0, 1/(6*sqrt(7)), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(21), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/35), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(21), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 1/6, 0, -1/6*1/sqrt(7), 0,
        0, 0, 0, 0, 0, 0, sqrt(2/7)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(21), 0,
        0, 0, 0, 0, 0, 0, (-2*sqrt(2/35))/3, 0, sqrt(2/7)/3, 0, 0, 0, 0, 0, 0, 0, -1/6*1/sqrt(7), 0, 1/6, 0,
        1/(3*sqrt(2)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/6, 0, 1/(6*sqrt(7)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, 0, 0, -1/6*1/sqrt(7), 0, 1/6, 0, 0, 0, 0, 0,
        1/(3*sqrt(70)), 0, 0, 0, 1/(3*sqrt(2)),
    ]),
    # split

    (2, 3, 4): np.array([
        0, 0, 0, 1/(2*sqrt(105)), 0, 0, 0, 0, 0, 1/(3*sqrt(5)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/6,
        0, 1/(3*sqrt(7)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(21), 0, 0, 0, 0, 0, 0,
        0, -1/3*1/sqrt(7), 0, 1/6, 0, 0, 0, 0, 0, 1/(3*sqrt(7)), 0, 0, 0, 1/(3*sqrt(5)), 0, 0, 0, 0, 0, 1/(2*sqrt(105)),
        0, 0, 0, -(1/sqrt(30)), 0, -1/2*sqrt(3/70), 0, 0, 0, 0, 0, 0, 0, -1/6*1/sqrt(10), 0, -1/6*sqrt(7/10), 0, 0, 0, 0,
        0, 0, 0, 1/(6*sqrt(14)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0,
        0, 0, 0, -1/3*sqrt(5/14), 0, 1/(6*sqrt(14)), 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(7/10), 0, -1/6*1/sqrt(10), 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(3/70), 0, -(1/sqrt(30)), 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(5), 0, 0, 0, 0, 0, 0,
        0, -2/sqrt(105), 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(21), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(2*sqrt(21)), 0, 0, 0, 0, 0, 0, 0, 2/sqrt(105), 0, 0, 0, 0, 0, 0,
        0, 1/(2*sqrt(5)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/70)/2, 0, -(1/sqrt(30)), 0, 0,
        0, 0, 0, sqrt(7/10)/6, 0, -1/6*1/sqrt(10), 0, 0, 0, 0, 0, sqrt(5/14)/3, 0, 1/(6*sqrt(14)), 0, 0, 0, 0, 0, -(1/sqrt(42)),
        0, 0, 0, 0, 0, 0, 0, -1/6*1/sqrt(14), 0, 0, 0, 0, 0, 0, 0, 1/(6*sqrt(10)), 0, -1/6*sqrt(7/10), 0, 0,
        0, 0, 0, 1/sqrt(30), 0, -1/2*sqrt(3/70), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(105), 0, 0,
        0, 0, 0, 0, 0, -1/3*1/sqrt(7), 0, 0, 0, 1/(3*sqrt(5)), 0, 0, 0, 0, 0, 1/(3*sqrt(7)), 0, 1/6, 0, 0,
        0, -(1/sqrt(21)), 0, 0, 0, 0, 0, 0, 0, -1/6, 0, 1/(3*sqrt(7)), 0, 0, 0, 0, 0, -1/3*1/sqrt(5), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(105)), 0, 0, 0, 0, 0,
    ]),
    # split

    (2, 4, 4): np.array([
        0, 0, 0, 0, 0, 0, -(1/sqrt(165)), 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/55), 0, 0, 0, 0, 0,
        0, 0, -sqrt(3/77), 0, 0, 0, 1/sqrt(165), 0, 0, 0, 0, 0, sqrt(5/231), 0, sqrt(3/55)/2, 0, 0, 0, -sqrt(3/77), 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(3/55), 0, sqrt(5/231), 0, 0, 0, 0, 0, -(1/sqrt(165)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(3/55)/2, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(165), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, sqrt(5/66)/2, 0, -sqrt(7/330), 0,
        0, 0, 0, 0, (3*sqrt(3/770))/2, 0, -1/2*sqrt(5/66), 0, 0, 0, 0, 0, 1/sqrt(462), 0, (-3*sqrt(3/770))/2, 0, 0, 0, 0, 0,
        1/sqrt(462), 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/770))/2, 0, 0, 0, 0, 0, 0, 0, sqrt(5/66)/2, 0, (-3*sqrt(3/770))/2, 0,
        0, 0, 0, 0, sqrt(7/330), 0, -1/2*sqrt(5/66), 0, 0, 0, 0, 0, 0, 0, -sqrt(7/330), 0, 0, 0, 0, 0,
        0, 0, (-2*sqrt(7/55))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(7/55), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 4/(3*sqrt(385)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 17/(6*sqrt(385)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, (2*sqrt(5/77))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17/(6*sqrt(385)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 4/(3*sqrt(385)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(7/55), 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-2*sqrt(7/55))/3, 0, sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, sqrt(7/330), 0, sqrt(5/66)/2, 0, 0, 0, 0, 0,
        0, 0, sqrt(5/66)/2, 0, (3*sqrt(3/770))/2, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/770))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(462), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(462), 0, (3*sqrt(3/770))/2, 0, 0, 0, 0, 0,
        0, 0, (3*sqrt(3/770))/2, 0, sqrt(5/66)/2, 0, 0, 0, 0, 0, 0, 0, sqrt(5/66)/2, 0, sqrt(7/330), 0, 0, 0, 0, 0,
        0, 0, sqrt(7/330), 0, 0, 0, -(1/sqrt(165)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/55), 0, 0, 0,
        0, 0, -(1/sqrt(165)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/55), 0, -sqrt(5/231), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(3/77), 0, 0, 0, 0, 0, 0, 0, sqrt(5/231), 0, -1/2*sqrt(3/55), 0, 0, 0,
        0, 0, -sqrt(3/77), 0, 0, 0, -(1/sqrt(165)), 0, 0, 0, 0, 0, -1/2*sqrt(3/55), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(165)), 0, 0,
    ]),
    # split

    (3, 3, 4): np.array([
        0, 0, 0, 0, 1/sqrt(154), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/462), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(3/154), 0, 1/sqrt(66), 0, -(1/sqrt(22)), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(66)), 0, sqrt(3/154), 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/462), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/462), 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(7/22), 0, 0, 0,
        -1/3*sqrt(5/22), 0, 0, 0, 0, 0, (2*sqrt(2/77))/3, 0, -1/3*1/sqrt(22), 0, 0, 0, -(1/sqrt(462)), 0, 0, 0, 0, 0, 0, 0,
        1/(3*sqrt(22)), 0, (2*sqrt(2/77))/3, 0, 0, 0, 0, 0, sqrt(5/22)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/462), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/154), 0, 1/sqrt(66), 0, 0, 0, 0, 0,
        (2*sqrt(2/77))/3, 0, -1/3*1/sqrt(22), 0, 0, 0, 0, 0, 1/(3*sqrt(154)), 0, -1/3*sqrt(10/77), 0, 0, 0, 0, 0, sqrt(5/462), 0, 0, 0,
        0, 0, 0, 0, sqrt(10/77)/3, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(22)), 0, (-2*sqrt(2/77))/3, 0, 0, 0, 0, 0,
        -(1/sqrt(66)), 0, -sqrt(3/154), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(22)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -(1/sqrt(462)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/462), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(2/77), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/462), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -(1/sqrt(462)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(22)), 0, -(1/sqrt(66)), 0, sqrt(3/154), 0, 0, 0, 0, 0,
        0, 0, 1/(3*sqrt(22)), 0, (2*sqrt(2/77))/3, 0, 0, 0, 0, 0, 0, 0, sqrt(10/77)/3, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/462), 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(154)), 0, sqrt(10/77)/3, 0, 0, 0, 0, 0,
        0, 0, (2*sqrt(2/77))/3, 0, 1/(3*sqrt(22)), 0, 0, 0, 0, 0, 0, 0, sqrt(3/154), 0, -(1/sqrt(66)), 0, 0, 0, -sqrt(5/462), 0,
        0, 0, 0, 0, sqrt(5/22)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(22)), 0, (-2*sqrt(2/77))/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(462)), 0, 0, 0, 0, 0, 0, 0, (2*sqrt(2/77))/3, 0, 1/(3*sqrt(22)), 0,
        0, 0, 0, 0, -1/3*sqrt(7/22), 0, 0, 0, sqrt(5/22)/3, 0, 0, 0, 0, 0, -sqrt(5/462), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/462), 0, 0, 0, 0, 0, -(1/sqrt(66)), 0, -sqrt(3/154), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(22)), 0, 0, 0, 0, 0, 0, 0,
        sqrt(3/154), 0, -(1/sqrt(66)), 0, 0, 0, 0, 0, -sqrt(5/462), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(154), 0, 0, 0,
        0,
    ]),
    # split

    (3, 4, 4): np.array([
        0, 0, 0, 1/(3*sqrt(22)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 5/(3*sqrt(154)), 0, 0, 0, 0, 0, -1/3*1/sqrt(22), 0, -5/(3*sqrt(154)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/3*sqrt(5/22), 0, 0, 0, 0, 0, 0, 0, 5/(3*sqrt(154)), 0, -1/3*1/sqrt(22), 0, 0, 0, 0, 0, -5/(3*sqrt(154)),
        0, 0, 0, 0, 0, 0, 0, sqrt(5/22)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(22)), 0, 0,
        0, 0, 0, -(1/sqrt(66)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(66)), 0, 0, 0, 0, 0, 1/sqrt(66),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(66), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(5/462), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(66), 0, 0, 0, 0, 0, -sqrt(5/462),
        0, 0, 0, 1/sqrt(66), 0, 0, 0, 0, 0, -(1/sqrt(66)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(66)),
        0, 0, 0, sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, -sqrt(7/330), 0, 1/sqrt(330), 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(330)), 0, -sqrt(2/1155), 0, 0, 0, 0, 0, 0, 0, sqrt(2/1155), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(3/154), 0, 0, 0, 0, 0, 0, 0, -sqrt(3/154), 0, sqrt(2/1155), 0, 0, 0, 0, 0, 0,
        0, -sqrt(2/1155), 0, -(1/sqrt(330)), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(330), 0, -sqrt(7/330), 0, 0, 0, 0, 0, 0,
        0, sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/55)/3, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(7/110),
        0, 0, 0, 0, 0, 0, 0, -13/(3*sqrt(770)), 0, 0, 0, 0, 0, 0, 0, -3/sqrt(770), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(770), 0, 0, 0, 0, 0, 0, 0, 13/(3*sqrt(770)),
        0, 0, 0, 0, 0, 0, 0, sqrt(7/110)/3, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(14/55), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(330)),
        0, -sqrt(7/330), 0, 0, 0, 0, 0, sqrt(2/1155), 0, -(1/sqrt(330)), 0, 0, 0, 0, 0, sqrt(3/154), 0, sqrt(2/1155), 0, 0,
        0, 0, 0, -sqrt(3/154), 0, 0, 0, 0, 0, 0, 0, -sqrt(2/1155), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(330),
        0, -sqrt(2/1155), 0, 0, 0, 0, 0, sqrt(7/330), 0, 1/sqrt(330), 0, 0, 0, 0, 0, 0, 0, sqrt(7/330), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(66), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(66),
        0, 0, 0, 0, 0, 0, 0, sqrt(5/462), 0, 0, 0, 1/sqrt(66), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(66),
        0, 0, 0, -sqrt(5/462), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(66)), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(66)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(66)), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(66)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(22), 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(5/22),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(3*sqrt(154)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(3*sqrt(154)),
        0, -1/3*1/sqrt(22), 0, sqrt(5/22)/3, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(22)), 0, -5/(3*sqrt(154)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 5/(3*sqrt(154)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/(3*sqrt(22)), 0, 0, 0, 0, 0,
    ]),
    # split

    (4, 4, 4): np.array([
        0, 0, 0, 0, sqrt(14/143)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, sqrt(14/143)/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, 0, 0, 0, 0, 0, 0, -sqrt(7/286), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/286)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/3, 0, sqrt(35/286)/3, 0, -sqrt(7/286), 0,
        0, 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, sqrt(5/286)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/3, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/286)/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/3, 0, 0, 0,
        0, 0, 0, 0, -1/3*sqrt(11/182), 0, 0, 0, -sqrt(5/286), 0, 0, 0, 0, 0, sqrt(10/1001), 0, -1/3*sqrt(5/286), 0, 0, 0,
        -1/3*sqrt(11/182), 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/3, 0, sqrt(10/1001), 0, 0, 0, 0, 0, sqrt(5/286), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, -sqrt(5/286), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/3, 0,
        sqrt(35/286)/3, 0, 0, 0, 0, 0, sqrt(10/1001), 0, -1/3*sqrt(5/286), 0, 0, 0, 0, 0, 3/sqrt(2002), 0, -sqrt(10/1001), 0, 0, 0,
        0, 0, 3/sqrt(2002), 0, 0, 0, 0, 0, 0, 0, sqrt(10/1001), 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/3, 0,
        -sqrt(10/1001), 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, -1/3*sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, sqrt(35/286)/3, 0, 0, 0,
        0, 0, 0, 0, sqrt(14/143)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/286), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/3*sqrt(11/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(2002), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(2002), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/3*sqrt(11/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/286), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(14/143)/3, 0, -1/3*sqrt(35/286), 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, sqrt(5/286)/3, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/286)/3, 0, sqrt(10/1001), 0, 0, 0, 0, 0, 0, 0, sqrt(10/1001), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 3/sqrt(2002), 0, 0, 0, 0, 0, 0, 0, 3/sqrt(2002), 0, sqrt(10/1001), 0, 0, 0,
        0, 0, 0, 0, sqrt(10/1001), 0, sqrt(5/286)/3, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/3, 0, -1/3*sqrt(35/286), 0, 0, 0,
        0, 0, 0, 0, -1/3*sqrt(35/286), 0, 0, 0, sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/3, 0,
        0, 0, 0, 0, sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/3, 0, -sqrt(10/1001), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(11/182), 0, 0, 0, 0, 0, 0, 0, sqrt(10/1001), 0, sqrt(5/286)/3, 0,
        0, 0, 0, 0, -1/3*sqrt(11/182), 0, 0, 0, sqrt(5/286), 0, 0, 0, 0, 0, sqrt(5/286)/3, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/286), 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(5/286), 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, -1/3*sqrt(5/286), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/286), 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/3, 0,
        -1/3*sqrt(35/286), 0, 0, 0, 0, 0, sqrt(5/286)/3, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/286), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/3*sqrt(35/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(35/286)/3, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, sqrt(35/286)/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/143)/3, 0, 0, 0, 0, 0, 0, 0,
        -1/3*sqrt(35/286), 0, 0, 0, 0, 0, 0, 0, sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(35/286), 0, 0, 0,
        0, 0, 0, 0, sqrt(14/143)/3, 0, 0, 0, 0,
    ]),
    # split

    (0, 5, 5): np.array([
        1/sqrt(11), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(11), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(11), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(11), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(11), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(11), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(11), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(11), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(11), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(11), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(11),
    ]),
    # split

    (1, 4, 5): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(110), 0, -(1/sqrt(22)), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(330)), 0,
        -sqrt(2/55), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(165)), 0, -1/3*sqrt(14/55), 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(2/11), 0,
        -sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(33), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/330), 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/55)/3, 0, 1/sqrt(165), 0, 0, 0, 0, 0, 0, 0, sqrt(2/55), 0,
        1/sqrt(330), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(22), 0, 1/(3*sqrt(110)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(55), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4/(3*sqrt(55)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/165), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/165), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/11)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(2/165), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/165), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 4/(3*sqrt(55)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(55), 0, 1/sqrt(22), 0,
        -1/3*1/sqrt(110), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/55), 0, -(1/sqrt(330)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(14/55)/3, 0, -(1/sqrt(165)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/330), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(33), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(2/11), 0,
        sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(165)), 0, sqrt(14/55)/3, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(330)), 0, sqrt(2/55), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(110), 0, 1/sqrt(22),
    ]),
    # split

    (1, 5, 5): np.array([
        0, 1/(2*sqrt(33)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(33), 0, sqrt(3/55)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(3/55), 0, 1/sqrt(55), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(55)), 0, sqrt(7/330), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(22)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(22), 0, -sqrt(7/330), 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/330), 0, -(1/sqrt(55)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(55), 0, -1/2*sqrt(3/55), 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(3/55)/2, 0, -1/2*1/sqrt(33), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(33)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/66), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 2*sqrt(2/165), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/110), 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(2/165), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(330), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(330)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(2/165), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/110), 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2*sqrt(2/165), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/66), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(33), 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(3/55), 0, -1/2*1/sqrt(33), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(55)), 0, -1/2*sqrt(3/55), 0, 0, 0, 0, 0, 0,
        0, -sqrt(7/330), 0, -(1/sqrt(55)), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(22)), 0, -sqrt(7/330), 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(22), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(55), 0, sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, sqrt(3/55)/2, 0, 1/sqrt(55), 0, 0, 0, 0, 0, 0,
        0, 1/(2*sqrt(33)), 0, sqrt(3/55)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(33)), 0, 0, 0, 0, 0, 0,
        0, 0, 0,
    ]),
    # split

    (2, 3, 5): np.array([
        0, 0, 0, 0, 0, 0, 1/(2*sqrt(1155)), 0, 0, 0, -(1/sqrt(22)), 0, 0, 0, 0, 0, 1/sqrt(462), 0, 0, 0,
        -sqrt(3/110), 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(77), 0, -(1/sqrt(66)), 0, 0, 0, 0, 0, 1/sqrt(66), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(66), 0, -1/2*1/sqrt(77), 0, 0, 0, 0, 0, 0, 0, sqrt(3/110), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(22), 0, 0, 0, -1/2*1/sqrt(1155), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*1/sqrt(165), 0, -(1/sqrt(55)), 0, 0, 0, 0, 0, 0, 0, -sqrt(2/385), 0, -2/sqrt(165), 0, 0, 0,
        0, 0, 0, 0, -sqrt(5/231), 0, -1/2*1/sqrt(11), 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/231), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/(2*sqrt(11)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(165), 0, sqrt(2/385), 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(55), 0, 1/(2*sqrt(165)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/165), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/110), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(3/77), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/231), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(3/77), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/110), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/165), 0, 0, 0, 1/sqrt(55), 0, -1/2*1/sqrt(165), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 2/sqrt(165), 0, -sqrt(2/385), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(11)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/231), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(5/231), 0, 1/(2*sqrt(11)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/385), 0, 2/sqrt(165), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*1/sqrt(165), 0, 1/sqrt(55), 0, 1/sqrt(22), 0, 0, 0, 1/(2*sqrt(1155)), 0, 0, 0, 0, 0, 0, 0,
        sqrt(3/110), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(66), 0, 1/(2*sqrt(77)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(66), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(77), 0,
        1/sqrt(66), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(462), 0, 0, 0, sqrt(3/110), 0, 0, 0, 0, 0, 0, 0,
        1/(2*sqrt(1155)), 0, 0, 0, 1/sqrt(22),
    ]),
    # split

    (2, 4, 5): np.array([
        0, 0, 0, 1/(3*sqrt(110)), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(66), 0, 0, 0, sqrt(7/55)/6, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/330), 0, sqrt(5/11)/6, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/22)/3, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/6*sqrt(5/11), 0, sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(66), 0, 0, 0, sqrt(7/330), 0, 0, 0, 0,
        0, 0, 0, sqrt(7/55)/6, 0, 0, 0, 1/sqrt(66), 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(110)), 0, 0, 0, -(1/sqrt(33)),
        0, -(1/sqrt(165)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(165)), 0, -1/6*sqrt(5/11), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (-2*sqrt(2/55))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/55)/6, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/11)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(33)),
        0, sqrt(7/55)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-2*sqrt(2/55))/3, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/6*sqrt(5/11), 0, -(1/sqrt(165)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(165)), 0, -(1/sqrt(33)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(2/55), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/55), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(165)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(165), 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/55), 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(2/55), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/sqrt(165), 0, -(1/sqrt(33)), 0, 0, 0, 0, 0, 0, 0, sqrt(5/11)/6, 0, -(1/sqrt(165)), 0, 0,
        0, 0, 0, 0, 0, (2*sqrt(2/55))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(33), 0, sqrt(7/55)/6, 0, 0,
        0, 0, 0, 0, 0, -1/3*sqrt(2/11), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(7/55), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-2*sqrt(2/55))/3, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(165), 0, -1/6*sqrt(5/11), 0, 0,
        0, 0, 0, 0, 0, 1/sqrt(33), 0, -(1/sqrt(165)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/3*1/sqrt(110), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(7/55), 0, 0, 0, 1/sqrt(66), 0, 0,
        0, 0, 0, -(1/sqrt(66)), 0, 0, 0, sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, sqrt(5/11)/6, 0, sqrt(7/330), 0, 0,
        0, 0, 0, -1/3*sqrt(7/22), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/330), 0, sqrt(5/11)/6, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/330), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(66)), 0, 0, 0, sqrt(7/55)/6, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(110)), 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (2, 5, 5): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/715), 0,
        0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/2145), 0, 0, 0, 1/sqrt(286), 0, 0, 0, 0, 0, -sqrt(14/429), 0,
        0, 0, sqrt(6/715), 0, 0, 0, 0, 0, 0, 0, sqrt(5/286), 0, 2*sqrt(7/2145), 0, 0, 0, 0, 0, -sqrt(14/429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/2145), 0, sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, -sqrt(6/715), 0,
        0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(286)), 0, 0, 0, 2*sqrt(7/2145), 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(6/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(286), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        7/(2*sqrt(715)), 0, -3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, sqrt(5/429), 0, -7/(2*sqrt(715)), 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/1430), 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(858), 0, -sqrt(7/1430), 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(858), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1430), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/429), 0, -sqrt(7/1430), 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(715)), 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0,
        3/(2*sqrt(143)), 0, -7/(2*sqrt(715)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(15/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/715), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(4290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/715), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/1430), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(10/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/1430), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(6/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(4290), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/715), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(15/286), 0, 3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(143)), 0, 7/(2*sqrt(715)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 7/(2*sqrt(715)), 0, sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/429), 0,
        sqrt(7/1430), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1430), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(858), 0, sqrt(7/1430), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(7/1430), 0, sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/429), 0,
        7/(2*sqrt(715)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(715)), 0, 3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 3/(2*sqrt(143)), 0, 0, 0, -(1/sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/715), 0,
        0, 0, 0, 0, 0, 0, -(1/sqrt(286)), 0, 0, 0, -2*sqrt(7/2145), 0, 0, 0, 0, 0, 0, 0, -sqrt(6/715), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/2145), 0, -sqrt(5/286), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(14/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286), 0, -2*sqrt(7/2145), 0,
        0, 0, 0, 0, 0, 0, -sqrt(14/429), 0, 0, 0, -sqrt(6/715), 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/2145), 0,
        0, 0, -(1/sqrt(286)), 0, 0, 0, 0, 0, 0, 0, -sqrt(6/715), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(286)), 0, 0,
    ]),
    # split

    (3, 3, 5): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(11)), 0, 0, 0, -1/2*sqrt(5/462), 0, 0, 0, 0,
        0, 0, 0, 1/(2*sqrt(11)), 0, 1/(2*sqrt(33)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(33), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(33), 0, 1/(2*sqrt(11)), 0, 0, 0, 0, 0, 0,
        0, sqrt(5/462)/2, 0, 0, 0, 1/(2*sqrt(11)), 0, 0, 0, 0, 0, -1/2*1/sqrt(231), 0, 0, 0, 0, 0, -1/2*1/sqrt(11), 0, 0,
        0, sqrt(5/462)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/(2*sqrt(33)), 0, 3/(2*sqrt(154)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(33), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(154)), 0, 1/(2*sqrt(33)), 0, 0, 0, 0, 0, 0, 0, 2/sqrt(231), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/462)/2, 0, 0, 0, -1/2*1/sqrt(11), 0, -1/2*1/sqrt(11), 0, -1/2*1/sqrt(33), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(33), 0, -3/(2*sqrt(154)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/462), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -5/(2*sqrt(231)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(154)), 0, -1/2*1/sqrt(33), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(33), 0, -1/2*1/sqrt(11), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(33)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(33)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/462),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/462),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(33), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(33),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(33)), 0, -1/2*1/sqrt(11), 0, 0,
        0, 0, 0, 0, 0, 3/(2*sqrt(154)), 0, -1/2*1/sqrt(33), 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(231)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(5/462), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(2*sqrt(33)), 0, -3/(2*sqrt(154)), 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(11)), 0, -1/2*1/sqrt(33), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/462), 0, 0, 0, -1/2*1/sqrt(11), 0, 0, 0, 0,
        0, -2/sqrt(231), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(154)), 0, 1/(2*sqrt(33)), 0, 0, 0, 0,
        0, -(1/sqrt(33)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(33), 0, 3/(2*sqrt(154)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(11)), 0, 0, 0, sqrt(5/462)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(231)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/462),
        0, 0, 0, 1/(2*sqrt(11)), 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(33)), 0, 1/(2*sqrt(11)), 0, 0, 0, -(1/sqrt(33)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(11), 0, 1/(2*sqrt(33)), 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(11), 0, 0,
        0, -1/2*sqrt(5/462), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (3, 4, 5): np.array([
        0, 0, 0, 0, 0, 0, 1/sqrt(858), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/143)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(3/2002))/2, 0, 0, 0, sqrt(5/143)/2, 0, 0, 0, 0, 0, 0, 0,
        5/(2*sqrt(429)), 0, 3/(2*sqrt(143)), 0, 0, 0, -sqrt(5/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(143)), 0, 5/(2*sqrt(429)), 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(5/143), 0, 0, 0, (-5*sqrt(3/2002))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(858)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/3*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(11/26), 0, 0, 0,
        -1/2*sqrt(35/429), 0, 0, 0, 0, 0, -4*sqrt(5/3003), 0, 0, 0, -2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 25/(6*sqrt(2002)), 0,
        -1/2*1/sqrt(429), 0, 0, 0, 0, 0, -1/3*sqrt(5/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(429)), 0, 25/(6*sqrt(2002)), 0,
        0, 0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/429)/2, 0, 0, 0,
        sqrt(11/26)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(7/2145), 0, sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/715))/6, 0, -1/2*sqrt(7/2145), 0,
        0, 0, 0, 0, 0, 0, 43/(6*sqrt(10010)), 0, (-3*sqrt(3/715))/2, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(3003)), 0, -8/(3*sqrt(715)), 0,
        0, 0, 0, 0, 0, 0, sqrt(11/182)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8/(3*sqrt(715)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, (3*sqrt(3/715))/2, 0, -43/(6*sqrt(10010)), 0, 0, 0, 0, 0, 0, 0, sqrt(7/2145)/2, 0, (-7*sqrt(7/715))/6, 0,
        0, 0, 0, 0, 0, 0, -sqrt(7/429), 0, -2*sqrt(7/2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/715), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19/sqrt(30030), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(5/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19/sqrt(30030), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(2145), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/715), 0, -sqrt(7/429), 0, 2*sqrt(7/2145), 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/2145)/2, 0, (7*sqrt(7/715))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(3/715))/2, 0, 43/(6*sqrt(10010)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 8/(3*sqrt(715)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(11/182)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(3003)), 0, 8/(3*sqrt(715)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 43/(6*sqrt(10010)), 0, (3*sqrt(3/715))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (7*sqrt(7/715))/6, 0, sqrt(7/2145)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(7/2145), 0, -sqrt(7/429), 0, 0, 0, -1/3*sqrt(7/143), 0,
        0, 0, 0, 0, 0, 0, sqrt(35/429)/2, 0, 0, 0, -1/6*sqrt(11/26), 0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(429)), 0, -25/(6*sqrt(2002)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/3*sqrt(5/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 25/(6*sqrt(2002)), 0, 1/(2*sqrt(429)), 0,
        0, 0, 0, 0, 0, 0, -4*sqrt(5/3003), 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(11/26), 0,
        0, 0, sqrt(35/429)/2, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(858), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/143), 0, 0, 0,
        (5*sqrt(3/2002))/2, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(143)), 0, -5/(2*sqrt(429)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(5/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(429)), 0, -3/(2*sqrt(143)), 0,
        0, 0, 0, 0, 0, 0, (-5*sqrt(3/2002))/2, 0, 0, 0, -1/2*sqrt(5/143), 0, 0, 0, 0, 0, sqrt(5/143)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(858), 0, 0, 0, 0,
    ]),
    # split

    (3, 5, 5): np.array([
        0, 0, 0, sqrt(5/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/2002), 0, 0, 0, 5/(2*sqrt(429)), 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(143)), 0, -5/(2*sqrt(429)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(10/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(429)), 0, -(1/sqrt(143)), 0, 0, 0, 0,
        0, 0, 0, -5/(2*sqrt(429)), 0, 0, 0, -sqrt(5/2002), 0, 0, 0, 0, 0, sqrt(10/429), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/2002), 0, 0,
        0, 0, 0, -sqrt(10/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/2002), 0, 0, 0, 0,
        0, 0, 0, sqrt(10/1001), 0, 0, 0, -2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/2002), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0,
        0, 0, 0, -sqrt(5/858), 0, 0, 0, 3*sqrt(3/2002), 0, 0, 0, 0, 0, 0, 0, -2/sqrt(429), 0, 0, 0, sqrt(10/1001),
        0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(10/1001),
        0, 0, 0, 3*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(2/1001), 0, 4*sqrt(2/5005), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -4*sqrt(2/5005), 0, 1/sqrt(30030), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(30030)), 0, -3/(2*sqrt(715)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(715)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/429), 0, 3/(2*sqrt(715)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3/(2*sqrt(715)), 0, -(1/sqrt(30030)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(30030), 0, -4*sqrt(2/5005),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(2/5005), 0, -3*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 3*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(30/1001), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(6/5005), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(22/1365), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -23/sqrt(30030), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(14/2145), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/2145), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 23/sqrt(30030), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(22/1365), 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(6/5005), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(30/1001), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(2/1001), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -4*sqrt(2/5005), 0, -3*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(30030)), 0, -4*sqrt(2/5005), 0, 0, 0, 0,
        0, 0, 0, 3/(2*sqrt(715)), 0, -(1/sqrt(30030)), 0, 0, 0, 0, 0, 0, 0, sqrt(7/429), 0, 3/(2*sqrt(715)), 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(715)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(30030), 0, -3/(2*sqrt(715)), 0, 0, 0, 0, 0, 0, 0, 4*sqrt(2/5005), 0, 1/sqrt(30030), 0, 0, 0, 0,
        0, 0, 0, 3*sqrt(2/1001), 0, 4*sqrt(2/5005), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(2/1001), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/1001), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 3*sqrt(3/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, sqrt(10/1001), 0, 0,
        0, 0, 0, sqrt(5/858), 0, 0, 0, 3*sqrt(3/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0, 0,
        0, 0, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(429), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -3*sqrt(3/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(10/1001), 0, 0, 0, -2/sqrt(429), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(10/1001), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/2002), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -(1/sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(10/429), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 5/(2*sqrt(429)), 0, 0, 0, -sqrt(5/2002), 0, 0, 0, 0, 0, 0, 0, -5/(2*sqrt(429)), 0, -(1/sqrt(143)),
        0, 0, 0, sqrt(10/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, -5/(2*sqrt(429)), 0, 0, 0, 0,
        0, 0, 0, sqrt(5/2002), 0, 0, 0, 5/(2*sqrt(429)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/2002),
        0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (4, 4, 5): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, (2*sqrt(5/143))/3, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(143), 0, 0, 0, 0, 0, 0,
        0, 0, 0, (-2*sqrt(5/143))/3, 0, 1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, sqrt(5/429), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/(3*sqrt(143)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -3/(2*sqrt(143)), 0, 0, 0, -1/2*sqrt(35/858), 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/143), 0, sqrt(5/429)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(5/429), 0, -1/2*sqrt(5/143), 0, 0, 0, 0, 0, 0, 0, sqrt(35/858)/2, 0, 0, 0, -3/(2*sqrt(143)), 0, 0, 0, 0,
        0, -1/6*sqrt(11/13), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0,
        0, sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(143)), 0, 0, 0, sqrt(35/858)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(35/143), 0, -1/2*sqrt(5/858), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858)/2,
        0, -1/6*sqrt(35/143), 0, 0, 0, 0, 0, 0, 0, 2/(3*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(35/858)/2, 0, 0, 0, 3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, sqrt(5/429), 0, 0, 0, -(1/sqrt(143)), 0, (-2*sqrt(5/143))/3,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/143)/2, 0, -1/2*sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(35/143)/6, 0, sqrt(5/858)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(3/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(143)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858)/2, 0, sqrt(35/143)/6, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(5/429), 0, sqrt(5/143)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-2*sqrt(5/143))/3, 0, -(1/sqrt(143)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -2/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(143)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/286), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/286), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(143), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (2*sqrt(5/143))/3, 0, -(1/sqrt(143)), 0, 0, 0, 0, 0, 0, 0, sqrt(5/429)/2, 0, sqrt(5/143)/2, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(5/858), 0, sqrt(35/143)/6, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(3/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/6*sqrt(35/143), 0, sqrt(5/858)/2, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/143), 0, -1/2*sqrt(5/429), 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(143), 0, (-2*sqrt(5/143))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(35/858), 0, 0, 0, 3/(2*sqrt(143)), 0, 0, 0, 0,
        0, -2/(3*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/858), 0, -1/6*sqrt(35/143), 0, 0, 0, 0,
        0, sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/143)/6, 0, -1/2*sqrt(5/858), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(143)), 0, 0, 0, sqrt(35/858)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858),
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/13)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(35/858), 0, 0, 0, -3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, sqrt(5/429)/2, 0, -1/2*sqrt(5/143), 0, 0, 0, 1/(3*sqrt(143)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/143)/2, 0, sqrt(5/429)/2, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(143)),
        0, 0, 0, -1/2*sqrt(35/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/(3*sqrt(143)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (2*sqrt(5/143))/3, 0, 1/sqrt(143), 0, -2/sqrt(143), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -(1/sqrt(143)), 0, (2*sqrt(5/143))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (4, 5, 5): np.array([
        0, 0, 0, 0, 0, 0, 1/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(35/286)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/429), 0, -(1/sqrt(429)), 0, sqrt(2/143), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(429), 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(35/286)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(429)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/143)/6, 0, 0, 0, sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, sqrt(5/143)/6, 0, sqrt(5/429), 0, 0, 0, -sqrt(2/143), 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/429), 0, sqrt(5/143)/6, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/858), 0,
        0, 0, sqrt(5/143)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, 0, 0, 0, 0,
        -sqrt(7/858), 0, 0, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, sqrt(10/143)/3, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/143)/3, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(35/143)/6, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(429), 0, -1/6*sqrt(35/143), 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/143)/6, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(5/858), 0, -1/6*sqrt(35/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/858), 0, 0, 0, 0, 0,
        0, 0, -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/3*1/sqrt(286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (2*sqrt(2/143))/3, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (2*sqrt(2/143))/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(2/143), 0, -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/858), 0, sqrt(35/143)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/143)/6, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(429), 0, sqrt(35/143)/6, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/143)/6, 0, sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(2/143), 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(10/143), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/143)/3, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/858), 0, 0, 0, sqrt(5/858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, -sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(7/858), 0, 0, 0, -1/6*sqrt(5/143), 0, 0, 0, 0, 0, 0, 0, -sqrt(5/429), 0, -1/6*sqrt(5/143), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/143)/6, 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, sqrt(5/143)/6, 0, 0, 0, -sqrt(7/858), 0, 0, 0, 0, 0,
        -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(429), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/3*sqrt(35/286), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(429), 0, sqrt(5/429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(5/429), 0, 1/sqrt(429), 0, 0, 0, 0, 0, 0, 0, sqrt(35/286)/3, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(429), 0, 0, 0, 0,
    ]),
    # split

    (5, 5, 5): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(286)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3/(2*sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(286)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3/(2*sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/143)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3/(2*sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 3/(2*sqrt(286)), 0, sqrt(5/286)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/286), 0, 3/(2*sqrt(286)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(286)), 0, 0,
        0, 0, 0, 0, 0, sqrt(7/143)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/143), 0, 0, 0, -sqrt(5/858),
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/286), 0, sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(2*sqrt(429)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/858), 0, -1/2*sqrt(5/286), 0, 0,
        0, 0, 0, 0, 0, sqrt(5/858), 0, 0, 0, -1/2*sqrt(7/143), 0, 0, 0, 0, 0, -1/2*1/sqrt(429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/2,
        0, 0, 0, 0, 0, -1/2*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(7/143)/2, 0, 0, 0, sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/858), 0, 0,
        0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, 0,
        0, sqrt(7/143)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(7/143), 0, 0, 0, 3/(2*sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(286)), 0, -1/2*sqrt(5/286), 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/2, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/858),
        0, sqrt(5/286)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/286), 0, -3/(2*sqrt(286)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 3/(2*sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/143)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(429)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/143), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(286)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(5/286)/2, 0, -3/(2*sqrt(286)), 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, sqrt(5/286)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, -2/sqrt(429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/286), 0, -sqrt(5/858), 0, 0,
        0, 0, 0, 0, 0, 3/(2*sqrt(286)), 0, -1/2*sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(286)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/858), 0, 0, 0, sqrt(7/143)/2,
        0, 0, 0, 0, 0, -2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/858),
        0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/143), 0, 0, 0, sqrt(5/858),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/143),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/143), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(429)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(5/858), 0, 0, 0, -1/2*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, sqrt(5/858),
        0, -1/2*sqrt(5/286), 0, 0, 0, -1/2*1/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/2, 0, sqrt(5/858), 0, 0,
        0, 0, 0, 0, 0, sqrt(7/143)/2, 0, 0, 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(7/143)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(286)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/286), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(5/286)/2, 0, 3/(2*sqrt(286)), 0, -sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(286)), 0, sqrt(5/286)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -3/(2*sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/143), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/143),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -3/(2*sqrt(286)), 0, sqrt(3/143)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(286)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(286)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (0, 6, 6): np.array([
        1/sqrt(13), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(13), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(13), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(13), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(13), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(13), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(13), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(13), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(13), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(13), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(13), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(13), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(13),
    ]),
    # split

    (1, 5, 6): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(429), 0, -(1/sqrt(26)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*1/sqrt(143), 0, -1/2*sqrt(5/39), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(286)), 0, -1/2*sqrt(15/143), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(5/858), 0, -sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/286), 0,
        -sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/286), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/143), 0, sqrt(5/858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(15/143)/2, 0, 1/sqrt(286), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/39)/2, 0,
        1/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(26), 0, 1/(2*sqrt(429)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(78), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(286), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 4/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(35/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/143), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 4/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(286), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(78), 0, 1/sqrt(26), 0, -1/2*1/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/39)/2, 0, -1/2*1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/143)/2, 0, -(1/sqrt(286)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/143), 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/286), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/286), 0, sqrt(7/429), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(5/858), 0, sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(286)), 0,
        sqrt(15/143)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(143), 0, sqrt(5/39)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*1/sqrt(429), 0, 1/sqrt(26),
    ]),
    # split

    (1, 6, 6): np.array([
        0, 1/sqrt(182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(182)), 0, sqrt(11/273)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/273), 0, sqrt(5/91)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(5/91), 0, sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/182), 0, sqrt(5/273), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/273), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(26)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(26), 0, -sqrt(5/273),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/273), 0, -sqrt(3/182), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/182), 0, -1/2*sqrt(5/91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/91)/2,
        0, -1/2*sqrt(11/273), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/273)/2, 0, -(1/sqrt(182)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/sqrt(182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(6/91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/sqrt(546), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2*sqrt(2/273), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/182), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/273), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(546), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(546)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/273), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2*sqrt(2/273), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/sqrt(546), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(6/91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(182)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(11/273), 0, -(1/sqrt(182)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/91), 0, -1/2*sqrt(11/273), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(3/182), 0, -1/2*sqrt(5/91), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/273), 0, -sqrt(3/182),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(26)), 0, -sqrt(5/273), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(26), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/273), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/182), 0, sqrt(5/273), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/91)/2, 0, sqrt(3/182),
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/273)/2, 0, sqrt(5/91)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(182), 0, sqrt(11/273)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(182), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (2, 4, 6): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(1430)), 0, 0, 0, -(1/sqrt(26)), 0, 0, 0, 0, 0, 0, 0,
        1/(3*sqrt(286)), 0, 0, 0, -(1/sqrt(39)), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(429), 0, 0, 0, -sqrt(7/429), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/3*sqrt(7/286), 0, -sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, sqrt(14/143)/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/715), 0, -1/3*sqrt(7/286), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(39), 0, 0, 0, -1/3*1/sqrt(286), 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(26), 0, 0, 0, -1/3*1/sqrt(1430), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -(1/sqrt(1430)), 0, -(1/sqrt(78)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/(3*sqrt(715)), 0,
        -2*sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(7/143), 0, -sqrt(14/715), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2*sqrt(2/429), 0, (-4*sqrt(7/715))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/143)/3, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (4*sqrt(7/715))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/715), 0,
        sqrt(7/143)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/429), 0, 4/(3*sqrt(715)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(78), 0, 1/sqrt(1430), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/715), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 2*sqrt(14/2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/143), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(14/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(14/2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/715), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, 0, 0, 1/sqrt(78), 0, -(1/sqrt(1430)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(2/429), 0, -4/(3*sqrt(715)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(14/715), 0, -1/3*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (4*sqrt(7/715))/3, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/143)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2*sqrt(2/429), 0, (4*sqrt(7/715))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(7/143), 0, sqrt(14/715), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/(3*sqrt(715)), 0, 2*sqrt(2/429), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -(1/sqrt(1430)), 0, 1/sqrt(78), 0, 1/sqrt(26), 0, 0, 0, 1/(3*sqrt(1430)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(39), 0, 0, 0, 1/(3*sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/429), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/715), 0, sqrt(7/286)/3, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/143)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/3*sqrt(7/286), 0, sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(429), 0, 0, 0, sqrt(7/429), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/(3*sqrt(286)), 0, 0, 0, 1/sqrt(39), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/(3*sqrt(1430)), 0, 0, 0, 1/sqrt(26),
    ]),
    # split

    (2, 5, 6): np.array([
        0, 0, 0, 1/sqrt(2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(91), 0, 0, 0, 3/sqrt(5005), 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(3/182), 0, 0, 0, 2/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 3*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/715), 0, sqrt(3/286), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(143), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(3/286), 0, 2*sqrt(3/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, 0,
        0, 3*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(1001), 0, 0, 0, sqrt(3/182), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 3/sqrt(5005), 0, 0, 0, 1/sqrt(91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(2002),
        0, 0, 0, -sqrt(5/182), 0, -1/2*sqrt(15/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/91), 0, -1/2*sqrt(13/385),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/1001), 0, -sqrt(11/910), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/5005), 0, -3*sqrt(3/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/715),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(7/286), 0, sqrt(3/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -3*sqrt(3/2002), 0, sqrt(3/5005), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/910), 0, -1/2*sqrt(3/1001), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/385), 0, -1/2*sqrt(3/91), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(15/1001), 0, -sqrt(5/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/182), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -9*sqrt(3/10010), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -8/sqrt(5005), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 8/sqrt(5005), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9*sqrt(3/10010), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 4*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/182), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/1001)/2,
        0, -sqrt(5/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/385)/2, 0, -1/2*sqrt(3/91), 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(11/910), 0, -1/2*sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/2002), 0, sqrt(3/5005), 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/286), 0, sqrt(3/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/286),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/715), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(3/5005), 0, -3*sqrt(3/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/1001)/2, 0, -sqrt(11/910), 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(3/91)/2, 0, -1/2*sqrt(13/385), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/182),
        0, -1/2*sqrt(15/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(2002)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(5005), 0, 0, 0, 1/sqrt(91), 0, 0,
        0, 0, 0, 0, 0, -2/sqrt(1001), 0, 0, 0, sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, 0,
        0, 3*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/286), 0, 2*sqrt(3/715), 0, 0, 0, 0, 0, 0,
        0, -2/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(3/715), 0, sqrt(3/286), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/182), 0, 0,
        0, 2/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(91)), 0, 0, 0, 3/sqrt(5005), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/sqrt(2002), 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (2, 6, 6): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(455)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(182)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(1001), 0, 0, 0, 1/sqrt(455), 0,
        0, 0, 0, 0, 0, 0, -2*sqrt(3/1001), 0, 0, 0, 1/sqrt(182), 0, 0, 0, 0, 0, 0, 0, -2/sqrt(143), 0,
        0, 0, 3/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/1430), 0, 2*sqrt(3/1001), 0, 0, 0, 0, 0,
        0, 0, -2/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(3/1001), 0, sqrt(21/1430), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(182)), 0,
        0, 0, 2*sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(455)), 0, 0, 0, 3/sqrt(1001), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(455), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(11/910), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/455))/2, 0, -sqrt(11/910), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/143)/2, 0, (-3*sqrt(3/455))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/2002), 0, -1/2*sqrt(7/143), 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/1001), 0, -sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(1430), 0, -sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(1430), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/2002), 0, -sqrt(3/1001), 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/2, 0, -sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(3/455))/2, 0, -1/2*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/910), 0, (-3*sqrt(3/455))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(11/910), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(22/455), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/910), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(2/5005), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/1001), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/770), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(14/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/770), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/5005), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/910), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(22/455), 0, sqrt(11/910), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(11/910), 0, (3*sqrt(3/455))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/455))/2, 0, sqrt(7/143)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/2, 0, sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(15/2002), 0, sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/1001), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(1430), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(1430), 0, sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/1001), 0,
        sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/2002), 0, sqrt(7/143)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(7/143)/2, 0, (3*sqrt(3/455))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(3/455))/2, 0, sqrt(11/910), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/910), 0, 0, 0, -(1/sqrt(455)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(182)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(455)), 0, 0, 0, -3/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(182)), 0, 0, 0,
        -2*sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -2*sqrt(3/1001), 0, -sqrt(21/1430), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/1430), 0, -2*sqrt(3/1001), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -2/sqrt(143), 0, 0, 0, -3/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -2*sqrt(3/1001), 0, 0, 0, -(1/sqrt(182)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(1001), 0, 0, 0, -(1/sqrt(455)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(182)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(455)), 0, 0,
    ]),
    # split

    (3, 3, 6): np.array([
        0, 0, 0, 0, 0, 0, -1/2*1/sqrt(3003), 0, 0, 0, 0, 0, -(1/sqrt(26)), 0, 0, 0, 0, 0, 0, 0,
        1/(2*sqrt(858)), 0, 0, 0, -1/2*1/sqrt(13), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(858)), 0, -1/2*sqrt(5/143), 0, 0, 0,
        0, 0, 1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/143)/2, 0, -(1/sqrt(858)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/(2*sqrt(13)), 0, 0, 0, 1/(2*sqrt(858)), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(26), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(858)), 0,
        0, 0, -1/2*1/sqrt(13), 0, 0, 0, 0, 0, 0, 0, sqrt(3/1001), 0, 0, 0, -sqrt(3/143), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(5/286), 0, -3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 3/(2*sqrt(143)), 0, -1/2*sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/143), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(13)), 0, 0, 0, -1/2*1/sqrt(858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(858)), 0, -1/2*sqrt(5/143), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(5/286), 0, -3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(3/1001))/2, 0, -sqrt(5/286), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 5/sqrt(858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(143)), 0, sqrt(5/286)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(5/143)/2, 0, 1/sqrt(858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 5/sqrt(858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10/sqrt(3003), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/sqrt(858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(143), 0, 0, 0, 0, 0, sqrt(5/143)/2, 0, -(1/sqrt(858)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3/(2*sqrt(143)), 0, -1/2*sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/286), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/sqrt(858), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-5*sqrt(3/1001))/2, 0, sqrt(5/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/286), 0, 3/(2*sqrt(143)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(858)), 0, sqrt(5/143)/2, 0, 0, 0, 1/(2*sqrt(13)), 0, 0, 0,
        1/(2*sqrt(858)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3/(2*sqrt(143)), 0, sqrt(5/286)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/286), 0, 3/(2*sqrt(143)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(3/1001), 0, 0, 0, sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/(2*sqrt(858)), 0, 0, 0, 1/(2*sqrt(13)), 0, 1/sqrt(26), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/(2*sqrt(13)), 0, 0, 0, -1/2*1/sqrt(858), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/143)/2, 0, 1/sqrt(858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -(1/sqrt(858)), 0, sqrt(5/143)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(858)), 0,
        0, 0, 1/(2*sqrt(13)), 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(3003), 0, 0, 0, 0, 0, 1/sqrt(26),
    ]),
    # split

    (3, 4, 6): np.array([
        0, 0, 0, 0, 0, 1/sqrt(6006), 0, 0, 0, 0, 0, 0, 0, -sqrt(3/182), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(13), 0, 0, 0, sqrt(3/286)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -3/(2*sqrt(143)), 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, -3/(2*sqrt(143)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(3/286), 0, 0, 0, -1/2*1/sqrt(13), 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(143)), 0, 0,
        0, 0, 0, -sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(6006), 0, 0, 0, 0, 0, sqrt(2/91), 0, 0,
        0, -1/3*sqrt(10/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(273)), 0, 0, 0, -17/(6*sqrt(2002)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(429)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/143),
        0, -1/6*sqrt(11/26), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-4*sqrt(2/143))/3, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/26)/6, 0, -1/2*sqrt(5/143), 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(7/429), 0, 0, 0, -(1/sqrt(429)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -17/(6*sqrt(2002)), 0, 0, 0, 1/(2*sqrt(273)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(10/1001), 0, 0, 0, sqrt(2/91), 0, sqrt(5/273), 0, 2/sqrt(1001), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/3003))/2, 0, sqrt(13/154)/3, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/(2*sqrt(143)), 0, (5*sqrt(5/286))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(286), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(3*sqrt(286)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(35/429)/2, 0, -1/3*1/sqrt(286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/286))/6,
        0, 1/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/154)/3, 0, (5*sqrt(5/3003))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 2/sqrt(1001), 0, sqrt(5/273), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 2*sqrt(5/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/1001), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2*sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/858), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(2/429), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3*sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(5/1001), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(1001), 0, sqrt(5/273),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(13/154), 0, (5*sqrt(5/3003))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-5*sqrt(5/286))/6, 0, 1/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(35/429), 0, -1/3*1/sqrt(286), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 5/(3*sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(286)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(143), 0, (5*sqrt(5/286))/6, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-5*sqrt(5/3003))/2, 0, sqrt(13/154)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/273), 0, 2/sqrt(1001), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/1001)/3, 0, 0, 0, sqrt(2/91), 0, 0,
        0, 0, 0, 0, 0, 17/(6*sqrt(2002)), 0, 0, 0, 1/(2*sqrt(273)), 0, 0, 0, 0, 0, 0, 0, sqrt(7/429), 0, 0,
        0, -(1/sqrt(429)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(11/26), 0, -1/2*sqrt(5/143), 0, 0, 0, 0, 0, 0,
        0, (4*sqrt(2/143))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/143)/2, 0, -1/6*sqrt(11/26), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(273), 0, 0,
        0, -17/(6*sqrt(2002)), 0, 0, 0, 0, 0, 0, 0, -sqrt(2/91), 0, 0, 0, -1/3*sqrt(10/1001), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(6006)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*1/sqrt(143), 0, 0, 0, 0, 0, -sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, sqrt(3/286)/2, 0, 0, 0, -1/2*1/sqrt(13),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/858), 0, -3/(2*sqrt(143)), 0, 0, 0, 0, 0, sqrt(3/143), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(143)), 0, -sqrt(5/858), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/(2*sqrt(13)), 0, 0, 0, sqrt(3/286)/2, 0, 0, 0, 0, 0, 0, 0, sqrt(3/182), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(6006), 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (3, 5, 6): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0, 0, 1/sqrt(182), 0,
        0, 0, 0, 0, 0, 0, -sqrt(7/858), 0, 0, 0, 1/sqrt(91), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/429), 0, sqrt(2/143), 0, 0, 0, 0, 0, -2/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(2/143), 0, sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(91)), 0, 0, 0, -sqrt(7/858), 0, 0, 0,
        0, 0, 0, 0, -(1/sqrt(182)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(2002)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(15/2002), 0, 0, 0, -sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, -4*sqrt(2/3003), 0, 0, 0,
        -(1/sqrt(91)), 0, 0, 0, 0, 0, 0, 0, -sqrt(3/143), 0, 0, 0, -sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/429), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/1001), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(91), 0, 0, 0, 4*sqrt(2/3003), 0, 0, 0, 0, 0, 0, 0,
        sqrt(3/182), 0, 0, 0, sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/1001), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1001), 0, sqrt(3/182), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/858), 0, -sqrt(5/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/2002), 0, -3/sqrt(1001), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -(1/sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/429), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3/sqrt(1001), 0, -sqrt(5/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/1001), 0, -sqrt(7/858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -2*sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/182), 0, -3/sqrt(1001), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/91), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(15/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(1001)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/3003), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/3003), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(1001)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/1001), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/91), 0, -sqrt(3/182), 0, 3/sqrt(1001), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/1001), 0, sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1001), 0, sqrt(5/2002), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/2002), 0, 3/sqrt(1001), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/858), 0, sqrt(5/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/1001), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1001), 0, -sqrt(3/182), 0, 0, 0, -sqrt(3/1001), 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/182), 0, 0, 0, -sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(91), 0, 0, 0, -4*sqrt(2/3003), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/1001), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(143)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/143), 0, 0, 0, sqrt(3/1001), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -4*sqrt(2/3003), 0, 0, 0, 1/sqrt(91), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(15/2002), 0, 0, 0, sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/1001), 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/1001), 0, 0, 0,
        0, 0, 0, 0, -(1/sqrt(182)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(91)), 0,
        0, 0, sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, -sqrt(5/429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(143), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/429), 0, -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/858), 0, 0, 0,
        -(1/sqrt(91)), 0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0, 0, -(1/sqrt(182)), 0, 0, 0, 0, 0,
        0, 0, sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(2002), 0, 0, 0,
        0,
    ]),
    # split

    (3, 6, 6): np.array([
        0, 0, 0, 1/(2*sqrt(182)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/182)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(182),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/182), 0, 0, 0, sqrt(7/143)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(15/2002), 0, -1/2*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/2,
        0, -sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/143), 0, 0, 0, -1/2*sqrt(3/182), 0, 0, 0, 0,
        0, 0, 0, sqrt(3/143), 0, 0, 0, 0, 0, -1/2*1/sqrt(182), 0, 0, 0, 0, 0, 0, 0, sqrt(15/2002), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/182)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(2*sqrt(182)), 0, 0, 0, 0, 0, -1/2*sqrt(5/182), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(91)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/182)/2, 0, 0, 0, -9/(2*sqrt(2002)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(91), 0, 0, 0, -sqrt(6/1001), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 9/(2*sqrt(2002)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/1001), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(286), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(286)),
        0, 0, 0, 9/(2*sqrt(2002)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/1001), 0, 0, 0, 1/sqrt(91), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -9/(2*sqrt(2002)), 0, 0, 0, sqrt(5/182)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(91)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/182), 0, 0, 0, sqrt(11/182)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/182), 0, sqrt(3/91)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(3/91), 0, sqrt(5/1001)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/1001),
        0, -1/2*sqrt(3/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/2002)/2, 0, -1/2*sqrt(15/1001), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(15/1001)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143), 0, sqrt(15/1001)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/1001), 0, sqrt(3/2002)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(3/2002), 0, -1/2*sqrt(5/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/1001)/2, 0, -1/2*sqrt(3/91),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/91)/2, 0, -1/2*sqrt(11/182), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/182)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/91)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -3/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(1001), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(1001),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 2/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 4/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1001),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(11/91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/91),
        0, -1/2*sqrt(11/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/1001), 0, -1/2*sqrt(3/91), 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(3/2002)/2, 0, -1/2*sqrt(5/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/1001)/2, 0, sqrt(3/2002)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, sqrt(15/1001)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/143),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/1001), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(3/2002), 0, -1/2*sqrt(15/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/1001)/2, 0, -1/2*sqrt(3/2002), 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(3/91)/2, 0, sqrt(5/1001)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/182)/2,
        0, sqrt(3/91)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/182)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/182)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/sqrt(91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/(2*sqrt(2002)),
        0, 0, 0, sqrt(5/182)/2, 0, 0, 0, 0, 0, 0, 0, sqrt(6/1001), 0, 0, 0, 1/sqrt(91), 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(286), 0, 0, 0, 9/(2*sqrt(2002)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/1001),
        0, 0, 0, 0, 0, 0, 0, -(1/sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/1001),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9/(2*sqrt(2002)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -(1/sqrt(91)), 0, 0, 0, -sqrt(6/1001), 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/182), 0, 0, 0, -9/(2*sqrt(2002)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(91)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(5/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*1/sqrt(182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/182), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/143),
        0, 0, 0, 0, 0, -1/2*1/sqrt(182), 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/2, 0, 0, 0, -1/2*sqrt(3/182), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/143), 0, -sqrt(15/2002), 0, 0, 0, 0, 0, sqrt(3/143), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(15/2002), 0, -1/2*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/182)/2,
        0, 0, 0, sqrt(7/143)/2, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(182)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(3/182)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(182)), 0, 0, 0, 0, 0, 0,
        0, 0, 0,
    ]),
    # split

    (4, 4, 6): np.array([
        0, 0, 0, 0, 0, 0, -2/(3*sqrt(715)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/4290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/429), 0, 0, 0, sqrt(2/195), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0, 1/sqrt(65), 0, 0, 0, -2/sqrt(143), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -(1/sqrt(65)), 0, 2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/195), 0,
        0, 0, -sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/4290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/4290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17/(6*sqrt(715)), 0, 0, 0,
        0, 0, -sqrt(7/390), 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/330), 0, 0, 0, -1/2*1/sqrt(65), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(3/286), 0, 1/(2*sqrt(715)), 0, 0, 0, 0, 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*1/sqrt(715), 0, sqrt(3/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(65)), 0, 0, 0,
        -1/2*sqrt(13/330), 0, 0, 0, 0, 0, 0, 0, sqrt(7/390), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(7/4290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(2/429), 0, 0, 0, sqrt(2/195), 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/330), 0, 0, 0, -1/2*1/sqrt(65), 0,
        0, 0, 0, 0, 0, 0, -1/3*sqrt(11/65), 0, 0, 0, -sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(21/1430)/2, 0, -1/2*sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(7/429)/2, 0, sqrt(21/1430)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/715), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/(2*sqrt(65)), 0, 0, 0, sqrt(13/330)/2, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/195), 0,
        0, 0, sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2/sqrt(429), 0, 1/sqrt(65), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/286), 0, 1/(2*sqrt(715)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(21/1430)/2, 0, -1/2*sqrt(7/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*1/sqrt(715), 0, -sqrt(7/858), 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/429)/2, 0, -1/2*sqrt(21/1430), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*1/sqrt(715), 0, -sqrt(3/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(65)), 0, -2/sqrt(429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (2*sqrt(5/143))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2/sqrt(143), 0, 0, 0, -(1/sqrt(65)), 0, 2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*1/sqrt(715), 0, sqrt(3/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/429)/2, 0, sqrt(21/1430)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*1/sqrt(715), 0, sqrt(7/858), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/1430)/2, 0, sqrt(7/429)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(3/286), 0, -1/2*1/sqrt(715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0,
        -(1/sqrt(65)), 0, -sqrt(2/195), 0, 0, 0, -sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(65)), 0, 0, 0,
        -1/2*sqrt(13/330), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/429)/2, 0, -1/2*sqrt(21/1430), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/1430)/2, 0, sqrt(7/429)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/3*sqrt(11/65), 0, 0, 0, sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(13/330), 0, 0, 0, 1/(2*sqrt(65)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/429), 0, 0, 0, -sqrt(2/195), 0,
        0, 0, 0, 0, sqrt(7/4290), 0, 0, 0, 0, 0, 0, 0, sqrt(7/390), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/(2*sqrt(65)), 0, 0, 0, sqrt(13/330)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*1/sqrt(715), 0, -sqrt(3/286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/286), 0, -1/2*1/sqrt(715), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(13/330), 0, 0, 0, 1/(2*sqrt(65)), 0, 0, 0, 0, 0, 0, 0, 17/(6*sqrt(715)), 0, 0, 0,
        0, 0, sqrt(7/390), 0, 0, 0, 0, 0, 0, 0, sqrt(7/4290), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/4290), 0, 0, 0, 0, 0,
        0, 0, -sqrt(2/195), 0, 0, 0, sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(65)), 0, -2/sqrt(429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(143), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(429), 0, -(1/sqrt(65)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(2/429), 0, 0, 0, -sqrt(2/195), 0, 0, 0, 0, 0, 0, 0, sqrt(7/4290), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -2/(3*sqrt(715)), 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (4, 5, 6): np.array([
        0, 0, 0, 0, 0, 1/(2*sqrt(429)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(2145)), 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(65)),
        0, 0, 0, -7/(6*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/195)/2, 0, sqrt(7/143)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/286), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/143), 0, sqrt(7/195)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(6*sqrt(143)),
        0, 0, 0, 1/(2*sqrt(65)), 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(2145)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/1430), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(429)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -4/sqrt(2145), 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/65), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(2/195), 0, 0, 0, -7/(3*sqrt(715)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/2145), 0, sqrt(7/286)/3,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(7/286), 0, -sqrt(7/2145), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 7/(3*sqrt(715)), 0, 0, 0, -sqrt(2/195), 0, 0, 0, 0, 0, 0, 0, -sqrt(14/715), 0, 0, 0, 0, 0, -1/2*sqrt(3/65),
        0, 0, 0, 0, 0, 0, 0, -4/sqrt(2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/455))/2,
        0, 0, 0, sqrt(11/273)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(910), 0, 0, 0, 3*sqrt(3/5005), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -4*sqrt(2/15015), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(143)), 0, (-2*sqrt(2/715))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/429),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (2*sqrt(2/715))/3, 0, -(1/sqrt(143)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(2/2145), 0, 0, 0, -4*sqrt(2/15015), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/5005), 0, 0,
        0, 1/sqrt(910), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/273)/2, 0, 0, 0, (3*sqrt(3/455))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(15/2002), 0, 0, 0, -1/2*sqrt(3/91), 0, -5/sqrt(2002), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(2/455), 0, -sqrt(6/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/sqrt(10010), 0, -1/2*1/sqrt(3003),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/1001), 0, sqrt(11/455)/3, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/3*1/sqrt(286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(7/2145), 0, -1/3*1/sqrt(286), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(11/455)/3, 0, sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*1/sqrt(3003), 0, 9/sqrt(10010), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/1001), 0, sqrt(2/455), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -5/sqrt(2002), 0, -1/2*sqrt(3/91), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(5/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(2002)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/1001))/3,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (2*sqrt(2/143))/3, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-2*sqrt(2/143))/3, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-5*sqrt(5/1001))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/2002),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(2002), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(5/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 5/sqrt(2002), 0, -1/2*sqrt(3/91), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/1001), 0, sqrt(2/455),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(3003)), 0, 9/sqrt(10010), 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/3*sqrt(11/455), 0, sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/2145), 0, -1/3*1/sqrt(286), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(286)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/1001), 0, sqrt(11/455)/3, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -9/sqrt(10010), 0, -1/2*1/sqrt(3003), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/455), 0, -sqrt(6/1001), 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/91)/2, 0, -5/sqrt(2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/273),
        0, 0, 0, (3*sqrt(3/455))/2, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/5005), 0, 0, 0, 1/sqrt(910), 0, 0, 0, 0,
        0, 0, 0, -sqrt(2/2145), 0, 0, 0, -4*sqrt(2/15015), 0, 0, 0, 0, 0, 0, 0, 0, 0, (-2*sqrt(2/715))/3, 0, -(1/sqrt(143)),
        0, 0, 0, 0, 0, 0, 0, sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143),
        0, (-2*sqrt(2/715))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(2/15015), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -(1/sqrt(910)), 0, 0, 0, 3*sqrt(3/5005), 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/455))/2, 0, 0, 0, sqrt(11/273)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/2002), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/429)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 4/sqrt(2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/715), 0, 0, 0, 0, 0, -1/2*sqrt(3/65),
        0, 0, 0, 0, 0, 0, 0, -7/(3*sqrt(715)), 0, 0, 0, -sqrt(2/195), 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(7/286)/3, 0, -sqrt(7/2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(7/2145), 0, sqrt(7/286)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/195), 0, 0, 0, -7/(3*sqrt(715)), 0, 0,
        0, 0, 0, 0, 0, sqrt(3/65)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -4/sqrt(2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/1430), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(2145)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(6*sqrt(143)), 0, 0, 0, 1/(2*sqrt(65)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(7/143)/2, 0, sqrt(7/195)/2, 0, 0, 0, -sqrt(7/286), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(7/195), 0, sqrt(7/143)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(65), 0, 0, 0, -7/(6*sqrt(143)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(2145)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(429)),
        0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (4, 6, 6): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/1326), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -7/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (7*sqrt(5/2431))/3, 0, 0, 0, -1/2*1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(4862), 0, -sqrt(5/1326), 0, 0, 0,
        sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/1326), 0, -7/sqrt(4862), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, (7*sqrt(5/2431))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -7/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/1326), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(442)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(1326)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -5*sqrt(5/14586), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/2431), 0, 0, 0, 0, 0,
        3/(2*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 7/(6*sqrt(2431)), 0, 0, 0, 7/(2*sqrt(1326)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 7/(6*sqrt(2431)), 0, 5*sqrt(5/14586), 0, 0, 0, 0, 0, -sqrt(21/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -5*sqrt(5/14586), 0, 7/(6*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(1326)), 0, 0, 0, 7/(6*sqrt(2431)), 0,
        0, 0, 0, 0, 0, 0, -3/(2*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 5*sqrt(5/14586), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(1326)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(15/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(3/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23/(2*sqrt(102102)), 0, 0, 0, (-3*sqrt(15/3094))/2, 0, 0, 0,
        0, 0, 0, 0, -2*sqrt(2/17017), 0, 0, 0, -2*sqrt(3/1547), 0, 0, 0, 0, 0, 0, 0, -sqrt(11/1326), 0, 0, 0,
        -23/(2*sqrt(102102)), 0, 0, 0, 0, 0, 0, 0, 0, 0, (2*sqrt(35/2431))/3, 0, 2*sqrt(2/17017), 0, 0, 0, 0, 0, 0, 0,
        -sqrt(11/1326), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(2/17017), 0, (2*sqrt(35/2431))/3, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 23/(2*sqrt(102102)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/1547), 0, 0, 0,
        2*sqrt(2/17017), 0, 0, 0, 0, 0, 0, 0, (3*sqrt(15/3094))/2, 0, 0, 0, -23/(2*sqrt(102102)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -2*sqrt(3/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(15/3094))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(165/3094), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/1547), 0, sqrt(165/3094)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(21/2431)/2, 0, sqrt(5/1547)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/2618)/2, 0, -1/2*sqrt(21/2431), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 53/(6*sqrt(17017)), 0, -1/2*sqrt(65/2618), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/7293), 0,
        -53/(6*sqrt(17017)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 53/(6*sqrt(17017)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/2618)/2, 0, -53/(6*sqrt(17017)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(21/2431)/2, 0, -1/2*sqrt(65/2618), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/1547), 0,
        -1/2*sqrt(21/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(165/3094), 0, sqrt(5/1547)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(165/3094)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(11/1547))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -16/sqrt(17017), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9/sqrt(17017), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1547)/6, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 32/(3*sqrt(17017)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(7/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32/(3*sqrt(17017)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1547)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -9/sqrt(17017), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -16/sqrt(17017), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (3*sqrt(11/1547))/2, 0, -1/2*sqrt(165/3094), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(165/3094), 0,
        -1/2*sqrt(5/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/1547), 0, sqrt(21/2431)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(21/2431)/2, 0, sqrt(65/2618)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(65/2618)/2, 0, 53/(6*sqrt(17017)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53/(6*sqrt(17017)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(10/7293), 0, 53/(6*sqrt(17017)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53/(6*sqrt(17017)), 0, sqrt(65/2618)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/2618)/2, 0, sqrt(21/2431)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(21/2431)/2, 0, -1/2*sqrt(5/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/1547), 0,
        -1/2*sqrt(165/3094), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(165/3094), 0, 0, 0, (3*sqrt(15/3094))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(15/3094))/2, 0, 0, 0, 23/(2*sqrt(102102)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/1547), 0, 0, 0, -2*sqrt(2/17017), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 23/(2*sqrt(102102)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2*sqrt(2/17017), 0, (-2*sqrt(35/2431))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(11/1326), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (2*sqrt(35/2431))/3, 0, -2*sqrt(2/17017), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(11/1326), 0, 0, 0, 23/(2*sqrt(102102)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(2/17017), 0,
        0, 0, 2*sqrt(3/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 23/(2*sqrt(102102)), 0, 0, 0, (3*sqrt(15/3094))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(3/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(15/3094))/2, 0, 0, 0, 0, 0, -3/(2*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -7/(2*sqrt(1326)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/14586), 0, 0, 0, 0, 0,
        0, 0, -3/(2*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(1326)), 0, 0, 0,
        -7/(6*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/14586), 0, -7/(6*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 7/(6*sqrt(2431)), 0, -5*sqrt(5/14586), 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(6*sqrt(2431)), 0, 0, 0, -7/(2*sqrt(1326)), 0,
        0, 0, 0, 0, 0, 0, -sqrt(21/2431), 0, 0, 0, 0, 0, -3/(2*sqrt(442)), 0, 0, 0, 0, 0, 0, 0,
        -5*sqrt(5/14586), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(1326)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/1326), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(4862), 0, 0, 0,
        0, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, (-7*sqrt(5/2431))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/1326), 0,
        7/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(4862), 0, sqrt(5/1326), 0, 0, 0, 0, 0,
        0, 0, 0, 0, (7*sqrt(5/2431))/3, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, 0, 0, 0, 0, -7/sqrt(4862), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(5/1326), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0,
        0,
    ]),
    # split

    (5, 5, 6): np.array([
        0, 0, 0, 0, 0, 0, -1/2*sqrt(15/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(7/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4862), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(105/2431)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -15/(2*sqrt(4862)), 0, -1/2*sqrt(3/221), 0, sqrt(15/221)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/221)/2, 0,
        -15/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(105/2431)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (3*sqrt(7/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(7/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 8*sqrt(3/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/2210), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/4862), 0, 0, 0, sqrt(21/2210), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(3/4862), 0, 9/(2*sqrt(2210)), 0, 0, 0, -2*sqrt(3/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -9/(2*sqrt(2210)), 0, -1/2*sqrt(3/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/2210), 0, 0, 0, sqrt(21/4862), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/2210), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(7/4862))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4862), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(77/2210), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -29/(2*sqrt(36465)), 0,
        0, 0, 0, 0, -sqrt(14/1105), 0, 0, 0, 0, 0, 0, 0, -sqrt(7/72930), 0, 0, 0, -1/2*sqrt(7/1105), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(11/663)/2, 0, sqrt(13/1870)/2, 0, 0, 0, 0, 0, (-5*sqrt(5/2431))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(13/1870), 0, sqrt(11/663)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1105)/2, 0,
        0, 0, -sqrt(7/72930), 0, 0, 0, 0, 0, 0, 0, sqrt(14/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/2210)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(35/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(105/2431)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/4862), 0, 0, 0, sqrt(21/2210), 0, 0, 0, 0, 0,
        0, 0, -sqrt(7/72930), 0, 0, 0, -1/2*sqrt(7/1105), 0, 0, 0, 0, 0, 0, 0, -6*sqrt(3/12155), 0, 0, 0, -2*sqrt(21/12155), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 8/sqrt(12155), 0, -3/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, -sqrt(10/7293), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(4862), 0, 8/sqrt(12155), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(21/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1105)/2, 0, 0, 0, sqrt(7/72930), 0,
        0, 0, 0, 0, 0, 0, -sqrt(21/2210), 0, 0, 0, -sqrt(21/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(105/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -15/(2*sqrt(4862)), 0, -1/2*sqrt(3/221), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/4862), 0, 9/(2*sqrt(2210)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(11/663)/2, 0, sqrt(13/1870)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8/sqrt(12155), 0,
        -3/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/12155), 0, -sqrt(14/2431), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(7/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/2431), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 3/sqrt(4862), 0, -8/sqrt(12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/1870), 0,
        -1/2*sqrt(11/663), 0, 0, 0, 0, 0, 0, 0, 0, 0, -9/(2*sqrt(2210)), 0, sqrt(3/4862)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(3/221)/2, 0, 15/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/221)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(3/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-5*sqrt(5/2431))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(10/7293), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(7/7293), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 4*sqrt(5/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(7/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(10/7293), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(5/2431))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2*sqrt(3/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/221)/2, 0, sqrt(3/221)/2, 0,
        -15/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9/(2*sqrt(2210)), 0, -1/2*sqrt(3/4862), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(13/1870), 0, sqrt(11/663)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3/sqrt(4862), 0, 8/sqrt(12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/2431), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(7/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(3/12155), 0, sqrt(14/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8/sqrt(12155), 0, 3/sqrt(4862), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/663)/2, 0, -1/2*sqrt(13/1870), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(3/4862), 0, -9/(2*sqrt(2210)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -15/(2*sqrt(4862)), 0,
        sqrt(3/221)/2, 0, 0, 0, sqrt(105/2431)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/2210), 0, 0, 0, sqrt(21/4862), 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1105)/2, 0, 0, 0, -sqrt(7/72930), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(21/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(4862), 0, -8/sqrt(12155), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(10/7293), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 8/sqrt(12155), 0, 3/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, -6*sqrt(3/12155), 0,
        0, 0, 2*sqrt(21/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/72930), 0, 0, 0, sqrt(7/1105)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(21/4862), 0, 0, 0, -sqrt(21/2210), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(105/2431)/2, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(77/2210), 0, 0, 0, 0, 0, 0, 0, sqrt(14/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/1105)/2, 0, 0, 0, sqrt(7/72930), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/1870), 0,
        -1/2*sqrt(11/663), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(5/2431))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/663)/2, 0, -1/2*sqrt(13/1870), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(7/72930), 0, 0, 0, sqrt(7/1105)/2, 0, 0, 0, 0, 0, 0, 0, -29/(2*sqrt(36465)), 0, 0, 0, 0, 0,
        sqrt(14/1105), 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/2210), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(35/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(7/4862))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/2210)/2, 0,
        0, 0, 0, 0, 0, 0, -sqrt(21/2210), 0, 0, 0, -sqrt(21/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -9/(2*sqrt(2210)), 0, sqrt(3/4862)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2*sqrt(3/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/4862), 0, -9/(2*sqrt(2210)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(21/4862), 0, 0, 0, -sqrt(21/2210), 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/2210), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8*sqrt(3/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (3*sqrt(7/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(7/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(35/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(105/2431), 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(3/221)/2, 0, 15/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(15/221)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -15/(2*sqrt(4862)), 0,
        sqrt(3/221)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(105/2431)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(35/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(7/4862))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(15/2431), 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (5, 6, 6): np.array([
        0, 0, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(3/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -7/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(4862), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*1/sqrt(221), 0, (-7*sqrt(3/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (7*sqrt(3/4862))/2, 0, -1/2*1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(4862), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 7/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(3/4862))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/221)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(221)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/442)/2, 0, 7/(2*sqrt(4862)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/2431), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(4862)), 0, sqrt(15/442)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/442),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(221)), 0, 0, 0, 0, 0, 0,
        0, sqrt(2/221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/442), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/4862)/2, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/221), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/442), 0, 0, 0, -7/(2*sqrt(2431)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(15/4862), 0, 7/(2*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(21/2431)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(2431)), 0, -1/2*sqrt(15/4862),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(2431)), 0, 0, 0, -sqrt(3/442), 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(21/2431), 0, 0, 0, 0, 0, -sqrt(2/221), 0, 0, 0, 0, 0, 0, 0, sqrt(15/4862)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(2/221), 0, 0, 0, 0, 0, -sqrt(5/442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/442), 0, 0, 0, 3/sqrt(4862), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, 3*sqrt(3/4862), 0, 0, 0, 0, 0, 0, 0, 0,
        0, -3/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/4862), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(14/2431), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/2431), 0, 0,
        0, -3/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/4862), 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 3/sqrt(4862), 0, 0, 0, sqrt(5/442), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(221),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/442), 0, 0, 0, sqrt(55/1547)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/1547), 0, -1/2*sqrt(15/3094), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(15/3094)/2, 0, -29/(2*sqrt(34034)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(34034)), 0, (-3*sqrt(15/17017))/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(15/17017))/2, 0, sqrt(6/17017), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(6/17017), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2*sqrt(5/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(5/2431), 0, -sqrt(6/17017), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(6/17017), 0, (3*sqrt(15/17017))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-3*sqrt(15/17017))/2, 0, 29/(2*sqrt(34034)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -29/(2*sqrt(34034)), 0, sqrt(15/3094)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/3094), 0, -1/2*sqrt(55/1547), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(55/1547)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1547), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(11/1547))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -9/sqrt(17017), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1547)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(13/1309), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10/sqrt(17017), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -10/sqrt(17017), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/1309), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(11/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/sqrt(17017), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(11/1547))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(11/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(55/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/3094)/2, 0, -1/2*sqrt(55/1547),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(34034)), 0, sqrt(15/3094)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (3*sqrt(15/17017))/2, 0, 29/(2*sqrt(34034)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/17017), 0, (3*sqrt(15/17017))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -2*sqrt(5/2431), 0, -sqrt(6/17017), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(5/2431), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/17017), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-3*sqrt(15/17017))/2, 0, sqrt(6/17017), 0, 0, 0, 0, 0, 0, 0, 0, 0, -29/(2*sqrt(34034)), 0, (-3*sqrt(15/17017))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(15/3094), 0, -29/(2*sqrt(34034)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/1547)/2, 0, -1/2*sqrt(15/3094),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/1547)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/442), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(4862), 0, 0,
        0, sqrt(5/442), 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/4862), 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, 0, 0, 0,
        0, -sqrt(14/2431), 0, 0, 0, -3/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/4862), 0, 0,
        0, 0, 0, 0, 0, sqrt(14/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/4862), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*1/sqrt(221), 0, 0, 0, 3*sqrt(3/4862), 0, 0, 0, 0, 0, 0, 0, -sqrt(5/442), 0, 0, 0, 3/sqrt(4862), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(5/442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(2/221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/442), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(15/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/2431)/2, 0, 0,
        0, 0, 0, -sqrt(2/221), 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(2431)), 0, 0, 0, -sqrt(3/442), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 7/(2*sqrt(2431)), 0, -1/2*sqrt(15/4862), 0, 0, 0, 0, 0, -1/2*sqrt(21/2431), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(15/4862)/2, 0, 7/(2*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/442), 0, 0,
        0, -7/(2*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, sqrt(2/221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(15/4862)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/442),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/221), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(15/442)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/2431), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(4862)), 0, sqrt(15/442)/2, 0, 0,
        0, -sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/442), 0, 7/(2*sqrt(4862)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(221)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -7/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(221)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(221), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (7*sqrt(3/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(4862), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (-7*sqrt(3/4862))/2, 0, -1/2*1/sqrt(221), 0, sqrt(7/221)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/(2*sqrt(221)), 0, (-7*sqrt(3/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(4862), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (7*sqrt(3/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (6, 6, 6): np.array([
        0, 0, 0, 0, 0, 0, -sqrt(11/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(77/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(42/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/2, 0, -sqrt(11/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(42/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-3*sqrt(21/8398))/2, 0, -1/2*sqrt(77/4199), 0, (5*sqrt(11/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(77/4199)/2, 0, (-3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(21/8398))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-5*sqrt(35/92378))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(7/46189), 0,
        0, 0, sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(35/92378))/2, 0, (3*sqrt(21/8398))/2, 0, 0, 0, -4/sqrt(46189), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(21/8398))/2, 0, (-5*sqrt(35/92378))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(35/4199), 0, 0, 0, 6*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-5*sqrt(35/92378))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(42/4199), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-5*sqrt(35/92378))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -43/(2*sqrt(46189)), 0, 0, 0, 0, 0, -sqrt(42/4199), 0,
        0, 0, 0, 0, 0, 0, (3*sqrt(21/46189))/2, 0, 0, 0, -sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(21/46189))/2, 0, (5*sqrt(35/92378))/2, 0, 0, 0, 0, 0, -43/(2*sqrt(46189)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-5*sqrt(35/92378))/2, 0, (3*sqrt(21/46189))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, (3*sqrt(21/46189))/2, 0, 0, 0,
        0, 0, 0, 0, sqrt(42/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (5*sqrt(35/92378))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/8398), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(42/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(7/46189), 0, 0, 0, sqrt(35/4199), 0, 0, 0, 0, 0,
        0, 0, (3*sqrt(21/46189))/2, 0, 0, 0, -sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, -sqrt(11/4199), 0, 0, 0, -6*sqrt(7/46189), 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(210/46189), 0, (-3*sqrt(21/46189))/2, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(21/46189))/2, 0, sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 6*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, (-3*sqrt(21/46189))/2, 0,
        0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0, 0, 0, -6*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(21/8398))/2, 0, -1/2*sqrt(77/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-5*sqrt(35/92378))/2, 0, (3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(21/46189))/2, 0, (5*sqrt(35/92378))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(210/46189), 0, (-3*sqrt(21/46189))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10/sqrt(46189), 0, -sqrt(210/46189), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 10/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(21/46189))/2, 0, -sqrt(210/46189), 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-5*sqrt(35/92378))/2, 0, (-3*sqrt(21/46189))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(21/8398))/2, 0, (5*sqrt(35/92378))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/2, 0, (3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(77/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -4/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -43/(2*sqrt(46189)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 10/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20/sqrt(46189), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10/sqrt(46189), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(11/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -43/(2*sqrt(46189)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(46189), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(11/4199), 0, sqrt(77/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/2, 0, (-3*sqrt(21/8398))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(21/8398))/2, 0, (-5*sqrt(35/92378))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-5*sqrt(35/92378))/2, 0, (3*sqrt(21/46189))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(21/46189))/2, 0,
        sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 10/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        10/sqrt(46189), 0, sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(210/46189), 0, (3*sqrt(21/46189))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(21/46189))/2, 0, (-5*sqrt(35/92378))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-5*sqrt(35/92378))/2, 0, (-3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(21/8398))/2, 0, sqrt(77/4199)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/2, 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0,
        0, 0, 6*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, (3*sqrt(21/46189))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 6*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(21/46189))/2, 0, -sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(210/46189), 0, (3*sqrt(21/46189))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(11/4199), 0, 0, 0, 6*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(21/46189))/2, 0, 0, 0,
        sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(7/46189), 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0,
        0, 0, 0, 0, sqrt(42/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(35/92378))/2, 0, 0, 0, 0, 0, 0, 0,
        sqrt(42/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, (-3*sqrt(21/46189))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(35/92378))/2, 0, (-3*sqrt(21/46189))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -43/(2*sqrt(46189)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(21/46189))/2, 0, (-5*sqrt(35/92378))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(21/46189))/2, 0, 0, 0, sqrt(7/8398), 0, 0, 0,
        0, 0, 0, 0, -43/(2*sqrt(46189)), 0, 0, 0, 0, 0, sqrt(42/4199), 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(35/92378))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(42/4199), 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(35/92378))/2, 0, 0, 0, 0, 0,
        0, 0, -sqrt(35/4199), 0, 0, 0, -6*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(21/8398))/2, 0, (5*sqrt(35/92378))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(46189), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(35/92378))/2, 0, (-3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 6*sqrt(7/46189), 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(35/92378))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -4/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(77/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/8398), 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(77/4199)/2, 0, (3*sqrt(21/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-3*sqrt(21/8398))/2, 0, sqrt(77/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(21/8398))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(77/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(77/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(42/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(42/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/4199), 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (0, 7, 7): np.array([
        1/sqrt(15), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(15), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(15), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(15), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(15), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(15), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(15), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(15), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(15), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(15), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(15), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(15), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(15), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(15), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(15),
    ]),
    # split

    (1, 6, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(2730)), 0, -(1/sqrt(30)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -(1/sqrt(910)), 0, -(1/sqrt(35)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -(1/sqrt(455)), 0, -sqrt(11/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(273)), 0, -sqrt(11/546), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(182)), 0, -sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(65)), 0, -sqrt(6/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(195), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/455), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(3/182), 0, 1/sqrt(182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/546), 0,
        1/sqrt(273), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/455), 0, 1/sqrt(455), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(35), 0, 1/sqrt(910), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(30), 0, 1/sqrt(2730), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(105), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/455), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 2*sqrt(2/273), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(3/91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4/sqrt(455), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/195), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 4/sqrt(455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(3/91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(2/273), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/455), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/455), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(105), 0, 1/sqrt(30), 0, -(1/sqrt(2730)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(35), 0, -(1/sqrt(910)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(11/455), 0, -(1/sqrt(455)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/546), 0,
        -(1/sqrt(273)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/182), 0, -(1/sqrt(182)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/455), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(195), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(65)), 0, sqrt(6/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(182)), 0,
        sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(273)), 0, sqrt(11/546), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(455)), 0, sqrt(11/455), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -(1/sqrt(910)), 0, 1/sqrt(35), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(2730)), 0, 1/sqrt(30),
    ]),
    # split

    (1, 7, 7): np.array([
        0, 1/(4*sqrt(15)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(15), 0, sqrt(13/105)/4, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(13/105), 0, sqrt(3/70)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/70), 0, sqrt(11/210)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(11/210), 0, sqrt(5/21)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(5/21),
        0, 3/(4*sqrt(35)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(4*sqrt(35)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(30)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/sqrt(30), 0, -3/(4*sqrt(35)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 3/(4*sqrt(35)), 0, -1/4*sqrt(5/21), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/21)/4,
        0, -1/2*sqrt(11/210), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/210)/2, 0, -1/2*sqrt(3/70), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/70)/2, 0, -1/4*sqrt(13/105), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(13/105)/4, 0, -1/4*1/sqrt(15), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/(4*sqrt(15)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/30)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/70), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(5/42)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(2/105), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/70)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(210), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/(2*sqrt(210)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(210), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(210)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/70),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/105), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/42), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(3/70), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/30), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/4*1/sqrt(15), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(13/105), 0, -1/4*1/sqrt(15),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/70), 0, -1/4*sqrt(13/105), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(11/210), 0, -1/2*sqrt(3/70), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(5/21),
        0, -1/2*sqrt(11/210), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(4*sqrt(35)), 0, -1/4*sqrt(5/21), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -(1/sqrt(30)), 0, -3/(4*sqrt(35)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(30), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(4*sqrt(35)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/21)/4, 0, 3/(4*sqrt(35)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(11/210)/2, 0, sqrt(5/21)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/70)/2, 0, sqrt(11/210)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/105)/4, 0, sqrt(3/70)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(4*sqrt(15)), 0, sqrt(13/105)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/(4*sqrt(15)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (2, 5, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(30030), 0, 0, 0, -(1/sqrt(30)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(6006), 0, 0, 0, -(1/sqrt(42)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(2002), 0,
        0, 0, -sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(429), 0, 0, 0, -(1/sqrt(91)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(429)), 0, -(1/sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(6/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(143), 0, -(1/sqrt(429)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(3/182), 0, 0, 0, -(1/sqrt(2002)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0,
        -(1/sqrt(6006)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(30), 0, 0, 0, -(1/sqrt(30030)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(2730)), 0, -(1/sqrt(105)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(3003), 0, -2/sqrt(273), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(3/1001), 0, -sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(3003), 0,
        -4/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/429), 0, -sqrt(2/143), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 4/sqrt(715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4/sqrt(1001), 0, 4/sqrt(3003), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/182), 0, sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2/sqrt(273), 0, 2/sqrt(3003), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(105), 0, 1/sqrt(2730), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/455), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(6/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(143), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/715), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 2*sqrt(6/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3*sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(91), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/455), 0, 0, 0, 1/sqrt(105), 0, -(1/sqrt(2730)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(273), 0, -2/sqrt(3003), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/182), 0, -sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 4/sqrt(1001), 0, -4/sqrt(3003), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4/sqrt(715), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/429), 0, sqrt(2/143), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(3003), 0, 4/sqrt(1001), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(3/1001), 0, sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -2/sqrt(3003), 0, 2/sqrt(273), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(2730)), 0, 1/sqrt(105), 0,
        1/sqrt(30), 0, 0, 0, 1/sqrt(30030), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(42), 0, 0, 0,
        1/sqrt(6006), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/182), 0, 0, 0, 1/sqrt(2002), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(143), 0, 1/sqrt(429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(6/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(429)), 0,
        1/sqrt(143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(429), 0, 0, 0, 1/sqrt(91), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(2002), 0, 0, 0, sqrt(3/182), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(6006), 0, 0, 0, 1/sqrt(42), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(30030), 0, 0, 0, 1/sqrt(30),
    ]),
    # split

    (2, 6, 7): np.array([
        0, 0, 0, 1/(2*sqrt(910)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(30)), 0, 0, 0, sqrt(11/2730)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/210)/2, 0, 0, 0, sqrt(5/546)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(11/182)/2, 0, 0, 0, sqrt(3/182)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(11/182)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/91)/2,
        0, sqrt(7/195)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/130),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/195), 0, sqrt(5/91)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/sqrt(78), 0, 0, 0, sqrt(11/182)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(3/182)/2, 0, 0, 0, sqrt(11/182)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/546)/2,
        0, 0, 0, sqrt(11/210)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/2730)/2, 0, 0, 0, 1/(2*sqrt(30)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(910)), 0, 0, 0, -1/2*1/sqrt(10), 0, -3/(2*sqrt(910)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(105)), 0, -2*sqrt(2/1365), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/1365), 0, -1/2*sqrt(7/195), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(91)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(182)),
        0, -5/(2*sqrt(546)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/455), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(65), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -2/sqrt(195), 0, sqrt(2/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -5/(2*sqrt(546)), 0, 1/(2*sqrt(182)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(91)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/195), 0, -1/2*sqrt(11/1365), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(2/1365), 0, -(1/sqrt(105)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(910)), 0, -1/2*1/sqrt(10), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(3/35), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/182), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/455), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/91),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(455)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/91)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(11/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/182), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/35)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(910)), 0, -1/2*1/sqrt(10),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/1365), 0, -(1/sqrt(105)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(7/195)/2, 0, -1/2*sqrt(11/1365), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(91),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(546)), 0, 1/(2*sqrt(182)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 2/sqrt(195), 0, sqrt(2/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(65)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/455), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(182), 0, -5/(2*sqrt(546)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(91)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1365)/2, 0, -1/2*sqrt(7/195),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(105), 0, -2*sqrt(2/1365), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(2*sqrt(10)), 0, -3/(2*sqrt(910)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(910), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(11/2730), 0, 0, 0, 1/(2*sqrt(30)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/546),
        0, 0, 0, sqrt(11/210)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/182), 0, 0, 0, sqrt(11/182)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -(1/sqrt(78)), 0, 0, 0, sqrt(11/182)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/195)/2, 0, sqrt(5/91)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/130), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/91), 0, sqrt(7/195)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(11/182), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/182), 0, 0,
        0, sqrt(3/182)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/210), 0, 0, 0, sqrt(5/546)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*1/sqrt(30), 0, 0, 0, sqrt(11/2730)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/(2*sqrt(910)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (2, 7, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(170), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3/(2*sqrt(595)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(11/15470), 0, 0, 0, 1/(2*sqrt(170)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/1547), 0, 0, 0, 3/(2*sqrt(595)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(15/3094))/2, 0, 0, 0, 3*sqrt(11/15470), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(3/1105), 0, 0, 0, sqrt(55/1547)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/1105), 0,
        (3*sqrt(15/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-3*sqrt(15/3094))/2, 0, sqrt(14/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/1547), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(11/15470), 0, 0, 0, (3*sqrt(15/3094))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3/(2*sqrt(595)), 0, 0, 0, sqrt(55/1547)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*1/sqrt(170), 0, 0, 0, 3*sqrt(11/15470), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(595)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(170)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/85)/4, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11/(4*sqrt(595)), 0, -1/4*sqrt(13/85), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 27/(2*sqrt(15470)), 0, -11/(4*sqrt(595)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(77/2210)/2, 0, -27/(2*sqrt(15470)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/1547))/4, 0, -1/2*sqrt(77/2210), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (9*sqrt(3/7735))/4, 0, (-5*sqrt(5/1547))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(2210), 0, (-9*sqrt(3/7735))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(2210), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (9*sqrt(3/7735))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (5*sqrt(5/1547))/4, 0, (-9*sqrt(3/7735))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/2210)/2, 0,
        (-5*sqrt(5/1547))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27/(2*sqrt(15470)), 0, -1/2*sqrt(77/2210), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 11/(4*sqrt(595)), 0, -27/(2*sqrt(15470)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(13/85)/4, 0, -11/(4*sqrt(595)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(13/85), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(91/510), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(26/1785), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -19/(2*sqrt(46410)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/23205), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(46410)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11*sqrt(2/23205), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 53/(2*sqrt(46410)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(14/3315), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53/(2*sqrt(46410)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11*sqrt(2/23205), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(46410)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(2/23205), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -19/(2*sqrt(46410)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(26/1785), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(91/510), 0, sqrt(13/85)/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/85)/4, 0, 11/(4*sqrt(595)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 11/(4*sqrt(595)), 0, 27/(2*sqrt(15470)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 27/(2*sqrt(15470)), 0, sqrt(77/2210)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/2210)/2, 0,
        (5*sqrt(5/1547))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/1547))/4, 0, (9*sqrt(3/7735))/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (9*sqrt(3/7735))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(2210), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(2210), 0, (9*sqrt(3/7735))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (9*sqrt(3/7735))/4, 0,
        (5*sqrt(5/1547))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/1547))/4, 0, sqrt(77/2210)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/2210)/2, 0, 27/(2*sqrt(15470)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 27/(2*sqrt(15470)), 0, 11/(4*sqrt(595)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 11/(4*sqrt(595)), 0, sqrt(13/85)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/85)/4, 0,
        0, 0, -1/2*1/sqrt(170), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(595)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(170), 0, 0, 0, -3*sqrt(11/15470), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3/(2*sqrt(595)), 0, 0, 0, -1/2*sqrt(55/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(11/15470), 0, 0, 0, (-3*sqrt(15/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/1547), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(15/3094))/2, 0, -sqrt(14/1105), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/1105), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/1105), 0, (-3*sqrt(15/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(3/1105), 0, 0, 0, -1/2*sqrt(55/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(15/3094))/2, 0,
        0, 0, -3*sqrt(11/15470), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/1547), 0, 0, 0, -3/(2*sqrt(595)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(11/15470), 0, 0, 0, -1/2*1/sqrt(170), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3/(2*sqrt(595)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*1/sqrt(170), 0, 0,
    ]),
    # split

    (3, 4, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(10010), 0, 0, 0, 0, 0, -(1/sqrt(30)), 0, 0, 0, 0, 0,
        0, 0, -1/3*1/sqrt(715), 0, 0, 0, 0, 0, -sqrt(2/105), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/715)/3, 0,
        0, 0, -sqrt(2/195), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/2145), 0, -(1/sqrt(195)), 0, 0, 0,
        0, 0, 0, 0, sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(195), 0,
        -sqrt(2/2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/195), 0, 0, 0, sqrt(2/715)/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(2/105), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(30), 0, 0, 0, 0, 0, 1/(3*sqrt(10010)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(10010), 0, 0, 0, -(1/sqrt(70)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/15015), 0,
        0, 0, -2*sqrt(2/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/2145), 0, 0, 0, -(1/sqrt(65)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(2/2145), 0, -2*sqrt(2/715), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/715), 0, -2*sqrt(2/2145), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(65), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(2/455), 0, 0, 0, -2*sqrt(2/15015), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(70), 0, 0, 0,
        -(1/sqrt(10010)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -(1/sqrt(2002)), 0, -(1/sqrt(182)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/1001), 0, -(1/sqrt(91)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/429), 0, -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(7/429), 0, -sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/429), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(2/143), 0, sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(91), 0,
        sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(182), 0, 1/sqrt(2002), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(273), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 4*sqrt(2/3003), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (4*sqrt(2/143))/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/143)/3, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (4*sqrt(2/143))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 2*sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        4*sqrt(2/3003), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(273), 0, 0, 0,
        0, 0, 1/sqrt(182), 0, -(1/sqrt(2002)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(91), 0,
        -sqrt(2/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, -sqrt(2/429), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(7/429), 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/429), 0,
        sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/1001), 0, 1/sqrt(91), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(2002)), 0, 1/sqrt(182), 0, 0, 0, 1/sqrt(70), 0, 0, 0,
        1/sqrt(10010), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/455), 0, 0, 0, 2*sqrt(2/15015), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(65), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 2*sqrt(2/715), 0, 2*sqrt(2/2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(2/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(2/2145), 0,
        2*sqrt(2/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/2145), 0, 0, 0, 1/sqrt(65), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/15015), 0, 0, 0, 2*sqrt(2/455), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(10010), 0, 0, 0, 1/sqrt(70), 0, 1/sqrt(30), 0, 0, 0, 0, 0, -1/3*1/sqrt(10010), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(2/105), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(2/195), 0, 0, 0, -1/3*sqrt(2/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(195), 0,
        sqrt(2/2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(2/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/2145), 0, 1/sqrt(195), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/715)/3, 0, 0, 0, sqrt(2/195), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/3*1/sqrt(715), 0, 0, 0, 0, 0, sqrt(2/105), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(10010), 0,
        0, 0, 0, 0, 1/sqrt(30),
    ]),
    # split

    (3, 5, 7): np.array([
        0, 0, 0, 0, 0, 1/(4*sqrt(1001)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(5), 0, 0, 0, 0,
        0, (3*sqrt(3/5005))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(4*sqrt(35)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/455))/2, 0, 0, 0, sqrt(7/715)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(3/65), 0, (-3*sqrt(3/1430))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/1430))/2,
        0, -1/2*sqrt(3/65), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/715), 0, 0, 0, (-3*sqrt(3/455))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(3/1430), 0, 0, 0, 0, 0, -3/(4*sqrt(35)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, (3*sqrt(3/5005))/4, 0, 0, 0, 0, 0, -1/4*1/sqrt(5), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(4*sqrt(1001)),
        0, 0, 0, 0, 0, 1/(4*sqrt(3)), 0, 0, 0, -5/(4*sqrt(3003)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/(2*sqrt(105)), 0, 0, 0, -1/2*sqrt(11/1365), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(3/455), 0, 0,
        0, -19/(4*sqrt(5005)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/455), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(1430)), 0, -1/2*sqrt(13/330), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(13/330)/2, 0, -7/(2*sqrt(1430)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(2/2145), 0, 0,
        0, -sqrt(2/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -19/(4*sqrt(5005)), 0, 0, 0, -1/4*sqrt(3/455), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/1365), 0, 0, 0, 1/(2*sqrt(105)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -5/(4*sqrt(3003)), 0, 0, 0, 1/(4*sqrt(3)), 0, sqrt(5/21)/4, 0, sqrt(5/546)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/39)/4, 0, 17/(4*sqrt(3003)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(3/182)/2, 0, sqrt(21/143)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(1001)),
        0, sqrt(11/273)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(286), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/143), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/429), 0, -1/2*1/sqrt(286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(11/273)/2, 0, 1/(2*sqrt(1001)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/143)/4,
        0, sqrt(3/182)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 17/(4*sqrt(3003)), 0, sqrt(7/39)/4, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/546)/2, 0, sqrt(5/21)/4, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(5/91)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(2/91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/(2*sqrt(1001)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(286)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -2*sqrt(3/1001), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9/(2*sqrt(1001)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/91), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/91), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/546), 0, sqrt(5/21)/4, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -17/(4*sqrt(3003)), 0, sqrt(7/39)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(21/143),
        0, sqrt(3/182)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/273), 0, 1/(2*sqrt(1001)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(7/429), 0, -1/2*1/sqrt(286), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(5/143)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(286)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(1001), 0, sqrt(11/273)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(3/182), 0, sqrt(21/143)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(7/39), 0, 17/(4*sqrt(3003)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(5/21), 0, sqrt(5/546)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(4*sqrt(3003)), 0, 0, 0, 1/(4*sqrt(3)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1365)/2, 0, 0, 0, 1/(2*sqrt(105)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 19/(4*sqrt(5005)), 0, 0, 0, -1/4*sqrt(3/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(2/2145), 0, 0,
        0, -sqrt(2/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/330), 0, -7/(2*sqrt(1430)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(1430)),
        0, -1/2*sqrt(13/330), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/455), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(3/455)/4, 0, 0, 0, -19/(4*sqrt(5005)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*1/sqrt(105), 0, 0, 0, -1/2*sqrt(11/1365), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(3), 0, 0, 0, -5/(4*sqrt(3003)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(1001),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/5005))/4, 0, 0, 0, 0, 0, -1/4*1/sqrt(5),
        0, 0, 0, 0, 0, 0, 0, -sqrt(3/1430), 0, 0, 0, 0, 0, -3/(4*sqrt(35)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/715)/2, 0, 0, 0, (-3*sqrt(3/455))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/1430))/2,
        0, -1/2*sqrt(3/65), 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(143)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(3/65)/2, 0, (-3*sqrt(3/1430))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/455))/2, 0, 0,
        0, sqrt(7/715)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(4*sqrt(35)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(4*sqrt(5)), 0, 0, 0, 0, 0, (3*sqrt(3/5005))/4, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(4*sqrt(1001)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (3, 6, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/3094)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 5/(4*sqrt(1547)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (15*sqrt(3/17017))/4, 0,
        0, 0, 0, 0, 1/(4*sqrt(17)), 0, 0, 0, 0, 0, 0, 0, 3*sqrt(5/4862), 0, 0, 0, 0, 0, sqrt(15/119)/4, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4862), 0, 0, 0, (3*sqrt(15/3094))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (3*sqrt(21/4862))/2, 0, (5*sqrt(3/1547))/2, 0, 0, 0, 0, 0, 0, 0, -15/(2*sqrt(2431)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(3/1547))/2, 0, (3*sqrt(21/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-3*sqrt(15/3094))/2, 0, 0, 0, -sqrt(35/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(15/119), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(17), 0, 0, 0, 0, 0, (-15*sqrt(3/17017))/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(4*sqrt(1547)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(3/3094), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(11/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -19/(4*sqrt(4641)), 0, 0, 0, -1/4*sqrt(11/51), 0, 0, 0, 0, 0, 0, 0, 0, 0, -20/sqrt(51051), 0, 0, 0, -2/sqrt(357), 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(195/1309), 0, 0, 0, (-5*sqrt(5/1547))/4, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -5*sqrt(5/7293), 0, 0, 0, -1/2*sqrt(5/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/14586))/2, 0,
        5/(2*sqrt(34034)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(3/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -5/(2*sqrt(34034)), 0, (7*sqrt(7/14586))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/1547)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/1547))/4, 0, 0, 0, sqrt(195/1309)/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2/sqrt(357), 0, 0, 0, 20/sqrt(51051), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(11/51)/4, 0, 0, 0, 19/(4*sqrt(4641)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1547)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 3*sqrt(11/15470), 0, sqrt(11/170)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/3570)/2, 0, sqrt(11/1785)/4, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 191/(4*sqrt(255255)), 0, -29/(4*sqrt(23205)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 37/(4*sqrt(17017)), 0, -9/(2*sqrt(3094)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23/(2*sqrt(102102)), 0,
        -8*sqrt(2/17017), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(36465)), 0, -59/(2*sqrt(170170)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(13/935)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        59/(2*sqrt(170170)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8*sqrt(2/17017), 0, -23/(2*sqrt(102102)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 9/(2*sqrt(3094)), 0, -37/(4*sqrt(17017)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 29/(4*sqrt(23205)), 0, -191/(4*sqrt(255255)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/1785), 0, -1/2*sqrt(143/3570), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/170), 0, -3*sqrt(11/15470), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(33/1190), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(77/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(2/7735), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/17017)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 43/sqrt(170170), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(42/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43/sqrt(170170), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/4862), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/17017)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -4*sqrt(2/7735), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(77/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/1190), 0,
        -1/2*sqrt(11/170), 0, 3*sqrt(11/15470), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/1785), 0, sqrt(143/3570)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(4*sqrt(23205)), 0, 191/(4*sqrt(255255)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 9/(2*sqrt(3094)), 0, 37/(4*sqrt(17017)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 8*sqrt(2/17017), 0, 23/(2*sqrt(102102)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        59/(2*sqrt(170170)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/935)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(36465)), 0, 59/(2*sqrt(170170)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 23/(2*sqrt(102102)), 0, 8*sqrt(2/17017), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 37/(4*sqrt(17017)), 0, 9/(2*sqrt(3094)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        191/(4*sqrt(255255)), 0, 29/(4*sqrt(23205)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/3570)/2, 0, -1/4*sqrt(11/1785), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/15470), 0, -1/2*sqrt(11/170), 0, 0, 0, -1/2*sqrt(11/1547), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/51)/4, 0, 0, 0, -19/(4*sqrt(4641)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2/sqrt(357), 0, 0, 0, -20/sqrt(51051), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (5*sqrt(5/1547))/4, 0, 0, 0, -1/4*sqrt(195/1309), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/1547)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(2*sqrt(34034)), 0, (-7*sqrt(7/14586))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(3/2431), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/14586))/2, 0, -5/(2*sqrt(34034)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -5*sqrt(5/7293), 0, 0, 0, sqrt(5/1547)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(195/1309), 0,
        0, 0, (5*sqrt(5/1547))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -20/sqrt(51051), 0, 0, 0, 2/sqrt(357), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -19/(4*sqrt(4641)), 0, 0, 0, sqrt(11/51)/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(11/1547), 0, 0, 0, 0, 0, 0, 0, sqrt(3/3094)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(4*sqrt(1547)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/4*1/sqrt(17), 0, 0, 0, 0, 0, (15*sqrt(3/17017))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(15/119), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(15/3094))/2, 0, 0, 0, sqrt(35/4862), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(3/1547))/2, 0, (-3*sqrt(21/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -15/(2*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (3*sqrt(21/4862))/2, 0, (-5*sqrt(3/1547))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4862), 0,
        0, 0, (-3*sqrt(15/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(5/4862), 0, 0, 0, 0, 0, -1/4*sqrt(15/119), 0,
        0, 0, 0, 0, 0, 0, 0, 0, (15*sqrt(3/17017))/4, 0, 0, 0, 0, 0, -1/4*1/sqrt(17), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 5/(4*sqrt(1547)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(3/3094)/2, 0, 0, 0, 0,
    ]),
    # split

    (3, 7, 7): np.array([
        0, 0, 0, 1/(6*sqrt(34)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/119)/6,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/1547))/6, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/6*1/sqrt(34), 0, 0, 0, 0, 0, (5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/6*sqrt(11/119), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(11/1547))/6, 0, 0,
        0, sqrt(7/663), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(11/9282))/2, 0, -sqrt(7/663), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/sqrt(1326), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/663), 0, (-5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/663), 0, 0, 0, (-5*sqrt(11/1547))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/sqrt(1326), 0, 0,
        0, 0, 0, -1/6*sqrt(11/119), 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, -1/6*1/sqrt(34),
        0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/1547))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/119)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/(6*sqrt(34)), 0, 0, 0, 0, 0, -1/2*1/sqrt(51), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -5/(2*sqrt(714)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(51)), 0, 0, 0, -2*sqrt(11/4641),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(714)), 0, 0, 0, (-5*sqrt(11/9282))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 2*sqrt(11/4641), 0, 0, 0, -5/(2*sqrt(1547)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(1547)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(442),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(1547)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -(1/sqrt(442)), 0, 0, 0, (5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -5/(2*sqrt(1547)), 0, 0, 0, 2*sqrt(11/4641), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(11/9282))/2,
        0, 0, 0, 5/(2*sqrt(714)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(11/4641), 0, 0, 0, 1/(2*sqrt(51)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(2*sqrt(714)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(51), 0, 0, 0, sqrt(13/255)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(13/255), 0, 4/sqrt(1785), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -4/sqrt(1785), 0, 23/(2*sqrt(46410)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -23/(2*sqrt(46410)), 0, sqrt(11/46410)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/46410), 0, -sqrt(5/4641), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/4641), 0, -11/(2*sqrt(7735)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 11/(2*sqrt(7735)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 3*sqrt(3/2210), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/2210), 0, 11/(2*sqrt(7735)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/(2*sqrt(7735)), 0, sqrt(5/4641), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/4641), 0, -1/2*sqrt(11/46410), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/46410)/2, 0, -23/(2*sqrt(46410)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 23/(2*sqrt(46410)), 0, -4/sqrt(1785), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4/sqrt(1785), 0, -1/2*sqrt(13/255),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/255)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/85)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(13/595)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(35/221), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -29/(3*sqrt(7735)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -61/(6*sqrt(7735)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(7/1105))/6,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9/(2*sqrt(7735)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 9/(2*sqrt(7735)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/1105))/6, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 61/(6*sqrt(7735)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 29/(3*sqrt(7735)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/221)/6, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(13/595), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/6*sqrt(91/85), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/255), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -4/sqrt(1785), 0, -1/2*sqrt(13/255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -23/(2*sqrt(46410)), 0, -4/sqrt(1785), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/46410), 0, -23/(2*sqrt(46410)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/4641), 0, -1/2*sqrt(11/46410), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 11/(2*sqrt(7735)), 0, sqrt(5/4641), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/2210), 0, 11/(2*sqrt(7735)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/2210), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -11/(2*sqrt(7735)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/4641),
        0, -11/(2*sqrt(7735)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/46410)/2, 0, -sqrt(5/4641), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 23/(2*sqrt(46410)), 0, sqrt(11/46410)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 4/sqrt(1785), 0, 23/(2*sqrt(46410)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/255)/2, 0, 4/sqrt(1785), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/255)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(51)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(714)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2*sqrt(11/4641), 0, 0, 0, 1/(2*sqrt(51)), 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/9282))/2,
        0, 0, 0, 5/(2*sqrt(714)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(1547)), 0, 0, 0, 2*sqrt(11/4641), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/sqrt(442), 0, 0, 0, (5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 5/(2*sqrt(1547)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(442)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(2*sqrt(1547)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (-5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(11/4641), 0, 0,
        0, -5/(2*sqrt(1547)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(2*sqrt(714)), 0, 0, 0, (-5*sqrt(11/9282))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*1/sqrt(51), 0, 0, 0, -2*sqrt(11/4641), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -5/(2*sqrt(714)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(51), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/6*1/sqrt(34), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(11/119), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(11/1547))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (-5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, -1/6*1/sqrt(34), 0, 0, 0, 0, 0, 0, 0, -5/sqrt(1326), 0, 0,
        0, 0, 0, -1/6*sqrt(11/119), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/663), 0, 0, 0, (-5*sqrt(11/1547))/6, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/663), 0, (-5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, 0, 0, 5/sqrt(1326),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/9282))/2, 0, -sqrt(7/663), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/1547))/6, 0, 0, 0, sqrt(7/663), 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(11/119)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(6*sqrt(34)), 0, 0, 0, 0,
        0, (5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/1547))/6, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/119)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/(6*sqrt(34)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (4, 4, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(15)), 0, 0, 0, 0,
        0, sqrt(7/715)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(15)), 0, 0, 0, -1/2*sqrt(3/715), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(3/65)/2, 0, sqrt(5/429)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(78), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(5/429), 0, sqrt(3/65)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/715)/2,
        0, 0, 0, 1/(2*sqrt(15)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(7/715), 0, 0, 0, 0, 0, 1/(2*sqrt(15)),
        0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(1430)), 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(15), 0, 0, 0, 0,
        0, -1/6*sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/sqrt(195), 0, 0, 0, -1/3*sqrt(5/143), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(2/195), 0, 4/sqrt(2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(2145),
        0, sqrt(2/195), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/143)/3, 0, 0, 0, 1/sqrt(195), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(2/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/6*sqrt(7/715), 0, 0, 0, 0, 0, -1/2*1/sqrt(15), 0, -1/2*1/sqrt(15), 0, 0, 0, sqrt(3/715)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -(1/sqrt(195)), 0, 0, 0, sqrt(5/143)/3, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/2145),
        0, sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/429),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/715), 0, sqrt(7/2145), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (7*sqrt(2/715))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(5/143)/3, 0, 0, 0, -(1/sqrt(195)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/715)/2,
        0, 0, 0, -1/2*1/sqrt(15), 0, 0, 0, -1/2*sqrt(3/65), 0, -1/2*sqrt(5/429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(2/195), 0, -4/sqrt(2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/2145),
        0, -sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/143)/3, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-7*sqrt(2/715))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/715), 0, -sqrt(7/2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(2145),
        0, -sqrt(2/195), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/429), 0, -1/2*sqrt(3/65), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(78)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/429),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(7/143), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(7/143)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(78), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(5/429)/2, 0, -1/2*sqrt(3/65), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4/sqrt(2145),
        0, -sqrt(2/195), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/715), 0, -sqrt(7/2145), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (7*sqrt(2/715))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/3*sqrt(7/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/2145), 0, -sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(2/195), 0, -4/sqrt(2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/65)/2, 0, -1/2*sqrt(5/429),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/715),
        0, 0, 0, -1/2*1/sqrt(15), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(5/143), 0, 0, 0, -(1/sqrt(195)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-7*sqrt(2/715))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/715), 0, sqrt(7/2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/2145), 0, sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(195), 0, 0,
        0, sqrt(5/143)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(15)), 0, 0, 0, sqrt(3/715)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/715)/6, 0, 0, 0, 0, 0, -1/2*1/sqrt(15),
        0, 0, 0, 0, 0, 0, 0, sqrt(2/715), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/3*sqrt(5/143), 0, 0, 0, 1/sqrt(195), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4/sqrt(2145),
        0, sqrt(2/195), 0, 0, 0, 0, 0, 0, 0, -sqrt(3/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(2/195), 0, 4/sqrt(2145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(195)), 0, 0,
        0, -1/3*sqrt(5/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(2*sqrt(15)), 0, 0, 0, 0, 0, -1/6*sqrt(7/715), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(1430), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/715)/6, 0, 0, 0, 0, 0, 1/(2*sqrt(15)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/715),
        0, 0, 0, 1/(2*sqrt(15)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/429)/2, 0, sqrt(3/65)/2, 0, 0,
        0, 0, 0, -(1/sqrt(78)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/65), 0, sqrt(5/429)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(15), 0, 0, 0, -1/2*sqrt(3/715), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*1/sqrt(15), 0, 0, 0, 0, 0, sqrt(7/715)/6, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (4, 5, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(14/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14/(3*sqrt(12155)), 0,
        0, 0, 0, 0, sqrt(7/255)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(12155), 0, 0, 0, 1/sqrt(85), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/4862), 0, sqrt(14/1105), 0, 0, 0, 0, 0, -sqrt(14/663), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(14/1105), 0, sqrt(35/4862), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -(1/sqrt(85)), 0, 0, 0, -7/sqrt(12155), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(7/255), 0, 0, 0, 0, 0, 14/(3*sqrt(12155)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(2431)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/2431))/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 23/(4*sqrt(12155)), 0, 0, 0, 0, 0, -1/4*sqrt(21/85), 0, 0, 0, 0, 0,
        0, 0, (19*sqrt(7/24310))/3, 0, 0, 0, 0, 0, -1/4*sqrt(5/51), 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(5/7293))/2, 0,
        0, 0, -1/2*1/sqrt(1105), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/2210)/2, 0, sqrt(7/1105)/2, 0, 0, 0,
        0, 0, 0, 0, (-7*sqrt(7/7293))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/1105), 0,
        sqrt(77/2210)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(1105)), 0, 0, 0, (-7*sqrt(5/7293))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(5/51)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(21/85)/4, 0, 0, 0, 0, 0, -23/(4*sqrt(12155)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-3*sqrt(3/2431))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-15*sqrt(3/17017))/4, 0, 0, 0, sqrt(3/17)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-27*sqrt(3/85085))/2, 0, 0, 0, -1/2*sqrt(3/595), 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(65/1309))/12, 0, 0, 0, -53/(4*sqrt(23205)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -16*sqrt(2/36465), 0, 0, 0, -sqrt(10/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(72930)), 0,
        -1/2*sqrt(13/1870), 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(7293)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(13/1870)/2, 0, 29/(2*sqrt(72930)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/1547), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53/(4*sqrt(23205)), 0, 0, 0, (5*sqrt(65/1309))/12, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(3/595)/2, 0, 0, 0, (27*sqrt(3/85085))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/4*sqrt(3/17), 0, 0, 0, (15*sqrt(3/17017))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (5*sqrt(3/3094))/2, 0, (3*sqrt(3/119))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(195/1309)/4, 0, (9*sqrt(3/7735))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163/(4*sqrt(255255)), 0, -1/2*sqrt(13/3570), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 41/(2*sqrt(255255)), 0, -43/(2*sqrt(85085)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(7/36465), 0, (-5*sqrt(5/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23/(6*sqrt(2431)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 43/(2*sqrt(85085)), 0, -41/(2*sqrt(255255)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/3570)/2, 0,
        -163/(4*sqrt(255255)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-9*sqrt(3/7735))/4, 0, -1/4*sqrt(195/1309), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-3*sqrt(3/119))/4, 0, (-5*sqrt(3/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-3*sqrt(15/1547))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(6/1547), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -23/(2*sqrt(51051)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4/sqrt(17017), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(11/1326), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (2*sqrt(70/2431))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1326), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4/sqrt(17017), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -23/(2*sqrt(51051)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -2*sqrt(6/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-3*sqrt(15/1547))/2, 0, 0, 0, (-3*sqrt(3/119))/4, 0, (5*sqrt(3/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-9*sqrt(3/7735))/4, 0, sqrt(195/1309)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/3570)/2, 0,
        163/(4*sqrt(255255)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43/(2*sqrt(85085)), 0, 41/(2*sqrt(255255)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 23/(6*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(7/36465), 0, (5*sqrt(5/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41/(2*sqrt(255255)), 0,
        43/(2*sqrt(85085)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 163/(4*sqrt(255255)), 0, sqrt(13/3570)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(195/1309)/4, 0, (-9*sqrt(3/7735))/4, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (5*sqrt(3/3094))/2, 0, (-3*sqrt(3/119))/4, 0, -1/4*sqrt(3/17), 0, 0, 0, (-15*sqrt(3/17017))/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(3/595)/2, 0, 0, 0, (-27*sqrt(3/85085))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 53/(4*sqrt(23205)), 0, 0, 0, (-5*sqrt(65/1309))/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/1547), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/1870)/2, 0, -29/(2*sqrt(72930)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(7293)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(72930)), 0, sqrt(13/1870)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -16*sqrt(2/36465), 0, 0, 0, sqrt(10/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(65/1309))/12, 0,
        0, 0, 53/(4*sqrt(23205)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-27*sqrt(3/85085))/2, 0, 0, 0, sqrt(3/595)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-15*sqrt(3/17017))/4, 0, 0, 0, -1/4*sqrt(3/17), 0, 0, 0, 0, 0,
        (3*sqrt(3/2431))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/85)/4, 0, 0, 0, 0, 0, 23/(4*sqrt(12155)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(5/51)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/(2*sqrt(1105)), 0, 0, 0, (7*sqrt(5/7293))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/1105), 0,
        -1/2*sqrt(77/2210), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-7*sqrt(7/7293))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/2210)/2, 0, -1/2*sqrt(7/1105), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(5/7293))/2, 0, 0, 0, 1/(2*sqrt(1105)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, (19*sqrt(7/24310))/3, 0, 0, 0, 0, 0, sqrt(5/51)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23/(4*sqrt(12155)), 0,
        0, 0, 0, 0, sqrt(21/85)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/2431))/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*1/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/255), 0, 0, 0, 0, 0, -14/(3*sqrt(12155)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -(1/sqrt(85)), 0, 0, 0, 7/sqrt(12155), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(14/1105), 0, -sqrt(35/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(14/663), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(35/4862), 0, -sqrt(14/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(12155), 0, 0, 0, -(1/sqrt(85)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 14/(3*sqrt(12155)), 0, 0, 0, 0, 0, -1/2*sqrt(7/255), 0, 0, 0, 0, 0,
        0, 0, -sqrt(14/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(2431), 0,
        0, 0, 0, 0, 0,
    ]),
    # split

    (4, 6, 7): np.array([
        0, 0, 0, 0, 0, 1/(3*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/(2*sqrt(221)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(7/85)/6, 0, 0, 0, 0, 0, 14/sqrt(36465), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(170), 0, 0, 0, -7*sqrt(2/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/221), 0, 7/sqrt(4862),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(14/663), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(4862), 0, sqrt(2/221), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(2/12155), 0, 0, 0, 1/sqrt(170), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -14/sqrt(36465), 0, 0, 0, 0, 0, sqrt(7/85)/6, 0, 0, 0, 0, 0, 0, 0, sqrt(14/2431), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(6*sqrt(442)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(4*sqrt(663)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/4*sqrt(7/51), 0, 0, 0, 0, 0, -1/4*sqrt(17/143), 0, 0, 0, 0, 0, 0, 0, 0,
        0, -11/(12*sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(2210)), 0, 0,
        0, -7*sqrt(3/24310), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(221), 0, 7/(2*sqrt(4862)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/7293)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(4862)), 0, -1/2*1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 7*sqrt(3/24310), 0, 0, 0, -7/(2*sqrt(2210)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/5610), 0, 0,
        0, 0, 0, -11/(12*sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(17/143), 0, 0, 0, 0, 0, -1/4*sqrt(7/51),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(4*sqrt(663)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -5/(6*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/1547))/6, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/51)/4, 0, 0, 0, 25/(4*sqrt(4641)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(357), 0, 0, 0, 19/sqrt(51051), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/12*sqrt(17/455), 0, 0,
        0, 109/(4*sqrt(255255)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/(2*sqrt(7735)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -29/(2*sqrt(34034)), 0, -1/2*sqrt(21/4862), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -8/sqrt(7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(21/4862)/2, 0, -29/(2*sqrt(34034)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/12155), 0, 0,
        0, -11/(2*sqrt(7735)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 109/(4*sqrt(255255)), 0, 0, 0, -1/12*sqrt(17/455), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 19/sqrt(51051), 0, 0, 0, 1/sqrt(357), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 25/(4*sqrt(4641)), 0, 0, 0, sqrt(11/51)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (5*sqrt(11/1547))/6, 0, 0, 0, -1/6*sqrt(11/34), 0, (-5*sqrt(11/3094))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(11/357)/4, 0, (-5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23/(4*sqrt(4641)), 0, (-5*sqrt(7/7293))/4,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/2210))/6, 0, 53/(12*sqrt(85085)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(2/85085), 0, (27*sqrt(3/170170))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(11/3094), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -9/(2*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/2431), 0, -1/2*sqrt(11/3094),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (27*sqrt(3/170170))/2, 0, 4*sqrt(2/85085), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 53/(12*sqrt(85085)), 0, (7*sqrt(7/2210))/6, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (-5*sqrt(7/7293))/4, 0, 23/(4*sqrt(4641)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-5*sqrt(11/9282))/2, 0, sqrt(11/357)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(11/3094))/3, 0, -1/6*sqrt(11/34),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(55/238), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/4641), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(10/4641), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 79/(6*sqrt(17017)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 19/sqrt(34034), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 3*sqrt(15/34034), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(15/34034), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -19/sqrt(34034), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -79/(6*sqrt(17017)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(10/4641), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(55/4641)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(55/238)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/3094))/3, 0, -1/6*sqrt(11/34), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (5*sqrt(11/9282))/2, 0, sqrt(11/357)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(7/7293))/4, 0, 23/(4*sqrt(4641)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -53/(12*sqrt(85085)), 0, (7*sqrt(7/2210))/6, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (-27*sqrt(3/170170))/2, 0, 4*sqrt(2/85085), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/2431), 0, -1/2*sqrt(11/3094),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/(2*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/3094)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(2/85085),
        0, (27*sqrt(3/170170))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(7/2210))/6, 0, 53/(12*sqrt(85085)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -23/(4*sqrt(4641)), 0, (-5*sqrt(7/7293))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/4*sqrt(11/357), 0, (-5*sqrt(11/9282))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/34)/6, 0, (-5*sqrt(11/3094))/3, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-5*sqrt(11/1547))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -25/(4*sqrt(4641)), 0, 0, 0, sqrt(11/51)/4,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -19/sqrt(51051), 0, 0, 0, 1/sqrt(357), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -109/(4*sqrt(255255)), 0, 0, 0, -1/12*sqrt(17/455), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/12155), 0, 0,
        0, -11/(2*sqrt(7735)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(21/4862), 0, -29/(2*sqrt(34034)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 8/sqrt(7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(34034)),
        0, -1/2*sqrt(21/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11/(2*sqrt(7735)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(17/455)/12, 0, 0, 0, 109/(4*sqrt(255255)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(357)), 0, 0, 0, 19/sqrt(51051), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/51), 0, 0, 0, 25/(4*sqrt(4641)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/1547))/6, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(6*sqrt(442)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(4*sqrt(663)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(17/143)/4, 0, 0, 0, 0, 0, -1/4*sqrt(7/51), 0, 0, 0, 0, 0, 0, 0, sqrt(91/5610), 0, 0,
        0, 0, 0, -11/(12*sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(3/24310), 0, 0, 0, -7/(2*sqrt(2210)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(4862)), 0, -1/2*1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/7293),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(221)), 0, 7/(2*sqrt(4862)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(2210)), 0, 0, 0, -7*sqrt(3/24310), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 11/(12*sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/51)/4, 0, 0, 0, 0,
        0, -1/4*sqrt(17/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(4*sqrt(663)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(6*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(14/2431), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14/sqrt(36465), 0, 0, 0, 0, 0, sqrt(7/85)/6,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(2/12155), 0, 0, 0, 1/sqrt(170), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 7/sqrt(4862), 0, sqrt(2/221), 0, 0, 0, 0, 0, -sqrt(14/663), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(2/221), 0, 7/sqrt(4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(170)), 0, 0, 0, -7*sqrt(2/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(7/85), 0, 0, 0, 0,
        0, 14/sqrt(36465), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(221)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(3*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (4, 7, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 5/(6*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(3/4199))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/12597), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -35/sqrt(138567), 0, 0, 0, 0, 0, -1/6*sqrt(7/323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 21/sqrt(46189), 0, 0, 0, -5/(6*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -35/sqrt(138567), 0, (-5*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 5*sqrt(7/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (5*sqrt(3/4199))/2, 0, -35/sqrt(138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(6*sqrt(323)), 0, 0, 0,
        21/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/323)/6, 0, 0, 0, 0, 0, -35/sqrt(138567), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-5*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -5/(6*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(7/323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(77/646), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -35/(6*sqrt(4199)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -25/(2*sqrt(25194)), 0,
        0, 0, 0, 0, sqrt(77/646)/6, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(21/92378), 0, 0, 0, 0, 0, 3/(2*sqrt(323)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(138567), 0, 0, 0, 35/(6*sqrt(4199)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 7/sqrt(138567), 0, 25/(2*sqrt(25194)), 0, 0, 0, 0, 0, 0, 0, -5*sqrt(21/92378), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -25/(2*sqrt(25194)), 0, 7/sqrt(138567), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -35/(6*sqrt(4199)), 0, 0, 0, 7/sqrt(138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(77/646), 0, 0, 0, 0, 0, 25/(2*sqrt(25194)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35/(6*sqrt(4199)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/646)/6, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(11/4522))/6, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(3*sqrt(29393)), 0, 0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 5/(2*sqrt(58786)), 0, 0, 0, (-11*sqrt(11/4522))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(13/74613))/2, 0,
        0, 0, -29/(3*sqrt(29393)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -47/sqrt(277134), 0, 0, 0, -5/(2*sqrt(58786)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(7/46189), 0, (5*sqrt(13/74613))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -47/sqrt(277134), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(13/74613))/2, 0, 6*sqrt(7/46189), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(58786)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 29/(3*sqrt(29393)), 0, 0, 0, (5*sqrt(13/74613))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(11/4522))/6, 0, 0, 0,
        -5/(2*sqrt(58786)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, -29/(3*sqrt(29393)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-11*sqrt(11/4522))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(143/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-2*sqrt(11/2261))/3, 0, sqrt(143/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(11/58786))/2, 0, (2*sqrt(11/2261))/3, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/646)/6, 0, (-3*sqrt(11/58786))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 125/(3*sqrt(323323)), 0, -1/6*sqrt(91/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (37*sqrt(3/323323))/2, 0,
        -125/(3*sqrt(323323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/sqrt(92378), 0, (-37*sqrt(3/323323))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 9/sqrt(92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (37*sqrt(3/323323))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 125/(3*sqrt(323323)), 0, (-37*sqrt(3/323323))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/646)/6, 0, -125/(3*sqrt(323323)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (3*sqrt(11/58786))/2, 0, -1/6*sqrt(91/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-2*sqrt(11/2261))/3, 0, (-3*sqrt(11/58786))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(143/323), 0, (2*sqrt(11/2261))/3, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(143/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(1001/1615)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(143/11305), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-79*sqrt(11/146965))/6, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-32*sqrt(11/146965))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -83/(2*sqrt(1616615)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        251/(6*sqrt(1616615)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207/(2*sqrt(1616615)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18*sqrt(7/230945), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 207/(2*sqrt(1616615)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 251/(6*sqrt(1616615)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -83/(2*sqrt(1616615)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-32*sqrt(11/146965))/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-79*sqrt(11/146965))/6, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(143/11305), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(1001/1615)/6, 0, -1/6*sqrt(143/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/6*sqrt(143/323), 0, (-2*sqrt(11/2261))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-2*sqrt(11/2261))/3, 0, (3*sqrt(11/58786))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(11/58786))/2, 0, sqrt(91/646)/6, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/646)/6, 0, 125/(3*sqrt(323323)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 125/(3*sqrt(323323)), 0, (37*sqrt(3/323323))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (37*sqrt(3/323323))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/sqrt(92378), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/sqrt(92378), 0, (37*sqrt(3/323323))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (37*sqrt(3/323323))/2, 0, 125/(3*sqrt(323323)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 125/(3*sqrt(323323)), 0, sqrt(91/646)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(91/646)/6, 0, (3*sqrt(11/58786))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(11/58786))/2, 0, (-2*sqrt(11/2261))/3, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-2*sqrt(11/2261))/3, 0, -1/6*sqrt(143/323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(143/323), 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(11/4522))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(11/323)/2, 0, 0, 0, 29/(3*sqrt(29393)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(11/4522))/6, 0, 0, 0,
        5/(2*sqrt(58786)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(3*sqrt(29393)), 0, 0, 0, (-5*sqrt(13/74613))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(58786)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-5*sqrt(13/74613))/2, 0, -6*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -47/sqrt(277134), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(7/46189), 0,
        (-5*sqrt(13/74613))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -47/sqrt(277134), 0, 0, 0, 5/(2*sqrt(58786)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(13/74613))/2, 0, 0, 0, 29/(3*sqrt(29393)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 5/(2*sqrt(58786)), 0, 0, 0, (11*sqrt(11/4522))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        29/(3*sqrt(29393)), 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(11/4522))/6, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, -1/6*sqrt(77/646), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -35/(6*sqrt(4199)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/6*sqrt(77/646), 0, 0, 0, 0, 0, -25/(2*sqrt(25194)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -35/(6*sqrt(4199)), 0, 0, 0, -7/sqrt(138567), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -25/(2*sqrt(25194)), 0, -7/sqrt(138567), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(21/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 7/sqrt(138567), 0, -25/(2*sqrt(25194)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(138567), 0,
        0, 0, -35/(6*sqrt(4199)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(21/92378), 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, -25/(2*sqrt(25194)), 0, 0, 0, 0, 0, -1/6*sqrt(77/646), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -35/(6*sqrt(4199)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(77/646), 0, 0, 0,
        0, 0, 0, 0, sqrt(7/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        5/(6*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(3/4199))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/323)/6, 0, 0, 0, 0, 0, 35/sqrt(138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(6*sqrt(323)), 0, 0, 0,
        -21/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(3/4199))/2, 0, 35/sqrt(138567), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/12597), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -35/sqrt(138567), 0, (5*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 21/sqrt(46189), 0, 0, 0, 5/(6*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -35/sqrt(138567), 0,
        0, 0, 0, 0, sqrt(7/323)/6, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/12597), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 5/(6*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/323)/6, 0, 0, 0, 0,
    ]),
    # split

    (5, 5, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(7/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/2431), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*1/sqrt(51), 0, 0, 0, (5*sqrt(7/7293))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(102)), 0, -5/(2*sqrt(663)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(5/221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 5/(2*sqrt(663)), 0, -(1/sqrt(102)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(7/7293))/2, 0, 0, 0, -1/2*1/sqrt(51),
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/14586), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/7293), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(85), 0, 0, 0, 0,
        0, -2*sqrt(21/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/255)/2, 0, 0, 0, sqrt(91/2805)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(2/3315), 0, -2*sqrt(10/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2*sqrt(10/7293), 0, sqrt(2/3315), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(91/2805),
        0, 0, 0, sqrt(7/255)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(21/12155), 0, 0, 0, 0, 0, 1/sqrt(85),
        0, 0, 0, 0, 0, 0, 0, -23/sqrt(72930), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/2431), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(85)), 0, 0, 0, 0, 0, 2*sqrt(21/12155), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/1105)/2, 0, 0,
        0, sqrt(35/2431)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/1105))/2, 0, -sqrt(3/24310), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(2431), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/24310), 0, (3*sqrt(3/1105))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(35/2431), 0, 0, 0, sqrt(21/1105)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/2210), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(21/12155), 0, 0, 0, 0, 0, -(1/sqrt(85)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/2431), 0, 0, 0, 0, 0, 1/(2*sqrt(51)), 0, 0, 0, (-5*sqrt(7/7293))/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/255), 0, 0, 0, -1/2*sqrt(91/2805), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(21/1105), 0, 0, 0, -1/2*sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/sqrt(24310),
        0, sqrt(13/5610), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/2431),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/5610), 0, 9/sqrt(24310), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(2/36465), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(35/2431), 0, 0, 0, -1/2*sqrt(21/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(91/2805),
        0, 0, 0, -1/2*sqrt(7/255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(7/7293))/2, 0, 0, 0, 1/(2*sqrt(51)),
        0, 1/sqrt(102), 0, 5/(2*sqrt(663)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/3315), 0, 2*sqrt(10/7293),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/1105))/2, 0, sqrt(3/24310), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -9/sqrt(24310), 0, -sqrt(13/5610), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(14/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -14*sqrt(2/36465), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/5610), 0, -9/sqrt(24310), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/24310), 0, (-3*sqrt(3/1105))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2*sqrt(10/7293), 0, -sqrt(2/3315), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 5/(2*sqrt(663)), 0, 1/sqrt(102), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/221), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(442), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/2431),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(14/2431), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(14/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/2431), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -(1/sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/221), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -5/(2*sqrt(663)), 0, 1/sqrt(102), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(10/7293), 0, -sqrt(2/3315), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/24310), 0, (-3*sqrt(3/1105))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(13/5610), 0, -9/sqrt(24310), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 14*sqrt(2/36465), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(14/2431), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/sqrt(24310),
        0, -sqrt(13/5610), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/1105))/2, 0, sqrt(3/24310), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(2/3315), 0, 2*sqrt(10/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(102)), 0, 5/(2*sqrt(663)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (5*sqrt(7/7293))/2, 0, 0, 0, 1/(2*sqrt(51)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/2805)/2,
        0, 0, 0, -1/2*sqrt(7/255), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/2431)/2, 0, 0, 0, -1/2*sqrt(21/1105), 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(2/36465), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(13/5610), 0, 9/sqrt(24310), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/2431), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -9/sqrt(24310), 0, sqrt(13/5610), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/1105)/2, 0, 0,
        0, -1/2*sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/255)/2, 0, 0, 0, -1/2*sqrt(91/2805), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*1/sqrt(51), 0, 0, 0, (-5*sqrt(7/7293))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -2*sqrt(21/12155), 0, 0, 0, 0, 0, -(1/sqrt(85)), 0, 0, 0, 0, 0, 0, 0, -sqrt(33/2210), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/2431)/2, 0, 0, 0, sqrt(21/1105)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/24310), 0, (3*sqrt(3/1105))/2, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(2431),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/1105))/2, 0, -sqrt(3/24310), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(21/1105), 0, 0, 0, sqrt(35/2431)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(85), 0, 0, 0, 0,
        0, 2*sqrt(21/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/2431), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/7293), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 23/sqrt(72930), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -2*sqrt(21/12155), 0, 0, 0, 0, 0, 1/sqrt(85), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/2805)/2,
        0, 0, 0, sqrt(7/255)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(10/7293), 0, sqrt(2/3315), 0, 0,
        0, 0, 0, 1/sqrt(442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/3315), 0, -2*sqrt(10/7293),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/255), 0, 0, 0, sqrt(91/2805)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(85)), 0, 0, 0, 0, 0, -2*sqrt(21/12155), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(7/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/14586), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/7293), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (5*sqrt(7/7293))/2, 0, 0, 0, -1/2*1/sqrt(51), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -5/(2*sqrt(663)), 0, -(1/sqrt(102)), 0, 0, 0, sqrt(5/221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(102), 0, -5/(2*sqrt(663)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(51)), 0, 0, 0, (5*sqrt(7/7293))/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/2431), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/7293), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (5, 6, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(35/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(10/138567), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(6/46189), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35/sqrt(138567), 0, 0, 0, -1/2*sqrt(7/969), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -7*sqrt(5/25194), 0, -sqrt(5/969), 0, 0, 0, sqrt(70/4199), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(5/969), 0, -7*sqrt(5/25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/969)/2, 0, 0, 0, 35/sqrt(138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -7*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(10/138567), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(5/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (3*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11/sqrt(25194), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(119/8151), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -28*sqrt(2/230945), 0, 0, 0, 0, 0, sqrt(21/3230), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 49/sqrt(692835), 0, 0, 0, 13/(2*sqrt(4845)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -7/sqrt(138567), 0, 8/sqrt(12597), 0, 0, 0, 0, 0, -sqrt(7/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -8/sqrt(12597), 0, -7/sqrt(138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -13/(2*sqrt(4845)), 0, 0, 0,
        49/sqrt(692835), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/3230), 0, 0, 0, 0, 0, -28*sqrt(2/230945), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -11/sqrt(25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-3*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-5*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(2/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/7106), 0, 0, 0, 0, 0, -sqrt(7/646), 0, 0, 0, 0, 0,
        0, 0, -9*sqrt(7/230945), 0, 0, 0, 0, 0, -sqrt(6/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(230945), 0,
        0, 0, sqrt(3/20995)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(3/46189), 0, 3*sqrt(3/8398), 0, 0, 0,
        0, 0, 0, 0, -6*sqrt(14/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/8398), 0,
        7*sqrt(3/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/20995), 0, 0, 0, -7/sqrt(230945), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(6/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/646), 0, 0, 0, 0, 0, sqrt(39/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        4*sqrt(2/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(3/4199))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/8398))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 25/(2*sqrt(25194)), 0, 0, 0, sqrt(77/1938)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 29/(2*sqrt(277134)), 0, 0, 0, -1/2*1/sqrt(1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, (-23*sqrt(3/461890))/2, 0,
        0, 0, -29/(2*sqrt(41990)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -41*sqrt(7/1385670), 0, 0, 0, -27/(2*sqrt(41990)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 49/(2*sqrt(138567)), 0, -9/(2*sqrt(46189)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(21/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/(2*sqrt(46189)), 0, 49/(2*sqrt(138567)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 27/(2*sqrt(41990)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 29/(2*sqrt(41990)), 0, 0, 0, (23*sqrt(3/461890))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(1938)), 0, 0, 0,
        -29/(2*sqrt(277134)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/1938), 0, 0, 0, -25/(2*sqrt(25194)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(11/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-15*sqrt(11/58786))/2, 0, -1/2*sqrt(11/646), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -5*sqrt(11/176358), 0, 2*sqrt(11/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (5*sqrt(13/74613))/2, 0, 37/(2*sqrt(88179)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8*sqrt(11/146965), 0, -3/sqrt(293930), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 367/(2*sqrt(9699690)), 0, -207/(2*sqrt(3233230)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 8/sqrt(138567), 0, -27*sqrt(2/323323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/4199), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27*sqrt(2/323323), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 207/(2*sqrt(3233230)), 0, -367/(2*sqrt(9699690)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(293930), 0,
        -8*sqrt(11/146965), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -37/(2*sqrt(88179)), 0, (-5*sqrt(13/74613))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -2*sqrt(11/6783), 0, 5*sqrt(11/176358), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(11/646)/2, 0, (15*sqrt(11/58786))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(165/2261)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(55/58786), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -8*sqrt(5/29393), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -37*sqrt(3/646646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-3*sqrt(3/323323))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(85/19019), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(105/46189), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(85/19019), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-3*sqrt(3/323323))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -37*sqrt(3/646646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -8*sqrt(5/29393), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(55/58786), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(165/2261)/2, 0, sqrt(11/646)/2, 0, (-15*sqrt(11/58786))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -2*sqrt(11/6783), 0, -5*sqrt(11/176358), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -37/(2*sqrt(88179)), 0, (5*sqrt(13/74613))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(293930), 0,
        8*sqrt(11/146965), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 207/(2*sqrt(3233230)), 0, 367/(2*sqrt(9699690)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27*sqrt(2/323323), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 8/sqrt(138567), 0, 27*sqrt(2/323323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 367/(2*sqrt(9699690)), 0,
        207/(2*sqrt(3233230)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8*sqrt(11/146965), 0, 3/sqrt(293930), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(13/74613))/2, 0, -37/(2*sqrt(88179)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -5*sqrt(11/176358), 0, -2*sqrt(11/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-15*sqrt(11/58786))/2, 0, sqrt(11/646)/2, 0, 0, 0, (5*sqrt(11/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(77/1938), 0, 0, 0, 25/(2*sqrt(25194)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(1938)), 0, 0, 0,
        29/(2*sqrt(277134)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(41990)), 0, 0, 0, (-23*sqrt(3/461890))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 27/(2*sqrt(41990)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 9/(2*sqrt(46189)), 0, -49/(2*sqrt(138567)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -3*sqrt(21/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49/(2*sqrt(138567)), 0,
        9/(2*sqrt(46189)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -41*sqrt(7/1385670), 0, 0, 0, 27/(2*sqrt(41990)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-23*sqrt(3/461890))/2, 0, 0, 0, 29/(2*sqrt(41990)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 29/(2*sqrt(277134)), 0, 0, 0, 1/(2*sqrt(1938)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        25/(2*sqrt(25194)), 0, 0, 0, -1/2*sqrt(77/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/8398))/2, 0, 0, 0,
        0, 0, 0, 0, (-5*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -4*sqrt(2/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/646), 0, 0, 0, 0, 0, -sqrt(39/7106), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(6/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(3/20995), 0, 0, 0, 7/sqrt(230945), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/8398), 0,
        -7*sqrt(3/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -6*sqrt(14/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(3/46189), 0, -3*sqrt(3/8398), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(230945), 0, 0, 0, -1/2*sqrt(3/20995), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -9*sqrt(7/230945), 0, 0, 0, 0, 0, sqrt(6/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/7106), 0,
        0, 0, 0, 0, sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(2/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11/sqrt(25194), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(21/3230), 0, 0, 0, 0, 0, 28*sqrt(2/230945), 0, 0, 0, 0, 0, 0, 0, 0, 0, -13/(2*sqrt(4845)), 0, 0, 0,
        -49/sqrt(692835), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -8/sqrt(12597), 0, 7/sqrt(138567), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/4199), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(138567), 0, -8/sqrt(12597), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 49/sqrt(692835), 0, 0, 0, -13/(2*sqrt(4845)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -28*sqrt(2/230945), 0,
        0, 0, 0, 0, -sqrt(21/3230), 0, 0, 0, 0, 0, 0, 0, sqrt(119/8151), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 11/sqrt(25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (3*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/4199), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -7*sqrt(10/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        7*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/969)/2, 0, 0, 0, -35/sqrt(138567), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(5/969), 0, 7*sqrt(5/25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(70/4199), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -7*sqrt(5/25194), 0, sqrt(5/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        35/sqrt(138567), 0, 0, 0, sqrt(7/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(6/46189), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(10/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(35/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/4199), 0,
        0, 0, 0, 0, 0,
    ]),
    # split

    (5, 7, 7): np.array([
        0, 0, 0, 0, 0, sqrt(7/3230)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (3*sqrt(3/3230))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(3/20995), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -63/sqrt(461890), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/3230), 0, 0, 0, 63/sqrt(461890),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/3230))/2, 0, -7*sqrt(3/20995), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(21/20995), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(3/20995), 0, (-3*sqrt(3/3230))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -63/sqrt(461890), 0, 0, 0, -1/2*sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 63/sqrt(461890),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(3/20995), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 3*sqrt(21/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (3*sqrt(3/3230))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/3230)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(2/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-9*sqrt(3/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0, 0, -7*sqrt(3/92378), 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(2/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (9*sqrt(3/8398))/2, 0, 7*sqrt(3/92378),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(42/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(3/92378), 0, (9*sqrt(3/8398))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/323), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 7*sqrt(3/92378), 0, 0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0, 0, 0, 0, -sqrt(42/4199), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-9*sqrt(3/8398))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, sqrt(77/323)/6, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 13/(6*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 29/(6*sqrt(8398)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(77/323), 0, 0, 0, 0,
        0, 1/(2*sqrt(12597)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -13/(6*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -29/(6*sqrt(8398)), 0, 0, 0, -35/sqrt(277134), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*1/sqrt(12597), 0, 35/sqrt(277134), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 8*sqrt(7/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -35/sqrt(277134),
        0, -1/2*1/sqrt(12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35/sqrt(277134), 0, 0, 0, -29/(6*sqrt(8398)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -8*sqrt(7/138567), 0, 0, 0, 0, 0, -13/(6*sqrt(646)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/(2*sqrt(12597)), 0, 0, 0, 0, 0, -1/6*sqrt(77/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(6*sqrt(8398)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13/(6*sqrt(646)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/323)/6, 0, 0, 0, 0, 0, -1/2*sqrt(77/1938), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(77/1938)/2, 0, 0, 0, sqrt(2/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(11/969)/2, 0, 0, 0, sqrt(13/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/12597), 0, 0,
        0, 41/(2*sqrt(92378)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -41/(2*sqrt(92378)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -41/(2*sqrt(92378)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/46189), 0, 0,
        0, -1/2*sqrt(13/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41/(2*sqrt(92378)), 0, 0, 0, -sqrt(2/12597), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/969)/2, 0, 0, 0, sqrt(11/969)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(2/12597), 0, 0, 0, sqrt(77/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/1938), 0, 0,
        0, sqrt(143/969)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(143/969), 0, -1/4*sqrt(11/6783), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/6783)/4, 0, -1/2*sqrt(187/10374), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(187/10374)/2, 0, -53/(2*sqrt(176358)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 53/(2*sqrt(176358)), 0, -83/(4*sqrt(969969)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83/(4*sqrt(969969)),
        0, (5*sqrt(13/24871))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(13/24871))/4, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -15*sqrt(3/92378), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 15*sqrt(3/92378), 0, (-5*sqrt(13/24871))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (5*sqrt(13/24871))/4, 0, 83/(4*sqrt(969969)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -83/(4*sqrt(969969)),
        0, 53/(2*sqrt(176358)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -53/(2*sqrt(176358)), 0, sqrt(187/10374)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(187/10374), 0, sqrt(11/6783)/4, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/6783), 0, -1/4*sqrt(143/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(143/969)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(1001/3230)/6,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-2*sqrt(286/11305))/3, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-89*sqrt(11/293930))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/3*sqrt(22/146965), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 751/(6*sqrt(3233230)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (50*sqrt(10/323323))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (45*sqrt(5/646646))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-45*sqrt(5/646646))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (-50*sqrt(10/323323))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -751/(6*sqrt(3233230)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(22/146965)/3, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (89*sqrt(11/293930))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (2*sqrt(286/11305))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(1001/3230), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/4*sqrt(143/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/6783)/4, 0, -1/4*sqrt(143/969),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(187/10374)/2, 0, sqrt(11/6783)/4, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 53/(2*sqrt(176358)), 0, sqrt(187/10374)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 83/(4*sqrt(969969)),
        0, 53/(2*sqrt(176358)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(13/24871))/4, 0, 83/(4*sqrt(969969)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -15*sqrt(3/92378), 0, (-5*sqrt(13/24871))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 15*sqrt(3/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(13/24871))/4, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -83/(4*sqrt(969969)), 0, (5*sqrt(13/24871))/4, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -53/(2*sqrt(176358)), 0, -83/(4*sqrt(969969)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(187/10374), 0, -53/(2*sqrt(176358)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/6783), 0, -1/2*sqrt(187/10374), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(143/969)/4, 0, -1/4*sqrt(11/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(143/969)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(77/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(11/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/12597), 0, 0, 0, sqrt(77/1938)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0, 0, 0, sqrt(11/969)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -41/(2*sqrt(92378)), 0, 0, 0, -sqrt(2/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(7/46189), 0, 0,
        0, -1/2*sqrt(13/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -41/(2*sqrt(92378)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 5*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41/(2*sqrt(92378)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/969)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(2/12597), 0, 0, 0, 41/(2*sqrt(92378)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(11/969), 0, 0, 0, sqrt(13/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/1938), 0, 0, 0, sqrt(2/12597),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(77/323), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -13/(6*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -29/(6*sqrt(8398)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(12597), 0, 0, 0, 0, 0, -1/6*sqrt(77/323),
        0, 0, 0, 0, 0, 0, 0, 8*sqrt(7/138567), 0, 0, 0, 0, 0, -13/(6*sqrt(646)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -35/sqrt(277134), 0, 0, 0, -29/(6*sqrt(8398)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 35/sqrt(277134),
        0, -1/2*1/sqrt(12597), 0, 0, 0, 0, 0, 0, 0, -8*sqrt(7/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/(2*sqrt(12597)), 0, 35/sqrt(277134), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(6*sqrt(8398)), 0, 0,
        0, -35/sqrt(277134), 0, 0, 0, 0, 0, 0, 0, 0, 0, 13/(6*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(77/323)/6, 0, 0, 0, 0, 0, 1/(2*sqrt(12597)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 29/(6*sqrt(8398)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13/(6*sqrt(646)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/323)/6, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (9*sqrt(3/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(42/4199), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(3/92378), 0, 0, 0, 0, 0, sqrt(7/646)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/323), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 7*sqrt(3/92378), 0, (9*sqrt(3/8398))/2, 0, 0, 0, 0, 0, -sqrt(42/4199), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-9*sqrt(3/8398))/2, 0, 7*sqrt(3/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(2/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/646), 0, 0, 0, 0,
        0, -7*sqrt(3/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-9*sqrt(3/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(2/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/646),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/3230),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/3230))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3*sqrt(21/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 7*sqrt(3/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -63/sqrt(461890),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 63/sqrt(461890), 0, 0, 0, -1/2*sqrt(7/3230),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(3/20995), 0, (-3*sqrt(3/3230))/2, 0, 0, 0, 3*sqrt(21/20995), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/3230))/2, 0, -7*sqrt(3/20995), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(7/3230)/2, 0, 0, 0, 63/sqrt(461890), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -63/sqrt(461890), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 7*sqrt(3/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/3230))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(7/3230)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (6, 6, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(77/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(21/41990), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(77/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1615)/2, 0, (3*sqrt(77/20995))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(33/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(77/20995))/2, 0, sqrt(11/1615)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/8398), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(21/41990),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/41990), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(33/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(77/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -8*sqrt(7/62985), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(21/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/1938), 0, 0, 0, -sqrt(14/12597),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/9690), 0, -1/2*sqrt(77/62985), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(11/20995), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/62985)/2, 0, -sqrt(77/9690), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(14/12597), 0, 0, 0, -sqrt(11/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/4199),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8*sqrt(7/62985), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -11*sqrt(11/125970), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(77/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(21/41990), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8*sqrt(7/62985), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/323), 0, 0, 0, 0,
        0, sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1938), 0, 0, 0, 4*sqrt(14/138567), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(7/125970), 0, -31*sqrt(7/1385670), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(17/2470), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 31*sqrt(7/1385670), 0, -sqrt(7/125970), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(14/138567),
        0, 0, 0, sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/46189), 0, 0, 0, 0, 0, sqrt(3/323),
        0, 0, 0, 0, 0, 0, 0, 103/sqrt(1385670), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 8*sqrt(7/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(21/41990),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(21/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/323), 0, 0, 0, 0,
        0, -sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(35/8398), 0, 0, 0, sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (3*sqrt(7/4199))/2, 0, -5*sqrt(7/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2*sqrt(3/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/92378),
        0, (3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(210/46189), 0, 0, 0, sqrt(35/8398), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 5*sqrt(15/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/46189), 0, 0, 0, 0, 0, -sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/4199),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, 0,
        0, 0, 0, sqrt(77/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1938), 0, 0, 0, sqrt(14/12597),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/1938), 0, 0, 0, -4*sqrt(14/138567), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(35/8398), 0, 0, 0, -sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (9*sqrt(7/46189))/2,
        0, (5*sqrt(7/138567))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15*sqrt(3/92378),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(7/138567))/2, 0, (9*sqrt(7/46189))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(65/21318), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(210/46189), 0, 0, 0, -sqrt(35/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(14/138567),
        0, 0, 0, -sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/12597), 0, 0, 0, sqrt(11/1938),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/8398), 0, 0, 0, -1/2*sqrt(11/1615), 0, (-3*sqrt(77/20995))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/9690), 0, sqrt(77/62985)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/125970), 0, 31*sqrt(7/1385670), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (-3*sqrt(7/4199))/2, 0, 5*sqrt(7/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-9*sqrt(7/46189))/2,
        0, (-5*sqrt(7/138567))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(10/46189), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -10*sqrt(10/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (-5*sqrt(7/138567))/2, 0, (-9*sqrt(7/46189))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/92378),
        0, (-3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31*sqrt(7/1385670), 0, sqrt(7/125970), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/62985)/2, 0, sqrt(77/9690), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-3*sqrt(77/20995))/2, 0, -1/2*sqrt(11/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(33/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(11/20995), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/2470), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -2*sqrt(3/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -15*sqrt(3/92378),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(10/46189), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 5*sqrt(10/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15*sqrt(3/92378), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(17/2470), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(11/20995), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(77/20995))/2, 0, -1/2*sqrt(11/1615),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/62985), 0, sqrt(77/9690), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -31*sqrt(7/1385670), 0, sqrt(7/125970), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(7/92378),
        0, (-3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(7/138567))/2, 0, (-9*sqrt(7/46189))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 10*sqrt(10/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -5*sqrt(10/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (9*sqrt(7/46189))/2, 0, (-5*sqrt(7/138567))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (3*sqrt(7/4199))/2, 0, 5*sqrt(7/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/125970), 0, 31*sqrt(7/1385670),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/9690), 0, sqrt(77/62985)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/1615)/2, 0, (-3*sqrt(77/20995))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/8398), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(14/12597), 0, 0, 0, sqrt(11/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(14/138567),
        0, 0, 0, -sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(210/46189), 0, 0, 0, -sqrt(35/8398), 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(65/21318), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (5*sqrt(7/138567))/2, 0, (9*sqrt(7/46189))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -15*sqrt(3/92378), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (-9*sqrt(7/46189))/2, 0, (5*sqrt(7/138567))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/8398), 0, 0,
        0, -sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1938), 0, 0, 0, -4*sqrt(14/138567), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(11/1938), 0, 0, 0, sqrt(14/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(77/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/4199),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/46189), 0, 0, 0, 0, 0, -sqrt(3/323),
        0, 0, 0, 0, 0, 0, 0, -5*sqrt(15/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(210/46189), 0, 0, 0, sqrt(35/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(7/92378),
        0, (3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(3/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (-3*sqrt(7/4199))/2, 0, -5*sqrt(7/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/8398), 0, 0,
        0, sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/323), 0, 0, 0, 0, 0, -sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(21/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(7/8398),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(21/41990),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -8*sqrt(7/62985), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -103/sqrt(1385670), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/46189), 0, 0, 0, 0, 0, sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(14/138567),
        0, 0, 0, sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -31*sqrt(7/1385670), 0, -sqrt(7/125970), 0, 0,
        0, 0, 0, sqrt(17/2470), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/125970), 0, -31*sqrt(7/1385670),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/1938), 0, 0, 0, 4*sqrt(14/138567), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(3/323), 0, 0, 0, 0, 0, sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 8*sqrt(7/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(21/41990), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/41990), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 11*sqrt(11/125970), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -8*sqrt(7/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/4199),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(14/12597), 0, 0, 0, -sqrt(11/1938),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/62985), 0, -sqrt(77/9690), 0, 0, 0, 4*sqrt(11/20995), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/9690), 0, -1/2*sqrt(77/62985), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/1938), 0, 0, 0, -sqrt(14/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(21/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -8*sqrt(7/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/41990), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(33/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(77/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(21/41990),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(7/8398), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/8398), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (3*sqrt(77/20995))/2, 0, sqrt(11/1615)/2, 0, -sqrt(33/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(11/1615), 0, (3*sqrt(77/20995))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(77/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(7/8398),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(21/41990), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/41990), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (6, 7, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(22/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(77/62985), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/20995), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(154/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(77/62985), 0, sqrt(11/4845)/2, 0, -sqrt(22/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(11/4845), 0, 2*sqrt(77/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/20995), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(77/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/4845)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/3230)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/3230)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(55/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/20995), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/41990), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/41990), 0, 0, 0, -1/2*sqrt(33/3230), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(77/20995), 0, -1/2*sqrt(77/3230), 0, 0, 0, sqrt(55/4199), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(77/3230)/2, 0, -sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(33/3230)/2, 0, 0, 0, sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/20995), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(77/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(33/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(15/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/3230), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(7/41990))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(2/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/35530), 0,
        0, 0, 0, 0, sqrt(15/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(210/46189), 0, 0, 0, sqrt(21/3230), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/35530), 0, (7*sqrt(7/41990))/2, 0, 0, 0, 0, 0, sqrt(2/20995), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(7/41990))/2, 0, -sqrt(91/35530), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(21/3230), 0, 0, 0, sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(15/646), 0, 0, 0, 0, 0, -sqrt(91/35530), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/41990))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(15/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/8398), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(7/12597))/2, 0, 0, 0, 0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0,
        0, 0, -32/sqrt(138567), 0, 0, 0, 0, 0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/277134), 0,
        0, 0, sqrt(7/8398)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/277134), 0, (5*sqrt(7/12597))/2, 0, 0, 0,
        0, 0, 0, 0, -32/sqrt(138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(7/12597))/2, 0,
        5*sqrt(7/277134), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/8398), 0, 0, 0, 5*sqrt(7/277134), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(11/323)/2, 0, 0, 0, 0, 0, (5*sqrt(7/12597))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/8398)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(7/4199))/2, 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/46189)/2, 0, 0, 0, (-3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -5*sqrt(6/46189), 0, 0, 0, -sqrt(14/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/46189), 0,
        -1/2*sqrt(21/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(21/46189)/2, 0, 5*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(7/4199))/2, 0, 0, 0, -1/2*sqrt(21/46189), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(14/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(11/323), 0, 0, 0, (-3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/1615)/4, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(77/1615), 0, -1/4*sqrt(143/1615), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-3*sqrt(77/41990))/2, 0, sqrt(77/1615)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(7/41990), 0, (3*sqrt(77/41990))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(35/46189))/4, 0, sqrt(7/41990)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(105/46189))/4, 0, (-7*sqrt(35/46189))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 5*sqrt(5/92378), 0, (-5*sqrt(105/46189))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(5/92378), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(105/46189))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (7*sqrt(35/46189))/4, 0, (-5*sqrt(105/46189))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/41990), 0,
        (-7*sqrt(35/46189))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(77/41990))/2, 0, sqrt(7/41990)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/4*sqrt(77/1615), 0, (3*sqrt(77/41990))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(143/1615)/4, 0, sqrt(77/1615)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(143/1615), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(143/9690), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(143/9690), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(55/25194)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(22/62985), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -197/(2*sqrt(1385670)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/277134), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (25*sqrt(5/277134))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 10*sqrt(10/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (25*sqrt(5/277134))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/277134), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -197/(2*sqrt(1385670)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -4*sqrt(22/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(55/25194)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/9690), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(143/9690), 0, sqrt(143/1615)/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/1615)/4, 0, -1/4*sqrt(77/1615), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/4*sqrt(77/1615), 0, (-3*sqrt(77/41990))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-3*sqrt(77/41990))/2, 0, -1/2*sqrt(7/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/41990), 0,
        (7*sqrt(35/46189))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(35/46189))/4, 0, (5*sqrt(105/46189))/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(105/46189))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(5/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 5*sqrt(5/92378), 0, (5*sqrt(105/46189))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(105/46189))/4, 0,
        (7*sqrt(35/46189))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(35/46189))/4, 0, -1/2*sqrt(7/41990), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/41990), 0, (-3*sqrt(77/41990))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-3*sqrt(77/41990))/2, 0, -1/4*sqrt(77/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/4*sqrt(77/1615), 0, sqrt(143/1615)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/1615)/4, 0,
        0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/323), 0, 0, 0, (3*sqrt(7/4199))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (3*sqrt(7/4199))/2, 0, 0, 0, sqrt(21/46189)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/46189)/2, 0, -5*sqrt(7/46189), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(6/46189), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/46189), 0, sqrt(21/46189)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -5*sqrt(6/46189), 0, 0, 0, sqrt(14/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/46189)/2, 0,
        0, 0, (3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(7/4199))/2, 0, 0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, (-5*sqrt(7/12597))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(7/8398), 0, 0, 0, -5*sqrt(7/277134), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(7/12597))/2, 0,
        -5*sqrt(7/277134), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -32/sqrt(138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/277134), 0, (-5*sqrt(7/12597))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/277134), 0, 0, 0, -1/2*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -32/sqrt(138567), 0, 0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(7/12597))/2, 0,
        0, 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/8398), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/646), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-7*sqrt(7/41990))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/646), 0, 0, 0, 0, 0, sqrt(91/35530), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(21/3230), 0, 0, 0, -sqrt(210/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-7*sqrt(7/41990))/2, 0, sqrt(91/35530), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(2/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(91/35530), 0, (-7*sqrt(7/41990))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(210/46189), 0, 0, 0, -sqrt(21/3230), 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/35530), 0, 0, 0, 0, 0, -1/2*sqrt(15/646), 0, 0, 0, 0, 0,
        0, 0, sqrt(2/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(7/41990))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/3230), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/646), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(33/3230)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/3230)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/3230)/2, 0, 0, 0, -sqrt(21/41990), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(77/3230)/2, 0, sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/4199), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(77/20995), 0, sqrt(77/3230)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(21/41990), 0, 0, 0, sqrt(33/3230)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/41990), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(55/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/3230)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/3230)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(11/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(77/62985), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(154/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(154/20995), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/4845), 0, -2*sqrt(77/62985), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(22/4845), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(77/62985), 0, -1/2*sqrt(11/4845), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(154/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/20995), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(77/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(22/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/4845), 0,
        0, 0, 0, 0, 0,
    ]),
    # split

    (7, 7, 7): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(13/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(1615), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1615), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/4845), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/9690),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/4845), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3/sqrt(1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/646), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(13/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/9690), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/4845), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2*sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/3230), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/4845), 0, 2*sqrt(7/4845), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(39/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/4845), 0, sqrt(13/4845),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/3230),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(7/4845), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(39/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(13/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1615), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/20995), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3/sqrt(1615), 0, 0, 0, -sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2*sqrt(7/4845), 0, sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(17/7410), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(21/41990), 0, -2*sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/20995), 0, 0, 0, -3/sqrt(1615),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/7410), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(7/4845), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/646),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/3230), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/646), 0, 0, 0, 0,
        0, sqrt(154/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(21/41990), 0, -sqrt(154/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -31/sqrt(125970), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(154/62985), 0, -sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/62985), 0, 0, 0, 0, 0, sqrt(5/646),
        0, 0, 0, 0, 0, 0, 0, 31/sqrt(125970), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/3230),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/646), 0, 0, 0, 0,
        0, 0, 0, sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/20995), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, -sqrt(154/62985), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/20995), 0, 0,
        0, sqrt(35/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(154/62985), 0, -sqrt(35/12597), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/41990), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/12597), 0, sqrt(154/62985), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(35/12597), 0, 0, 0, sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/41990), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/62985), 0, 0, 0, 0, 0, -sqrt(5/646),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(5/646), 0, 0, 0, 0, 0, -3/sqrt(1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1615), 0, 0, 0, sqrt(77/20995),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(77/20995), 0, 0, 0, -sqrt(35/12597), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/12597),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(5/25194),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/12597), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(35/12597), 0, 0, 0, -sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/20995), 0, 0, 0, 3/sqrt(1615),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3/sqrt(1615), 0, 0, 0, sqrt(13/4845), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(13/4845), 0, -2*sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 2*sqrt(7/4845), 0, -sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/41990), 0, sqrt(154/62985),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/62985), 0, sqrt(35/12597), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 5*sqrt(5/25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/25194), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/12597), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/12597), 0, -sqrt(154/62985), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(154/62985), 0, sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(21/41990), 0, 2*sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/4845), 0, -sqrt(13/4845),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/4845), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/9690), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(39/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/7410), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31/sqrt(125970), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/25194),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/25194), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 5*sqrt(5/25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(5/25194), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -31/sqrt(125970), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(17/7410), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(13/9690), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/4845), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 2*sqrt(7/4845), 0, -sqrt(13/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(21/41990), 0, 2*sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/62985), 0, sqrt(21/41990), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/12597), 0, -sqrt(154/62985), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(35/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(5/25194), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/25194), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/12597),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(154/62985), 0, sqrt(35/12597), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(21/41990), 0, sqrt(154/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2*sqrt(7/4845), 0, -sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/4845), 0, -2*sqrt(7/4845), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/4845), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1615), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(77/20995), 0, 0, 0, 3/sqrt(1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/12597), 0, 0, 0, -sqrt(77/20995), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 5*sqrt(5/25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(35/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/25194), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/20995), 0, 0,
        0, -sqrt(35/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3/sqrt(1615), 0, 0, 0, sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(1615), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(154/62985), 0, 0, 0, 0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, -sqrt(3/41990), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/12597), 0, 0, 0, sqrt(77/20995), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/12597), 0, sqrt(154/62985), 0, 0, 0, 0, 0, 0, 0, sqrt(3/41990),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/62985), 0, -sqrt(35/12597), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(77/20995), 0, 0, 0, sqrt(35/12597), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/646), 0, 0, 0, 0,
        0, -sqrt(154/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/20995), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/3230),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/41990), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -31/sqrt(125970), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(154/62985), 0, 0, 0, 0, 0, sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/62985), 0, -sqrt(21/41990), 0, 0,
        0, 0, 0, 31/sqrt(125970), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/41990), 0, -sqrt(154/62985),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, sqrt(154/62985), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/3230), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -2*sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(17/7410), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/41990), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(77/20995), 0, 0, 0, -3/sqrt(1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(21/41990), 0, -2*sqrt(7/4845), 0, 0, 0, sqrt(17/7410), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 2*sqrt(7/4845), 0, sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1615), 0, 0, 0, -sqrt(77/20995),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/20995), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 2*sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1615), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/4845), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(39/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -2*sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/3230),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 2*sqrt(7/4845), 0, sqrt(13/4845), 0, -sqrt(39/3230), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(13/4845), 0, 2*sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/3230), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(13/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/9690), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/4845), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(1615), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/4845), 0, sqrt(13/9690), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/4845), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 3/sqrt(1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/646),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(1615), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/4845), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (0, 8, 8): np.array([
        1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(17),
    ]),
    # split

    (1, 7, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(255), 0, -(1/sqrt(34)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(85), 0, -1/4*sqrt(7/17), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*1/sqrt(170), 0, -1/4*sqrt(91/255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*1/sqrt(102), 0, -1/2*sqrt(13/170), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(17), 0,
        -1/2*sqrt(11/170), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(7/85), 0, -1/4*sqrt(11/51), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/510), 0, -1/4*sqrt(3/17), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(3/170), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(3/17)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/51)/4, 0,
        sqrt(7/85)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/170)/2, 0, 1/(4*sqrt(17)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/170)/2, 0, 1/(2*sqrt(102)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(91/255)/4, 0, 1/(2*sqrt(170)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(7/17)/4, 0, 1/(4*sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(34), 0,
        1/(4*sqrt(255)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(34)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/510), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/170)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/85), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/102)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(34), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(21/170)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(2/255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(21/170)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(34), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/102)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/85), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/170)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/510), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(34)), 0, 1/sqrt(34), 0, -1/4*1/sqrt(255), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/17)/4, 0, -1/4*1/sqrt(85), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(91/255)/4, 0, -1/2*1/sqrt(170), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(13/170)/2, 0, -1/2*1/sqrt(102), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(11/170)/2, 0, -1/4*1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(11/51)/4, 0, -1/4*sqrt(7/85), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/17)/4, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/170), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/510), 0, sqrt(3/17)/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(7/85), 0, sqrt(11/51)/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(17), 0, sqrt(11/170)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(102), 0, sqrt(13/170)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*1/sqrt(170), 0, sqrt(91/255)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/4*1/sqrt(85), 0, sqrt(7/17)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/4*1/sqrt(255), 0, 1/sqrt(34),
    ]),
    # split

    (1, 8, 8): np.array([
        0, 1/(3*sqrt(34)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(34), 0, sqrt(5/51)/4,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(5/51), 0, sqrt(7/51)/4, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(7/51), 0, sqrt(13/34)/6, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(13/34), 0, sqrt(5/102)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/102), 0, sqrt(11/51)/4, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/51), 0, sqrt(35/17)/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/12*sqrt(35/17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(34)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(34), 0, -1/12*sqrt(35/17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/17)/12,
        0, -1/4*sqrt(11/51), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/51)/4, 0, -1/2*sqrt(5/102),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/102)/2, 0, -1/6*sqrt(13/34), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/34)/6, 0, -1/4*sqrt(7/51), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/51)/4, 0, -1/4*sqrt(5/51), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/51)/4, 0, -1/3*1/sqrt(34), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(34)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (2*sqrt(2/17))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 7/(6*sqrt(34)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(34), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(6*sqrt(34)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/17)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(2*sqrt(34)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/(3*sqrt(34)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(6*sqrt(34)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*1/sqrt(34), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/3*1/sqrt(34), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*1/sqrt(34), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(2/17), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(6*sqrt(34)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(34)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -7/(6*sqrt(34)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-2*sqrt(2/17))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(34), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(5/51), 0, -1/3*1/sqrt(34), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/4*sqrt(7/51), 0, -1/4*sqrt(5/51), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/6*sqrt(13/34), 0, -1/4*sqrt(7/51), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/102), 0, -1/6*sqrt(13/34),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/51), 0, -1/2*sqrt(5/102), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/12*sqrt(35/17), 0, -1/4*sqrt(11/51), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(34)), 0, -1/12*sqrt(35/17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(34), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/17)/12, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/51)/4, 0, sqrt(35/17)/12, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/102)/2, 0, sqrt(11/51)/4, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(13/34)/6, 0, sqrt(5/102)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(7/51)/4, 0, sqrt(13/34)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/51)/4, 0, sqrt(7/51)/4,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(34)), 0, sqrt(5/51)/4, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(34)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (2, 6, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(15470)), 0, 0, 0, -(1/sqrt(34)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(3094)), 0, 0, 0, -1/2*sqrt(3/34), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(3/3094)/2, 0, 0, 0, -1/2*sqrt(11/170), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/(2*sqrt(442)), 0, 0, 0, -1/2*sqrt(11/238), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(442), 0, 0, 0,
        (-3*sqrt(11/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(1105)), 0, -1/2*sqrt(33/1547), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(33/1547)/2, 0, -3/(2*sqrt(1105)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(11/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/238)/2, 0, 0, 0,
        -1/2*1/sqrt(442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/170)/2, 0, 0, 0, -1/2*sqrt(3/3094), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/34)/2, 0, 0, 0, -1/2*1/sqrt(3094), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(34), 0, 0, 0, -1/2*1/sqrt(15470), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(1190), 0, -1/2*1/sqrt(34), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/7735), 0, -(1/sqrt(85)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(11/1547), 0, -1/2*sqrt(33/595), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(5/1547), 0, -sqrt(22/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(442)), 0,
        -1/2*sqrt(165/3094), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(1105), 0, -3*sqrt(2/1547), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 3*sqrt(2/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(165/3094)/2, 0, 3/(2*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(22/1547), 0,
        sqrt(5/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/595)/2, 0, sqrt(11/1547)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(85), 0, sqrt(6/7735), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/(2*sqrt(34)), 0, 1/(2*sqrt(1190)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/(2*sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 3/sqrt(1190), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3*sqrt(11/7735), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/3094), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(15/1547))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/1105), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(7/1105), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(15/1547))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(55/3094), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3*sqrt(11/7735), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 3/sqrt(1190), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/(2*sqrt(85)), 0, 0, 0, 1/(2*sqrt(34)), 0, -1/2*1/sqrt(1190), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(85), 0, -sqrt(6/7735), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(33/595)/2, 0, -1/2*sqrt(11/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(22/1547), 0,
        -sqrt(5/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(165/3094)/2, 0, -3/(2*sqrt(442)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(2/1547), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/1105), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(1105), 0, 3*sqrt(2/1547), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(442)), 0, sqrt(165/3094)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(5/1547), 0, sqrt(22/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(11/1547), 0, sqrt(33/595)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(6/7735), 0, 1/sqrt(85), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*1/sqrt(1190), 0, 1/(2*sqrt(34)), 0, 1/sqrt(34), 0, 0, 0, 1/(2*sqrt(15470)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(3/34)/2, 0, 0, 0, 1/(2*sqrt(3094)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(11/170)/2, 0, 0, 0, sqrt(3/3094)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/238)/2, 0,
        0, 0, 1/(2*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(11/3094))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/1547)/2, 0, 3/(2*sqrt(1105)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/442), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(1105)), 0, sqrt(33/1547)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(442), 0, 0, 0, (3*sqrt(11/3094))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/(2*sqrt(442)), 0, 0, 0, sqrt(11/238)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(3/3094)/2, 0, 0, 0, sqrt(11/170)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/(2*sqrt(3094)), 0, 0, 0, sqrt(3/34)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/(2*sqrt(15470)), 0, 0, 0, 1/sqrt(34),
    ]),
    # split

    (2, 7, 8): np.array([
        0, 0, 0, 1/(6*sqrt(170)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(17)), 0, 0,
        0, sqrt(13/595)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/34)/6, 0, 0, 0, 1/sqrt(714),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/255)/2, 0, 0, 0, sqrt(11/119)/6, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/1190)/3, 0, 0, 0, sqrt(5/34)/6, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/119)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(11/238)/2, 0, sqrt(2/255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(51), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(2/255), 0, sqrt(11/238)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(85), 0, 0, 0, sqrt(55/119)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/34)/6,
        0, 0, 0, sqrt(143/1190)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/119)/6, 0, 0,
        0, sqrt(13/255)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(714), 0, 0, 0, sqrt(13/34)/6,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/595)/6, 0, 0, 0, 1/(3*sqrt(17)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(6*sqrt(170)), 0, 0, 0, -1/3*sqrt(7/34), 0, -1/4*sqrt(7/255), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(12*sqrt(17)), 0, -19/(12*sqrt(595)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(13/255), 0, -1/6*sqrt(17/70), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(13/1190), 0, -5/(2*sqrt(714)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(11/1190)/6, 0, -13/(12*sqrt(119)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/357)/4, 0, -11/(12*sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 5/(4*sqrt(357)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/510), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/170),
        0, 5/(4*sqrt(357)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/(12*sqrt(85)), 0, sqrt(11/357)/4,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -13/(12*sqrt(119)), 0, sqrt(11/1190)/6, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(2*sqrt(714)), 0, -1/6*sqrt(13/1190), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(17/70), 0, -1/4*sqrt(13/255), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -19/(12*sqrt(595)), 0, -5/(12*sqrt(17)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(7/255), 0, -1/3*sqrt(7/34), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(7/102), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(2/85), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(65/714), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(2/1785), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/238), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(2/357), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*1/sqrt(170), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(170)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/357), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/238)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 4*sqrt(2/1785), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/714)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/85), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/102)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/255)/4,
        0, -1/3*sqrt(7/34), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19/(12*sqrt(595)), 0, -5/(12*sqrt(17)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/70)/6, 0, -1/4*sqrt(13/255), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(714)), 0, -1/6*sqrt(13/1190), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 13/(12*sqrt(119)), 0, sqrt(11/1190)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11/(12*sqrt(85)),
        0, sqrt(11/357)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/170), 0, 5/(4*sqrt(357)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/510), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -5/(4*sqrt(357)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/4*sqrt(11/357), 0, -11/(12*sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(11/1190),
        0, -13/(12*sqrt(119)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/1190)/6, 0, -5/(2*sqrt(714)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/255)/4, 0, -1/6*sqrt(17/70), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 5/(12*sqrt(17)), 0, -19/(12*sqrt(595)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/34)/3, 0, -1/4*sqrt(7/255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*1/sqrt(170), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(13/595), 0, 0, 0, 1/(3*sqrt(17)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(714)), 0, 0, 0, sqrt(13/34)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/6*sqrt(11/119), 0, 0, 0, sqrt(13/255)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(5/34), 0, 0,
        0, sqrt(143/1190)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(85)), 0, 0, 0, sqrt(55/119)/6, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/255), 0, sqrt(11/238)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(51)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(11/238), 0, sqrt(2/255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(55/119), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(143/1190), 0, 0, 0, sqrt(5/34)/6, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/255), 0, 0, 0, sqrt(11/119)/6, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/6*sqrt(13/34), 0, 0, 0, 1/sqrt(714), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/3*1/sqrt(17), 0, 0, 0, sqrt(13/595)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/(6*sqrt(170)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (2, 8, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(969)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(91/4845), 0, 0, 0, 1/sqrt(969), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(13/1938), 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/323), 0,
        0, 0, sqrt(91/4845)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/1938), 0, 0, 0, sqrt(13/1938), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/323), 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(2/1615), 0, sqrt(77/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(7/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/1938), 0,
        3*sqrt(2/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/1938), 0, 0, 0, sqrt(77/1938)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(91/4845), 0, 0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(7/646), 0, 0, 0, sqrt(13/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(969)), 0,
        0, 0, sqrt(91/4845)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/646)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(969), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        13/(4*sqrt(969)), 0, -sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(7/4845))/4, 0, -13/(4*sqrt(969)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(13/3230))/2, 0, (-11*sqrt(7/4845))/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(1938)), 0, (-3*sqrt(13/3230))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(55/969)/4, 0, -7/(2*sqrt(1938)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/323)/4, 0, -1/4*sqrt(55/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(3230), 0, -1/4*sqrt(7/323), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(3230), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/323)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(55/969)/4, 0, -1/4*sqrt(7/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        7/(2*sqrt(1938)), 0, -1/4*sqrt(55/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(13/3230))/2, 0, -7/(2*sqrt(1938)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(7/4845))/4, 0, (-3*sqrt(13/3230))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 13/(4*sqrt(969)), 0, (-11*sqrt(7/4845))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/646), 0, -13/(4*sqrt(969)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(10/969), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(5/1938))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/1615), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(9690), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(10/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 23/(2*sqrt(9690)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(6/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        23/(2*sqrt(9690)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(10/969), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/646)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/4845), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(9690), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(5/1938))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -2*sqrt(10/969), 0, sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(5/646), 0, 13/(4*sqrt(969)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 13/(4*sqrt(969)), 0, (11*sqrt(7/4845))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (11*sqrt(7/4845))/4, 0, (3*sqrt(13/3230))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(13/3230))/2, 0,
        7/(2*sqrt(1938)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(1938)), 0, sqrt(55/969)/4, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/969)/4, 0, sqrt(7/323)/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/323)/4, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(3230), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(3230), 0, sqrt(7/323)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(7/323)/4, 0, sqrt(55/969)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(55/969)/4, 0, 7/(2*sqrt(1938)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 7/(2*sqrt(1938)), 0, (3*sqrt(13/3230))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(13/3230))/2, 0, (11*sqrt(7/4845))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(7/4845))/4, 0,
        13/(4*sqrt(969)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13/(4*sqrt(969)), 0, sqrt(5/646), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/646), 0, 0, 0, -(1/sqrt(969)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/646), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(969)), 0, 0, 0, -1/2*sqrt(91/4845), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/646), 0, 0, 0, -sqrt(13/1938), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(91/4845), 0, 0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(13/1938), 0, 0, 0, -1/2*sqrt(77/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(77/1938), 0, -3*sqrt(2/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(7/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(2/1615), 0,
        -1/2*sqrt(77/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/323), 0, 0, 0, -1/2*sqrt(11/323), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/1938), 0, 0, 0, -sqrt(13/1938), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/323), 0, 0, 0, -1/2*sqrt(91/4845), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/1938), 0, 0, 0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(91/4845), 0, 0, 0, -(1/sqrt(969)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(969)), 0, 0,
    ]),
    # split

    (3, 5, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(17017), 0, 0, 0, 0, 0, -(1/sqrt(34)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/4*1/sqrt(2431), 0, 0, 0, 0, 0, -1/4*sqrt(5/17), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(4862)), 0, 0, 0, 0, 0, -1/4*sqrt(3/17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(3/2431)/2, 0, 0, 0, -1/2*sqrt(3/119), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/4862), 0,
        -1/2*sqrt(3/221), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/221)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(3/221)/2, 0, -1/2*sqrt(15/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(3/119)/2, 0, 0, 0, sqrt(3/2431)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/17)/4, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/17)/4, 0, 0, 0, 0, 0,
        1/(4*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(34), 0, 0, 0, 0, 0, 1/(4*sqrt(17017)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(4*sqrt(1547)), 0,
        0, 0, -1/4*sqrt(3/17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/17017)/2, 0, 0, 0, -1/2*1/sqrt(17), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/2431))/4, 0, 0, 0, (-3*sqrt(3/119))/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(2/2431), 0, 0, 0, -3*sqrt(2/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-3*sqrt(7/4862))/2, 0, -1/2*sqrt(15/442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/2431), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/442)/2, 0, (-3*sqrt(7/4862))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(2/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (3*sqrt(3/119))/4, 0, 0, 0, (-3*sqrt(3/2431))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/(2*sqrt(17)), 0, 0, 0, -1/2*sqrt(15/17017), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/17)/4, 0,
        0, 0, -1/4*1/sqrt(1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(3/3094), 0, -1/4*1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -5/(4*sqrt(1547)), 0, -1/4*sqrt(15/119), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-15*sqrt(3/17017))/4, 0,
        (-3*sqrt(15/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(5/2431))/2, 0, (-5*sqrt(3/1547))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/2431), 0, -15/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (3*sqrt(21/2431))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 15/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(3/1547))/2, 0,
        (3*sqrt(5/2431))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(15/3094))/2, 0, (15*sqrt(3/17017))/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/119)/4, 0, 5/(4*sqrt(1547)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/(4*sqrt(17)), 0, sqrt(3/3094)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/(2*sqrt(119)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(10/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (5*sqrt(3/1547))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10*sqrt(3/17017), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(105/4862), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(14/2431), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(105/4862), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10*sqrt(3/17017), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(3/1547))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(10/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/(2*sqrt(119)), 0, 0, 0, 0, 0, 1/(4*sqrt(17)), 0, -1/2*sqrt(3/3094), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/119)/4, 0, -5/(4*sqrt(1547)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (3*sqrt(15/3094))/2, 0, (-15*sqrt(3/17017))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (5*sqrt(3/1547))/2, 0, (-3*sqrt(5/2431))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 15/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (3*sqrt(21/2431))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/2431), 0,
        15/(2*sqrt(4862)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(5/2431))/2, 0, (5*sqrt(3/1547))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-15*sqrt(3/17017))/4, 0, (3*sqrt(15/3094))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(4*sqrt(1547)), 0, sqrt(15/119)/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/3094), 0, 1/(4*sqrt(17)), 0, 0, 0, sqrt(3/17)/4, 0, 0, 0,
        1/(4*sqrt(1547)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(17)), 0, 0, 0, sqrt(15/17017)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/119))/4, 0, 0, 0, (3*sqrt(3/2431))/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(2/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/442)/2, 0, (3*sqrt(7/4862))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-3*sqrt(7/4862))/2, 0, sqrt(15/442)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(2/2431), 0, 0, 0, 3*sqrt(2/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(3/2431))/4, 0, 0, 0, (3*sqrt(3/119))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/17017)/2, 0,
        0, 0, 1/(2*sqrt(17)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(4*sqrt(1547)), 0, 0, 0,
        sqrt(3/17)/4, 0, 1/sqrt(34), 0, 0, 0, 0, 0, -1/4*1/sqrt(17017), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/17)/4, 0, 0, 0, 0, 0, -1/4*1/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/17)/4, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/119)/2, 0, 0, 0,
        -1/2*sqrt(3/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/221)/2, 0, sqrt(15/4862)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/221)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/4862), 0, sqrt(3/221)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/2431)/2, 0, 0, 0, sqrt(3/119)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -(1/sqrt(4862)), 0, 0, 0, 0, 0, sqrt(3/17)/4, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/4*1/sqrt(2431), 0, 0, 0, 0, 0, sqrt(5/17)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/4*1/sqrt(17017), 0, 0, 0, 0, 0, 1/sqrt(34),
    ]),
    # split

    (3, 6, 8): np.array([
        0, 0, 0, 0, 0, 1/(2*sqrt(9282)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(102)), 0, 0,
        0, 0, 0, sqrt(11/4641)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/51), 0, 0, 0, 0,
        0, sqrt(5/663)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/51), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/238), 0, 0, 0, 1/sqrt(442), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/1547), 0, -1/2*sqrt(7/442), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/221), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/442)/2, 0, -1/2*sqrt(55/1547), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(442)), 0, 0, 0, -1/2*sqrt(11/238), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/sqrt(442), 0, 0, 0, 0, 0, -1/4*sqrt(11/51), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/663)/4,
        0, 0, 0, 0, 0, -1/4*sqrt(11/51), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/4641)/4, 0, 0,
        0, 0, 0, -(1/sqrt(102)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(9282)), 0, 0, 0, 0,
        0, 1/sqrt(51), 0, 0, 0, -1/2*sqrt(5/4641), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(4*sqrt(17)),
        0, 0, 0, (-3*sqrt(3/1547))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2/sqrt(1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/357), 0, 0, 0, -7/(4*sqrt(663)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(33/1547), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(11/3094))/2, 0, -1/2*sqrt(15/442), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(221), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/442)/2, 0, (-3*sqrt(11/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(3/221), 0, 0, 0, -1/2*sqrt(33/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -7/(4*sqrt(663)), 0, 0, 0, -1/4*sqrt(11/357), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2/sqrt(1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/1547))/4,
        0, 0, 0, 1/(4*sqrt(17)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/4641), 0, 0,
        0, 1/sqrt(51), 0, sqrt(5/102)/2, 0, 1/sqrt(714), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(3/17)/4, 0, sqrt(7/442)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/119)/4,
        0, sqrt(165/1547)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/9282)/2, 0, 25/(4*sqrt(4641)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/442)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/3094), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/221), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/221), 0, -1/2*sqrt(15/3094), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(15/442)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 25/(4*sqrt(4641)), 0, sqrt(55/9282)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(165/1547)/4, 0, sqrt(11/119)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(7/442)/2, 0, sqrt(3/17)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(714),
        0, sqrt(5/102)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(102), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(357)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(22/4641), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (5*sqrt(11/4641))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 5/sqrt(3094), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(442), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -5/sqrt(3094), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-5*sqrt(11/4641))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(22/4641), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/(2*sqrt(357)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(102)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(714)), 0, sqrt(5/102)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/442), 0, sqrt(3/17)/4, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(165/1547), 0, sqrt(11/119)/4, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -25/(4*sqrt(4641)), 0, sqrt(55/9282)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(15/442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/221), 0, -1/2*sqrt(15/3094),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/221)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/3094)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(15/442)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(55/9282), 0, 25/(4*sqrt(4641)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/119), 0, sqrt(165/1547)/4,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(3/17), 0, sqrt(7/442)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/102), 0, 1/sqrt(714), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/4641)/2, 0, 0,
        0, 1/sqrt(51), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/1547))/4, 0, 0, 0, 1/(4*sqrt(17)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 7/(4*sqrt(663)), 0, 0, 0, -1/4*sqrt(11/357), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(3/221), 0, 0, 0, -1/2*sqrt(33/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/442),
        0, (-3*sqrt(11/3094))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(221), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(11/3094))/2, 0, -1/2*sqrt(15/442), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(33/1547)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(11/357)/4, 0, 0, 0, -7/(4*sqrt(663)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2/sqrt(1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(17), 0, 0, 0, (-3*sqrt(3/1547))/4, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(51)), 0, 0, 0, -1/2*sqrt(5/4641), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(9282), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(11/4641), 0, 0, 0, 0, 0, -(1/sqrt(102)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(5/663), 0, 0, 0, 0, 0, -1/4*sqrt(11/51), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(442)), 0, 0, 0, 0, 0, -1/4*sqrt(11/51), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(442), 0, 0, 0, -1/2*sqrt(11/238), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(7/442), 0, -1/2*sqrt(55/1547), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/221)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/1547)/2, 0, -1/2*sqrt(7/442), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/238)/2, 0, 0, 0, 1/sqrt(442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(11/51)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/51)/4, 0, 0,
        0, 0, 0, sqrt(5/663)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(102), 0, 0, 0, 0, 0, sqrt(11/4641)/4,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(9282)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (3, 7, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(1938)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/2261)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(165/29393)/2, 0, 0, 0, 0, 0, sqrt(5/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (5*sqrt(11/25194))/2, 0, 0, 0, 0, 0, sqrt(15/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(3/8398), 0, 0, 0,
        0, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/4199), 0, 0, 0, (5*sqrt(11/6783))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/4199), 0, (15*sqrt(11/58786))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(165/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-15*sqrt(11/58786))/2, 0, sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(11/6783))/2, 0, 0, 0,
        -3*sqrt(3/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/646), 0, 0, 0, 0, 0, (-5*sqrt(11/25194))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(5/1938), 0, 0, 0, 0, 0, -1/2*sqrt(165/29393), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(5/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*1/sqrt(1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(13/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -23/(6*sqrt(4522)), 0, 0, 0, -1/3*sqrt(65/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -10*sqrt(5/88179), 0, 0, 0, (-5*sqrt(5/323))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(935/3458), 0, 0, 0,
        -7/(2*sqrt(1938)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -35/(6*sqrt(4199)), 0, 0, 0, (-2*sqrt(11/2261))/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -11/sqrt(8398), 0, 0, 0, (-5*sqrt(11/58786))/6, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 8/sqrt(12597), 0, sqrt(55/29393)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -5*sqrt(5/25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/29393), 0, 8/sqrt(12597), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/58786))/6, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (2*sqrt(11/2261))/3, 0, 0, 0, 35/(6*sqrt(4199)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 7/(2*sqrt(1938)), 0, 0, 0, sqrt(935/3458)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (5*sqrt(5/323))/6, 0, 0, 0, 10*sqrt(5/88179), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/646)/3, 0, 0, 0,
        23/(6*sqrt(4522)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/323)/6, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(91/4845)/2, 0, sqrt(91/646)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (8*sqrt(13/11305))/3, 0, sqrt(13/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (43*sqrt(7/41990))/6, 0, -2/sqrt(4845), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67/(2*sqrt(176358)), 0, -59/(6*sqrt(22610)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 29/(3*sqrt(29393)), 0, (-79*sqrt(11/293930))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 23/(6*sqrt(20995)), 0, -sqrt(77/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(3/41990), 0, -37/(2*sqrt(88179)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(7/125970), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37/(2*sqrt(88179)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/12597), 0, -23/(6*sqrt(20995)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (79*sqrt(11/293930))/6, 0, -29/(3*sqrt(29393)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        59/(6*sqrt(22610)), 0, -67/(2*sqrt(176358)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(4845), 0, (-43*sqrt(7/41990))/6, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(13/323), 0, (-8*sqrt(13/11305))/3, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(91/646), 0, -1/2*sqrt(91/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(91/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-3*sqrt(13/1615))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -31/(2*sqrt(33915)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(17/25935), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(11/29393))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43/(2*sqrt(88179)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(20995)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(7/20995), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(20995)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 43/(2*sqrt(88179)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (3*sqrt(11/29393))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(17/25935), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -31/(2*sqrt(33915)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-3*sqrt(13/1615))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(91/969), 0,
        -1/3*sqrt(91/646), 0, sqrt(91/4845)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(13/323), 0,
        (8*sqrt(13/11305))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(4845), 0, (43*sqrt(7/41990))/6, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 59/(6*sqrt(22610)), 0, 67/(2*sqrt(176358)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (79*sqrt(11/293930))/6, 0, 29/(3*sqrt(29393)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/12597), 0, 23/(6*sqrt(20995)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 37/(2*sqrt(88179)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(7/125970), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(3/41990), 0, 37/(2*sqrt(88179)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 23/(6*sqrt(20995)), 0, sqrt(77/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        29/(3*sqrt(29393)), 0, (79*sqrt(11/293930))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67/(2*sqrt(176358)), 0,
        59/(6*sqrt(22610)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (43*sqrt(7/41990))/6, 0, 2/sqrt(4845), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (8*sqrt(13/11305))/3, 0, -1/6*sqrt(13/323), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/4845)/2, 0, -1/3*sqrt(91/646), 0, 0, 0, -1/6*sqrt(13/323), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/646)/3, 0, 0, 0, -23/(6*sqrt(4522)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/323))/6, 0, 0, 0, -10*sqrt(5/88179), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(1938)), 0, 0, 0, -1/6*sqrt(935/3458), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (2*sqrt(11/2261))/3, 0, 0, 0, -35/(6*sqrt(4199)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (5*sqrt(11/58786))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(55/29393), 0, -8/sqrt(12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -5*sqrt(5/25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        8/sqrt(12597), 0, -1/2*sqrt(55/29393), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/sqrt(8398), 0, 0, 0,
        (5*sqrt(11/58786))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -35/(6*sqrt(4199)), 0, 0, 0, (2*sqrt(11/2261))/3, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(935/3458), 0, 0, 0, 7/(2*sqrt(1938)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -10*sqrt(5/88179), 0, 0, 0, (5*sqrt(5/323))/6, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -23/(6*sqrt(4522)), 0, 0, 0, sqrt(65/646)/3, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/6*sqrt(13/323), 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(1938)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/2261)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(5/1938), 0, 0, 0, 0, 0, sqrt(165/29393)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(15/646), 0, 0, 0, 0, 0, (5*sqrt(11/25194))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(11/6783))/2, 0,
        0, 0, 3*sqrt(3/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-15*sqrt(11/58786))/2, 0, -sqrt(35/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(165/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/4199), 0, (-15*sqrt(11/58786))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/4199), 0, 0, 0, (-5*sqrt(11/6783))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(3/8398), 0, 0, 0, 0, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (5*sqrt(11/25194))/2, 0, 0, 0, 0, 0, -1/2*sqrt(15/646), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(165/29393)/2, 0, 0, 0, 0, 0, -sqrt(5/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(5/2261)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/(2*sqrt(1938)), 0, 0, 0, 0,
    ]),
    # split

    (3, 8, 8): np.array([
        0, 0, 0, 1/sqrt(1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(13/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/969)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(1938)), 0, 0, 0, 0, 0, sqrt(143/6783)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/1938), 0, 0, 0, 0, 0, sqrt(55/1938)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(143/6783), 0, 0, 0, sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(55/1938), 0, -sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(11/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(3/323), 0, -1/2*sqrt(55/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/323),
        0, 0, 0, -1/2*sqrt(143/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/646), 0, 0, 0, 0,
        0, -1/2*sqrt(13/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/1938)/2, 0, 0, 0, 0, 0, -1/2*sqrt(13/1938),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/6783)/2, 0, 0, 0, 0, 0, -(1/sqrt(1938)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(13/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/sqrt(1938), 0, 0, 0, 0, 0, -sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/1938), 0, 0, 0, -1/2*sqrt(65/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 3/(2*sqrt(323)), 0, 0, 0, -2*sqrt(13/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/1938)/2,
        0, 0, 0, (-3*sqrt(11/4522))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(13/6783), 0, 0,
        0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(11/4522))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/969)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(646), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/969)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -(1/sqrt(646)), 0, 0, 0, (3*sqrt(11/4522))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(11/969), 0, 0, 0, 2*sqrt(13/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (-3*sqrt(11/4522))/2, 0, 0, 0, sqrt(65/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2*sqrt(13/6783), 0, 0, 0, 3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(65/1938),
        0, 0, 0, sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/1938), 0, 0, 0, sqrt(7/646),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/646), 0, sqrt(35/969)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(35/969), 0, 2/sqrt(969), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(969), 0, sqrt(13/4522)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/4522), 0, -1/2*sqrt(5/13566), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(5/13566)/2, 0, -sqrt(11/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/6783), 0, -1/2*sqrt(5/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(5/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/646),
        0, sqrt(5/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/323), 0, sqrt(11/6783),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/6783), 0, sqrt(5/13566)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/13566), 0, -1/2*sqrt(13/4522), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/4522)/2, 0, -2/sqrt(969), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(969), 0, -1/2*sqrt(35/969), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(35/969)/2, 0, -sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 2*sqrt(7/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/969)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/969), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(3/2261))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(17/399), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -13/(2*sqrt(6783)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/969), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 13/(2*sqrt(6783)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/399)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/2261), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(3/2261))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(7/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/969),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(35/969), 0, -sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -2/sqrt(969), 0, -1/2*sqrt(35/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/4522),
        0, -2/sqrt(969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/13566)/2, 0, -1/2*sqrt(13/4522), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/6783), 0, sqrt(5/13566)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(5/323)/2, 0, sqrt(11/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/646), 0, sqrt(5/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/646),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/323), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/6783), 0, -1/2*sqrt(5/323), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/13566), 0, -sqrt(11/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(13/4522)/2, 0, -1/2*sqrt(5/13566), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(969),
        0, sqrt(13/4522)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/969)/2, 0, 2/sqrt(969), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/646), 0, sqrt(35/969)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1938),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(323)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/1938)/2, 0, 0, 0, sqrt(7/1938), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 2*sqrt(13/6783), 0, 0, 0, 3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (3*sqrt(11/4522))/2, 0, 0, 0, sqrt(65/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/969)/2,
        0, 0, 0, 2*sqrt(13/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(646), 0, 0, 0, (3*sqrt(11/4522))/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/969)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -(1/sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(11/4522))/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(13/6783), 0, 0, 0, -1/2*sqrt(11/969),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(65/1938), 0, 0, 0, (-3*sqrt(11/4522))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0, -2*sqrt(13/6783), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/1938), 0, 0, 0, -1/2*sqrt(65/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/1938),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -(1/sqrt(1938)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(13/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/969),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(143/6783), 0, 0, 0, 0,
        0, -(1/sqrt(1938)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/1938), 0, 0, 0, 0, 0, -1/2*sqrt(13/1938), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(11/646), 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/323), 0, 0, 0, -1/2*sqrt(143/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(3/323), 0, -1/2*sqrt(55/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/646), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/1938)/2, 0, -sqrt(3/323), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(143/6783)/2, 0, 0, 0, sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(13/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/1938)/2,
        0, 0, 0, 0, 0, sqrt(55/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(1938), 0, 0, 0, 0,
        0, sqrt(143/6783)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/969)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/1938)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0,
    ]),
    # split

    (4, 4, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(24310)), 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(34)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*1/sqrt(12155), 0, 0, 0, 0, 0, -1/2*1/sqrt(17), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/(2*sqrt(2431)), 0, 0, 0, -1/2*sqrt(7/255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*1/sqrt(663), 0, -1/2*1/sqrt(85), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(442), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(85)), 0, -1/2*1/sqrt(663), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/255)/2, 0, 0, 0, 1/(2*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/(2*sqrt(17)), 0, 0, 0, 0, 0, -1/2*1/sqrt(12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(34), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*1/sqrt(12155), 0, 0, 0, 0, 0, -1/2*1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0, (-4*sqrt(2/12155))/3, 0,
        0, 0, 0, 0, -2/sqrt(255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/12155), 0, 0, 0,
        -(1/sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(2431), 0, -2*sqrt(2/1105), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(5/663), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(2/1105), 0, -2/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(85), 0,
        0, 0, sqrt(7/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(255), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(17)), 0, 0, 0, 0, 0, 1/(2*sqrt(12155)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(2431)), 0, 0, 0,
        -1/2*sqrt(7/255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/12155), 0, 0, 0, -(1/sqrt(85)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (14*sqrt(2/12155))/3, 0, 0, 0, -sqrt(14/1105), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -7/sqrt(12155), 0, -sqrt(7/663), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/663), 0, -7/sqrt(12155), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/1105), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(85), 0, 0, 0, -sqrt(7/12155), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/255)/2, 0, 0, 0, -1/2*1/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(663), 0, -1/2*1/sqrt(85), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -2/sqrt(2431), 0, -2*sqrt(2/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -7/sqrt(12155), 0, -sqrt(7/663), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-28*sqrt(2/12155))/3, 0,
        -2*sqrt(7/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(2431), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(7/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(7/663), 0, 7/sqrt(12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(2/1105), 0, 2/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(85)), 0,
        1/(2*sqrt(663)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(442), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/663), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(10/2431))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 7/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(5/663), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(442), 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(85)), 0, -1/2*1/sqrt(663), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(2/1105), 0, -2/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(7/663), 0, -7/sqrt(12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(7/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 7/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-28*sqrt(2/12155))/3, 0,
        2*sqrt(7/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(12155), 0, sqrt(7/663), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(2431), 0, 2*sqrt(2/1105), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(663), 0, 1/(2*sqrt(85)), 0, 0, 0, 0, 0,
        sqrt(7/255)/2, 0, 0, 0, 1/(2*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(85), 0,
        0, 0, sqrt(7/12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/1105), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/663), 0, 7/sqrt(12155), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/2431), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/sqrt(12155), 0, sqrt(7/663), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (14*sqrt(2/12155))/3, 0, 0, 0, sqrt(14/1105), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(7/12155), 0, 0, 0, 1/sqrt(85), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/(2*sqrt(2431)), 0, 0, 0, sqrt(7/255)/2, 0, 0, 0, 1/(2*sqrt(17)), 0, 0, 0, 0, 0, -1/2*1/sqrt(12155), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(255), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(85), 0, 0, 0, -sqrt(7/12155), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(2/1105), 0, 2/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/663), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -2/sqrt(2431), 0, 2*sqrt(2/1105), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(7/12155), 0, 0, 0, 1/sqrt(85), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-4*sqrt(2/12155))/3, 0,
        0, 0, 0, 0, 2/sqrt(255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(12155), 0, 0, 0,
        0, 0, 1/(2*sqrt(17)), 0, 1/sqrt(34), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/(2*sqrt(17)), 0, 0, 0, 0, 0, 1/(2*sqrt(12155)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/255)/2, 0, 0, 0, -1/2*1/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(85)), 0,
        1/(2*sqrt(663)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*1/sqrt(663), 0, 1/(2*sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(2431)), 0, 0, 0,
        sqrt(7/255)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(12155), 0, 0, 0, 0, 0, 1/(2*sqrt(17)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(24310)), 0, 0, 0, 0, 0, 0, 0, 1/sqrt(34),
    ]),
    # split

    (4, 5, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 1/(6*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/17)/3, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(17)), 0, 0, 0, 0,
        0, 2/sqrt(12155), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(85), 0, 0, 0, -sqrt(7/7293), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/255), 0, 1/sqrt(442), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/221), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(442)), 0, sqrt(2/255), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/7293), 0, 0, 0, 1/sqrt(85), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -2/sqrt(12155), 0, 0, 0, 0, 0, 1/(2*sqrt(17)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(2/12155), 0, 0, 0, 0, 0, 0, 0, sqrt(2/17)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(6*sqrt(2431)),
        0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(5/34), 0, 0, 0, 0, 0, -1/12*sqrt(35/2431), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/12*1/sqrt(17), 0, 0, 0, 0, 0, -31/(12*sqrt(12155)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(3/85)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(7/255)/2, 0, 0, 0, -23/(2*sqrt(36465)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11/(2*sqrt(3315)),
        0, 19/(2*sqrt(14586)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(15/221)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -19/(2*sqrt(14586)),
        0, 11/(2*sqrt(3315)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23/(2*sqrt(36465)), 0, 0, 0, sqrt(7/255)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9/sqrt(24310), 0, 0, 0, 0, 0, sqrt(3/85)/4, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -31/(12*sqrt(12155)), 0, 0, 0, 0, 0, -1/12*1/sqrt(17), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/12*sqrt(35/2431), 0, 0, 0, 0, 0, -1/3*sqrt(5/34), 0, -1/12*sqrt(35/17), 0, 0, 0, sqrt(5/663)/4,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/255), 0, 0, 0, sqrt(13/187)/6, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*1/sqrt(85), 0, 0, 0, sqrt(77/1105)/4, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/3315), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/442)/2, 0, 49/(2*sqrt(72930)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -49/(2*sqrt(72930)), 0, sqrt(7/442)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 2*sqrt(42/12155), 0, 0, 0, sqrt(2/3315), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/1105)/4,
        0, 0, 0, -1/4*1/sqrt(85), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/187)/6, 0, 0,
        0, -1/2*sqrt(7/255), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/663)/4, 0, 0, 0, -1/12*sqrt(35/17),
        0, 0, 0, -1/4*sqrt(7/51), 0, -5/(6*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -11/(12*sqrt(85)), 0, -7/(4*sqrt(663)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(2210)),
        0, -1/4*sqrt(17/143), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(221), 0, -1/2*sqrt(91/2805),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/14586)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(2431)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(3/12155), 0, sqrt(7/14586)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(91/2805), 0, -1/2*1/sqrt(221), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(17/143), 0, -7/(2*sqrt(2210)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -7/(4*sqrt(663)), 0, -11/(12*sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -5/(6*sqrt(442)), 0, -1/4*sqrt(7/51), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/6*sqrt(5/17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-4*sqrt(2/221))/3, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/221), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(5/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -7/sqrt(14586), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(14586), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(5/7293), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/221)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (4*sqrt(2/221))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(5/17)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 5/(6*sqrt(442)), 0, -1/4*sqrt(7/51), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 7/(4*sqrt(663)), 0, -11/(12*sqrt(85)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/143)/4,
        0, -7/(2*sqrt(2210)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/2805)/2, 0, -1/2*1/sqrt(221), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(3/12155), 0, sqrt(7/14586)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -7/(2*sqrt(2431)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(7/14586), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(221)),
        0, -1/2*sqrt(91/2805), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/(2*sqrt(2210)), 0, -1/4*sqrt(17/143), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11/(12*sqrt(85)), 0, -7/(4*sqrt(663)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/51)/4, 0, -5/(6*sqrt(442)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(5/663), 0, 0, 0, -1/12*sqrt(35/17), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(13/187), 0, 0, 0, -1/2*sqrt(7/255), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/4*sqrt(77/1105), 0, 0, 0, -1/4*1/sqrt(85), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2*sqrt(42/12155), 0, 0, 0, sqrt(2/3315), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49/(2*sqrt(72930)),
        0, sqrt(7/442)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/2431), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/442), 0, 49/(2*sqrt(72930)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(2/3315), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 1/(4*sqrt(85)), 0, 0, 0, sqrt(77/1105)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/255)/2, 0, 0,
        0, sqrt(13/187)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/17)/12, 0, 0, 0, sqrt(5/663)/4, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/2431)/12,
        0, 0, 0, 0, 0, -1/3*sqrt(5/34), 0, 0, 0, 0, 0, 0, 0, 0, 0, 31/(12*sqrt(12155)), 0, 0, 0, 0,
        0, -1/12*1/sqrt(17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 9/sqrt(24310), 0, 0, 0, 0, 0, sqrt(3/85)/4, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -23/(2*sqrt(36465)), 0, 0, 0, sqrt(7/255)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 19/(2*sqrt(14586)), 0, 11/(2*sqrt(3315)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/221),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/(2*sqrt(3315)), 0, 19/(2*sqrt(14586)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/255), 0, 0, 0, -23/(2*sqrt(36465)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(3/85), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/(12*sqrt(17)), 0, 0, 0, 0, 0, -31/(12*sqrt(12155)), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/34)/3,
        0, 0, 0, 0, 0, -1/12*sqrt(35/2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/6*1/sqrt(2431), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(2/12155), 0, 0, 0, 0, 0, 0, 0, sqrt(2/17)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(12155),
        0, 0, 0, 0, 0, 1/(2*sqrt(17)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/7293), 0, 0,
        0, 1/sqrt(85), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(442), 0, sqrt(2/255), 0, 0,
        0, 0, 0, 0, 0, -sqrt(2/221), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(2/255), 0, 1/sqrt(442), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(85)), 0, 0,
        0, -sqrt(7/7293), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(17), 0, 0, 0, 0, 0, 2/sqrt(12155),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(2/17), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(6*sqrt(2431)), 0, 0, 0, 0, 0, 0,
        0, 0, 0,
    ]),
    # split

    (4, 6, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(25194)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/6*sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(70/46189), 0, 0, 0, 0, 0, 0, 0, sqrt(14/323)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(21/46189), 0, 0, 0, 0, 0, sqrt(35/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(10/138567), 0,
        0, 0, sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(8398), 0, sqrt(10/969), 0,
        0, 0, 0, 0, 0, 0, -sqrt(70/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(10/969), 0, 7/sqrt(8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/646), 0,
        0, 0, -7*sqrt(10/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(35/969), 0, 0, 0, 0, 0,
        2*sqrt(21/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(14/323), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/4199)/6, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(25194), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/8398)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 29/(12*sqrt(4199)), 0, 0, 0, 0, 0, -1/3*sqrt(77/646), 0, 0, 0, 0, 0,
        0, 0, 0, 0, (25*sqrt(35/46189))/12, 0, 0, 0, 0, 0, (-7*sqrt(7/323))/12, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        7*sqrt(21/92378), 0, 0, 0, 0, 0, -1/4*sqrt(7/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(119/16302), 0,
        0, 0, 1/(2*sqrt(1938)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(13/21318))/2, 0, (5*sqrt(5/12597))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(21/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-5*sqrt(5/12597))/2, 0, (7*sqrt(13/21318))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*1/sqrt(1938), 0, 0, 0, -sqrt(119/16302), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/323)/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/323))/12, 0, 0, 0, 0, 0, (-25*sqrt(35/46189))/12, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/646)/3, 0, 0, 0, 0, 0, -29/(12*sqrt(4199)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(165/29393), 0, 0, 0, sqrt(11/969), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-23*sqrt(11/88179))/4, 0, 0, 0, -1/12*sqrt(11/323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -139/(3*sqrt(323323)), 0, 0, 0, -sqrt(5/969), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -127/(4*sqrt(138567)), 0, 0, 0, (-9*sqrt(3/2261))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/3553), 0,
        0, 0, -37/(2*sqrt(88179)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (23*sqrt(5/277134))/2, 0, -1/2*sqrt(13/4522), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(13/4522)/2, 0, (23*sqrt(5/277134))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 37/(2*sqrt(88179)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (9*sqrt(3/2261))/4, 0,
        0, 0, 127/(4*sqrt(138567)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/969), 0, 0, 0, 139/(3*sqrt(323323)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/323)/12, 0, 0, 0, (23*sqrt(11/88179))/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(11/969), 0, 0, 0, sqrt(165/29393)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/13566), 0, sqrt(33/646)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(935/3458)/6, 0, sqrt(55/969)/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 101/(4*sqrt(88179)), 0, -1/12*sqrt(5/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (37*sqrt(15/323323))/4, 0, -43/(2*sqrt(176358)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        29/(2*sqrt(277134)), 0, -4*sqrt(10/29393), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/46189), 0, -199/(2*sqrt(1939938)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(35/46189))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 199/(2*sqrt(1939938)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 4*sqrt(10/29393), 0, -29/(2*sqrt(277134)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        43/(2*sqrt(176358)), 0, (-37*sqrt(15/323323))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/2261)/12, 0, -101/(4*sqrt(88179)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(55/969), 0, -1/6*sqrt(935/3458), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(33/646), 0, -sqrt(55/13566), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(11/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-11*sqrt(11/2261))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-29*sqrt(2/29393))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -5/(2*sqrt(29393)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(13/149226), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47/sqrt(277134), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(14/46189), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47/sqrt(277134), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(13/149226), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -5/(2*sqrt(29393)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-29*sqrt(2/29393))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-11*sqrt(11/2261))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(11/646), 0, 0, 0, -1/2*sqrt(33/646), 0, sqrt(55/13566), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/4*sqrt(55/969), 0, sqrt(935/3458)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(5/2261)/12, 0, 101/(4*sqrt(88179)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        43/(2*sqrt(176358)), 0, (37*sqrt(15/323323))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(10/29393), 0,
        29/(2*sqrt(277134)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 199/(2*sqrt(1939938)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(35/46189))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/46189), 0, 199/(2*sqrt(1939938)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(277134)), 0, 4*sqrt(10/29393), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (37*sqrt(15/323323))/4, 0, 43/(2*sqrt(176358)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 101/(4*sqrt(88179)), 0, sqrt(5/2261)/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(935/3458)/6, 0, -1/4*sqrt(55/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(55/13566), 0, -1/2*sqrt(33/646), 0, -sqrt(11/969), 0, 0, 0, -1/2*sqrt(165/29393), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(11/323)/12, 0, 0, 0, (-23*sqrt(11/88179))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(5/969), 0, 0, 0, -139/(3*sqrt(323323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (9*sqrt(3/2261))/4, 0, 0, 0, -127/(4*sqrt(138567)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37/(2*sqrt(88179)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/4522)/2, 0, (-23*sqrt(5/277134))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(46189), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (23*sqrt(5/277134))/2, 0, sqrt(13/4522)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/3553), 0, 0, 0, 37/(2*sqrt(88179)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -127/(4*sqrt(138567)), 0, 0, 0, (9*sqrt(3/2261))/4, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -139/(3*sqrt(323323)), 0, 0, 0, sqrt(5/969), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-23*sqrt(11/88179))/4, 0, 0, 0, sqrt(11/323)/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(165/29393), 0, 0, 0, -sqrt(11/969), 0, 0, 0, 0, 0, sqrt(11/8398)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(77/646)/3, 0, 0, 0, 0, 0, 29/(12*sqrt(4199)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (7*sqrt(7/323))/12, 0, 0, 0, 0, 0, (25*sqrt(35/46189))/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(7/323)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(1938), 0,
        0, 0, sqrt(119/16302), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(5/12597))/2, 0, (-7*sqrt(13/21318))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-3*sqrt(21/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(13/21318))/2, 0, (-5*sqrt(5/12597))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(119/16302), 0, 0, 0, -1/2*1/sqrt(1938), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(21/92378), 0, 0, 0, 0, 0, sqrt(7/323)/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (25*sqrt(35/46189))/12, 0, 0, 0, 0, 0, (7*sqrt(7/323))/12, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 29/(12*sqrt(4199)), 0, 0, 0, 0, 0, sqrt(77/646)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(11/8398)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(25194)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/3*sqrt(14/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(35/969), 0, 0, 0, 0, 0, -2*sqrt(21/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/646), 0,
        0, 0, 7*sqrt(10/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(10/969), 0, -7/sqrt(8398), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(70/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(8398), 0,
        -sqrt(10/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(10/138567), 0, 0, 0, -sqrt(7/646), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(21/46189), 0, 0, 0, 0, 0, -1/2*sqrt(35/969), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(70/46189), 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(14/323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/6*sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -(1/sqrt(25194)), 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (4, 7, 8): np.array([
        0, 0, 0, 0, 0, sqrt(7/1615)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(11/4845)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(77/12597)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4845)/2, 0, 0, 0, 0, 0, sqrt(21/4199), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(77/323)/6, 0, 0, 0, -7*sqrt(3/20995), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/323)/2, 0, 7*sqrt(11/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -7*sqrt(11/62985), 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 7*sqrt(3/20995), 0, 0, 0, sqrt(77/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/4199),
        0, 0, 0, 0, 0, sqrt(77/4845)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/12597), 0, 0, 0, 0,
        0, 0, 0, sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/12597)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/4845)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1615)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/1938),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -13/(6*sqrt(1615)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/3230), 0, 0, 0, 0, 0, (-11*sqrt(11/62985))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-7*sqrt(7/9690))/2, 0, 0, 0, 0, 0, -1/2*sqrt(231/8398), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/6*sqrt(77/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(11/969), 0, 0, 0, -sqrt(21/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(11/8398), 0, 7/sqrt(20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(77/125970), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -7/sqrt(20995), 0, -1/2*sqrt(11/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/4199), 0, 0,
        0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(7/25194), 0, 0, 0, 0, 0, -1/6*sqrt(77/323),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(231/8398), 0, 0, 0, 0, 0, (-7*sqrt(7/9690))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (-11*sqrt(11/62985))/2, 0, 0, 0, 0, 0, -sqrt(21/3230), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -13/(6*sqrt(1615)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, sqrt(13/969)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(39/3230), 0, 0, 0, sqrt(19/714)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (3*sqrt(3/1615))/2, 0, 0, 0, 97/(3*sqrt(146965)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/(6*sqrt(646)), 0, 0, 0, sqrt(429/22610)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(11/6783), 0, 0, 0, (3*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(187/10374),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-29*sqrt(11/440895))/2, 0, -2/sqrt(4199),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(17/2470),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(4199), 0, (-29*sqrt(11/440895))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(25194), 0, 0, 0, -1/2*sqrt(187/10374), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/4199))/2, 0, 0, 0, -sqrt(11/6783), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(429/22610)/2, 0, 0, 0, 1/(6*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 97/(3*sqrt(146965)), 0, 0, 0, (3*sqrt(3/1615))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(19/714)/2, 0, 0, 0, sqrt(39/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(13/969)/2, 0, 0, 0, -sqrt(91/9690), 0, -1/6*sqrt(91/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(13/4845)/2, 0, -2*sqrt(13/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 4/(3*sqrt(323)), 0, -47/(2*sqrt(176358)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/798)/2,
        0, -41/(6*sqrt(293930)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(11/176358))/2, 0, sqrt(19/23205),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/146965)/3, 0, sqrt(13/969)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -27/(2*sqrt(146965)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 9/sqrt(8398), 0, -27/(2*sqrt(146965)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(13/969)/2, 0, sqrt(11/146965)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(19/23205), 0, (11*sqrt(11/176358))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -41/(6*sqrt(293930)), 0, sqrt(17/798)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -47/(2*sqrt(176358)), 0, 4/(3*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(13/6783),
        0, sqrt(13/4845)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(91/323), 0, -sqrt(91/9690),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(91/969), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(65/323), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(5/6783)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 10*sqrt(5/88179), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (31*sqrt(11/29393))/6,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 53/(2*sqrt(88179)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(5/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (-3*sqrt(5/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -53/(2*sqrt(88179)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-31*sqrt(11/29393))/6, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -10*sqrt(5/88179), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(65/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/969)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/323)/6, 0, -sqrt(91/9690), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2*sqrt(13/6783), 0, sqrt(13/4845)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 47/(2*sqrt(176358)), 0, 4/(3*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 41/(6*sqrt(293930)), 0, sqrt(17/798)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(19/23205), 0, (11*sqrt(11/176358))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0, sqrt(11/146965)/3, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -9/sqrt(8398), 0, -27/(2*sqrt(146965)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 27/(2*sqrt(146965)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(11/146965), 0, sqrt(13/969)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (-11*sqrt(11/176358))/2, 0, sqrt(19/23205), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(17/798), 0, -41/(6*sqrt(293930)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -4/(3*sqrt(323)), 0, -47/(2*sqrt(176358)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/4845), 0, -2*sqrt(13/6783),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/9690), 0, -1/6*sqrt(91/323), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(13/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(19/714),
        0, 0, 0, sqrt(39/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -97/(3*sqrt(146965)), 0, 0, 0, (3*sqrt(3/1615))/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(429/22610), 0, 0, 0, 1/(6*sqrt(646)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/4199))/2, 0, 0, 0, -sqrt(11/6783), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -(1/sqrt(25194)), 0, 0, 0, -1/2*sqrt(187/10374), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2/sqrt(4199), 0, (-29*sqrt(11/440895))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/2470), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (29*sqrt(11/440895))/2, 0, -2/sqrt(4199), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(187/10374)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(11/6783), 0, 0, 0, (3*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*1/sqrt(646),
        0, 0, 0, sqrt(429/22610)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/1615))/2, 0, 0, 0, 97/(3*sqrt(146965)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/3230), 0, 0, 0, sqrt(19/714)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/969)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1938)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13/(6*sqrt(1615)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(11/62985))/2, 0, 0, 0, 0, 0, -sqrt(21/3230), 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(231/8398)/2, 0, 0, 0, 0, 0, (-7*sqrt(7/9690))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 7*sqrt(7/25194), 0, 0, 0, 0, 0, -1/6*sqrt(77/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/4199),
        0, 0, 0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7/sqrt(20995), 0, -1/2*sqrt(11/8398),
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/125970), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/8398)/2, 0, 7/sqrt(20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(11/969)/2, 0, 0, 0, -sqrt(21/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/323)/6, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/9690))/2, 0, 0, 0, 0, 0, -1/2*sqrt(231/8398),
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/3230), 0, 0, 0, 0, 0, (-11*sqrt(11/62985))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -13/(6*sqrt(1615)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(7/1615), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(77/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/12597),
        0, 0, 0, 0, 0, 0, 0, sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/4199), 0, 0,
        0, 0, 0, sqrt(77/4845)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(3/20995), 0, 0, 0, sqrt(77/323)/6,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(11/62985), 0, sqrt(11/323)/2, 0, 0, 0, 0,
        0, 0, 0, -sqrt(77/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/323),
        0, 7*sqrt(11/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(77/323), 0, 0, 0, -7*sqrt(3/20995),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/4845), 0, 0, 0, 0, 0, sqrt(21/4199), 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(7/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/12597)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(11/4845)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/1615)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (4, 8, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(323)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(11/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(55/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/4199), 0, 0, 0,
        0, 0, 0, 0, -1/3*1/sqrt(323), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/4199), 0, 0, 0, 0, 0,
        -1/2*sqrt(5/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/4199), 0, 0, 0, -1/2*sqrt(11/969), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/4199), 0, -1/6*sqrt(55/323), 0, 0, 0, 0, 0, 0, 0,
        sqrt(55/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/323)/6, 0, -sqrt(33/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/969)/2, 0, 0, 0, sqrt(35/4199), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/969)/2, 0, 0, 0, 0, 0, -sqrt(33/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/(3*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(55/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(5/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*1/sqrt(323), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/3*sqrt(13/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/(6*sqrt(646)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(77/323), 0, 0, 0, 0, 0, sqrt(13/646)/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-5*sqrt(55/8398))/6, 0, 0, 0, 0, 0, 11/(6*sqrt(646)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(33/8398), 0, 0, 0, 0, 0, 3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(4199), 0, 0, 0, sqrt(77/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(4199), 0,
        (5*sqrt(55/8398))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-5*sqrt(55/8398))/6, 0, 1/sqrt(4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/6*sqrt(77/323), 0, 0, 0, 1/sqrt(4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/(6*sqrt(646)), 0, 0, 0, 0, 0,
        (5*sqrt(55/8398))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(13/646), 0, 0, 0, 0, 0, sqrt(77/323)/6, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 11/(6*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(13/646)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/1938), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(35/1938)/2, 0, 0, 0, -sqrt(13/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(969), 0, 0, 0, -1/6*sqrt(91/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(11/8398), 0, 0, 0,
        -1/2*sqrt(35/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/12597), 0, 0, 0, -(1/sqrt(969)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, sqrt(11/8398)/6, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(5/4199), 0, sqrt(77/12597)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/12597), 0, 2*sqrt(5/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(11/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(969), 0, 0, 0, sqrt(77/12597)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(35/1938)/2, 0, 0, 0, sqrt(11/8398)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(91/323)/6, 0, 0, 0, -(1/sqrt(969)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/1938), 0, 0, 0,
        -1/2*sqrt(35/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(91/323), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/1938), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/3*sqrt(65/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0,
        sqrt(65/646)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/969)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (7*sqrt(3/8398))/2, 0, -1/2*sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(55/12597), 0, (-7*sqrt(3/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/4199))/6, 0,
        -sqrt(55/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/8398), 0, (-7*sqrt(7/4199))/6, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (7*sqrt(7/4199))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(55/12597), 0, (-7*sqrt(7/4199))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(3/8398))/2, 0,
        -sqrt(55/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/646)/2, 0, (-7*sqrt(3/8398))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/646), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/3*sqrt(65/646), 0, sqrt(13/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(65/646)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (2*sqrt(13/323))/3, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(13/323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/323), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/323), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*1/sqrt(4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(17/247)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 31/(6*sqrt(4199)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        6/sqrt(4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 31/(6*sqrt(4199)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/247)/6, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(4199), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/323), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/6*sqrt(13/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (2*sqrt(13/323))/3, 0, -1/3*sqrt(65/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/3*sqrt(65/646), 0, -1/2*sqrt(13/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(13/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/646)/2, 0, (7*sqrt(3/8398))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(3/8398))/2, 0, sqrt(55/12597), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/12597), 0, (7*sqrt(7/4199))/6, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/4199))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(5/8398), 0, (7*sqrt(7/4199))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (7*sqrt(7/4199))/6, 0, sqrt(55/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(55/12597), 0, (7*sqrt(3/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (7*sqrt(3/8398))/2, 0, sqrt(5/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/646)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0, -1/3*sqrt(65/646), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(65/646), 0, 0, 0, sqrt(13/1938), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/323)/6, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/1938), 0, 0, 0, sqrt(35/1938)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(91/323)/6, 0, 0, 0, 1/sqrt(969), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(35/1938)/2, 0, 0, 0, -1/6*sqrt(11/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(969), 0, 0, 0, -1/2*sqrt(77/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/6*sqrt(11/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/12597), 0,
        -2*sqrt(5/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(5/4199), 0, -1/2*sqrt(77/12597), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, -1/6*sqrt(11/8398), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/12597), 0, 0, 0, 1/sqrt(969), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(11/8398), 0, 0, 0, sqrt(35/1938)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(969), 0, 0, 0, sqrt(91/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(35/1938)/2, 0, 0, 0, sqrt(13/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(91/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(13/1938), 0, 0, 0, 0, 0, -1/3*sqrt(13/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -11/(6*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(13/646), 0, 0, 0, 0, 0,
        -1/6*sqrt(77/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/(6*sqrt(646)), 0, 0, 0, 0, 0, (-5*sqrt(55/8398))/6, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(77/323), 0, 0, 0, -(1/sqrt(4199)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-5*sqrt(55/8398))/6, 0, -(1/sqrt(4199)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 1/sqrt(4199), 0, (-5*sqrt(55/8398))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(4199), 0, 0, 0, -1/6*sqrt(77/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/8398), 0,
        0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(55/8398))/6, 0, 0, 0,
        0, 0, -11/(6*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(77/323), 0, 0, 0, 0, 0,
        -1/3*sqrt(13/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/(6*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(13/646), 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(323)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/969)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/969)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/(3*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/969)/2, 0,
        0, 0, 0, 0, sqrt(33/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/969)/2, 0, 0, 0,
        -sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/323)/6, 0, sqrt(33/4199), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(55/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/4199), 0, sqrt(55/323)/6, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/4199), 0, 0, 0, sqrt(11/969)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/4199), 0, 0, 0, 0, 0, sqrt(5/969)/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(55/4199), 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(323)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(55/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(11/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/969)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(3*sqrt(323)), 0, 0, 0,
        0,
    ]),
    # split

    (5, 5, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(35/46189), 0, 0, 0, 0, 0, sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(35/4199), 0, 0, 0, sqrt(15/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (5*sqrt(3/4199))/2, 0, sqrt(7/646), 0, 0, 0, 0, 0, -sqrt(5/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(7/646), 0, (5*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(15/323), 0, 0, 0, -1/2*sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/646), 0, 0, 0,
        0, 0, sqrt(35/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(46189), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -31/sqrt(461890), 0, 0, 0, 0, 0, 0, 0,
        -3/sqrt(646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(13/17765), 0, 0, 0, 0, 0, -(1/sqrt(323)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(21/46189))/2, 0, 0, 0, 1/(2*sqrt(1615)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 4*sqrt(2/4199), 0, sqrt(6/1615), 0, 0, 0, 0, 0, 0, 0, -11/sqrt(8398), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/1615), 0, 4*sqrt(2/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(1615), 0, 0, 0, (-7*sqrt(21/46189))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/sqrt(323), 0, 0, 0, 0, 0, 2*sqrt(13/17765), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3/sqrt(646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(35/46189), 0, 0, 0, 0, 0, sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(13/17765), 0, 0, 0, 0, 0, -(1/sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 73/sqrt(461890), 0, 0, 0,
        0, 0, -2*sqrt(3/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-47*sqrt(3/230945))/2, 0, 0, 0, -1/2*sqrt(21/1615), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7106), 0, -1/2*sqrt(3/20995), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(15/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(3/20995)/2, 0, sqrt(39/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/1615)/2, 0, 0, 0,
        (-47*sqrt(3/230945))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/1615), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(323), 0, 0, 0, 0, 0, -2*sqrt(13/17765), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, -sqrt(35/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(35/4199), 0, 0, 0, sqrt(15/323)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(21/46189))/2, 0, 0, 0, 1/(2*sqrt(1615)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-47*sqrt(3/230945))/2, 0, 0, 0, -1/2*sqrt(21/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -2*sqrt(34/13585), 0, 0, 0, -3*sqrt(14/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9*sqrt(7/461890), 0,
        -3*sqrt(3/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/46189), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/8398), 0, 9*sqrt(7/461890), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3*sqrt(14/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(21/1615)/2, 0, 0, 0, (47*sqrt(3/230945))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(1615), 0, 0, 0,
        (7*sqrt(21/46189))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/323), 0, 0, 0, sqrt(35/4199)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (5*sqrt(3/4199))/2, 0, sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(2/4199), 0, sqrt(6/1615), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7106), 0, -1/2*sqrt(3/20995), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 9*sqrt(7/461890), 0, -3*sqrt(3/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -7*sqrt(2/230945), 0, -6*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        7*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(7/46189), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/8398), 0, -9*sqrt(7/461890), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/20995)/2, 0, -sqrt(39/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(6/1615), 0, -4*sqrt(2/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(7/646), 0, (-5*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/323), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/sqrt(8398), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/46189), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(10/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 7*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(15/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(15/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -11/sqrt(8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/323), 0,
        0, 0, 0, 0, -sqrt(7/646), 0, (5*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(6/1615), 0, 4*sqrt(2/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(3/20995)/2, 0, sqrt(39/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/8398), 0,
        9*sqrt(7/461890), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(7/46189), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(6/46189), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(2/230945), 0, 6*sqrt(7/46189), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9*sqrt(7/461890), 0, 3*sqrt(3/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7106), 0, sqrt(3/20995)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 4*sqrt(2/4199), 0, -sqrt(6/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (5*sqrt(3/4199))/2, 0, -sqrt(7/646), 0, 0, 0, -1/2*sqrt(15/323), 0, 0, 0, -1/2*sqrt(35/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(1615), 0, 0, 0, (-7*sqrt(21/46189))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(21/1615)/2, 0, 0, 0, (-47*sqrt(3/230945))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3*sqrt(14/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 3*sqrt(3/8398), 0, -9*sqrt(7/461890), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(15/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        9*sqrt(7/461890), 0, 3*sqrt(3/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(34/13585), 0, 0, 0,
        3*sqrt(14/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-47*sqrt(3/230945))/2, 0, 0, 0, sqrt(21/1615)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(21/46189))/2, 0, 0, 0, -1/2*1/sqrt(1615), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(35/4199), 0, 0, 0, -1/2*sqrt(15/323), 0, -sqrt(5/646), 0, 0, 0,
        0, 0, sqrt(35/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(323), 0, 0, 0, 0, 0,
        2*sqrt(13/17765), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/1615), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/1615)/2, 0, 0, 0, (47*sqrt(3/230945))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/20995)/2, 0, -sqrt(39/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/4199), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7106), 0, sqrt(3/20995)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-47*sqrt(3/230945))/2, 0, 0, 0, sqrt(21/1615)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        73/sqrt(461890), 0, 0, 0, 0, 0, 2*sqrt(3/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(13/17765), 0,
        0, 0, 0, 0, 1/sqrt(323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/46189), 0, 0, 0,
        0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, -3/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3/sqrt(646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(323), 0,
        0, 0, 0, 0, -2*sqrt(13/17765), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(1615), 0, 0, 0,
        (7*sqrt(21/46189))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/1615), 0, -4*sqrt(2/4199), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -11/sqrt(8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(2/4199), 0, -sqrt(6/1615), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(21/46189))/2, 0, 0, 0, -1/2*1/sqrt(1615), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(13/17765), 0, 0, 0, 0, 0, 1/sqrt(323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -31/sqrt(461890), 0, 0, 0, 0, 0, 0, 0, 3/sqrt(646), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3/sqrt(46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(46189), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, -sqrt(35/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(15/323), 0, 0, 0, sqrt(35/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(7/646), 0, (-5*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (5*sqrt(3/4199))/2, 0, -sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(35/4199), 0, 0, 0, -1/2*sqrt(15/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/46189), 0, 0, 0,
        0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(46189), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/92378), 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (5, 6, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -3*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(323), 0, 0, 0, 0, 0, 3*sqrt(14/46189), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(323)), 0, 0, 0, -sqrt(21/4199), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(3/323), 0, 3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/323), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(7/8398), 0, sqrt(3/323), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(21/4199), 0, 0, 0, 3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -3*sqrt(14/46189), 0, 0, 0, 0, 0, 1/sqrt(323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(6/46189),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/4199), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(4199), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(15/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/323), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, 12*sqrt(2/46189),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/323), 0, 0, 0, -3*sqrt(35/46189), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/4199), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/4199), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/4199), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 3*sqrt(35/46189), 0, 0, 0, -1/2*sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -12*sqrt(2/46189), 0, 0, 0, 0, 0, -sqrt(5/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(15/46189),
        0, 0, 0, 0, 0, 0, 0, -sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/8398), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/4199)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/969),
        0, 0, 0, 0, 0, -2*sqrt(14/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(1938), 0, 0,
        0, 0, 0, -sqrt(95/14586), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/969), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/323), 0, 0, 0, -sqrt(11/4199), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/8398), 0, sqrt(7/46189), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(2/4199), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/46189), 0, -sqrt(35/8398), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(11/4199), 0, 0, 0, -1/2*sqrt(7/323), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -23/sqrt(46189), 0, 0, 0, 0, 0, -sqrt(2/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(95/14586), 0, 0, 0, 0, 0, 1/sqrt(1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(14/12597),
        0, 0, 0, 0, 0, sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/12597), 0, 0,
        0, 0, 0, -sqrt(11/1938), 0, 0, 0, sqrt(385/25194)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(11/646)/2, 0, 0, 0, sqrt(231/8398)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/646)/2,
        0, 0, 0, sqrt(119/5434)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1938)/2, 0, 0,
        0, 43/(2*sqrt(277134)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(21/8398), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(7/4199))/2, 0, (-5*sqrt(15/46189))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -29/sqrt(92378), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(15/46189))/2, 0, (-3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(3/92378), 0, 0, 0, -1/2*sqrt(21/8398), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 43/(2*sqrt(277134)), 0, 0, 0, sqrt(7/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(119/5434)/2, 0, 0, 0, sqrt(15/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(231/8398)/2, 0, 0, 0, sqrt(11/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(385/25194)/2,
        0, 0, 0, -sqrt(11/1938), 0, -1/2*sqrt(77/1938), 0, -1/2*sqrt(55/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(55/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(5/323)/2, 0, (-3*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 11/sqrt(25194),
        0, 2*sqrt(5/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(5/8398))/2, 0, (7*sqrt(21/92378))/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/46189), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(5/46189), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(105/46189), 0, -sqrt(6/46189), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(21/92378))/2, 0, (3*sqrt(5/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 2*sqrt(5/138567), 0, 11/sqrt(25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (-3*sqrt(3/4199))/2, 0, sqrt(5/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(55/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(55/1938), 0, -1/2*sqrt(77/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/969),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/1938), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2/sqrt(12597), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(13/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 41/(2*sqrt(46189)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/46189),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(7/46189), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -41/(2*sqrt(46189)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(13/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2/sqrt(12597),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1938), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/969)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/1938)/2,
        0, -1/2*sqrt(77/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/8398), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/4199))/2, 0, sqrt(5/323)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -2*sqrt(5/138567), 0, 11/sqrt(25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (-7*sqrt(21/92378))/2, 0, (3*sqrt(5/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(105/46189),
        0, -sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(5/46189), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-3*sqrt(5/8398))/2, 0, (7*sqrt(21/92378))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -11/sqrt(25194), 0, 2*sqrt(5/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/323),
        0, (-3*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(55/8398), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/1938)/2, 0, -1/2*sqrt(55/1938), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(385/25194),
        0, 0, 0, -sqrt(11/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(231/8398), 0, 0, 0, sqrt(11/646)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(119/5434), 0, 0, 0, sqrt(15/646)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -43/(2*sqrt(277134)), 0, 0, 0, sqrt(7/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(3/92378), 0, 0, 0, -1/2*sqrt(21/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-5*sqrt(15/46189))/2, 0, (-3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/sqrt(92378), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(7/4199))/2, 0, (-5*sqrt(15/46189))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(21/8398)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(7/1938), 0, 0, 0, 43/(2*sqrt(277134)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/646),
        0, 0, 0, sqrt(119/5434)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/646), 0, 0, 0, sqrt(231/8398)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1938), 0, 0, 0, sqrt(385/25194)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/12597)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(14/12597), 0, 0, 0, 0,
        0, sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(95/14586), 0, 0, 0, 0, 0, 1/sqrt(1938), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 23/sqrt(46189), 0, 0, 0, 0, 0, -sqrt(2/969), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(11/4199), 0, 0, 0, -1/2*sqrt(7/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(7/46189), 0, -sqrt(35/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(2/4199), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/8398), 0, sqrt(7/46189), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/323)/2, 0, 0, 0, -sqrt(11/4199), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(2/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(1938)),
        0, 0, 0, 0, 0, -sqrt(95/14586), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/969), 0, 0, 0, 0,
        0, -2*sqrt(14/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/12597), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/4199),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/8398), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(15/46189), 0, 0, 0, 0, 0, 0, 0, -sqrt(3/323),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 12*sqrt(2/46189), 0, 0, 0, 0, 0, -sqrt(5/646), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3*sqrt(35/46189), 0, 0, 0, -1/2*sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(21/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/4199), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/4199), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(3/323)/2, 0, 0, 0, -3*sqrt(35/46189), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(5/646), 0, 0, 0, 0, 0, 12*sqrt(2/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/323),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(15/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/4199)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(4199)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/4199), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(6/46189), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(14/46189), 0, 0, 0, 0, 0, 1/sqrt(323), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/4199), 0, 0, 0, 3/(2*sqrt(323)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 3*sqrt(7/8398), 0, sqrt(3/323), 0, 0, 0, 0, 0, -sqrt(6/323), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/323), 0, 3*sqrt(7/8398), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(323)), 0, 0, 0, -sqrt(21/4199), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -(1/sqrt(323)), 0, 0, 0, 0, 0, 3*sqrt(14/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*1/sqrt(4199), 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (5, 7, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(1938), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(5/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(15/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(15/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(21/92378), 0,
        0, 0, 0, 0, -(1/sqrt(969)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(7/8398), 0, 0, 0,
        -5/(2*sqrt(1938)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0, -1/2*sqrt(15/646), 0, 0, 0,
        0, 0, sqrt(5/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/646)/2, 0,
        -sqrt(35/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(1938)), 0, 0, 0, 3*sqrt(7/8398), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(969), 0, 0, 0, 0, 0, -5*sqrt(21/92378), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/4199), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 1/(2*sqrt(1938)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(11/3230)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(14/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23/(2*sqrt(25194)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(6/4199), 0, 0, 0, 0, 0,
        0, 0, sqrt(22/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/7106), 0, 0, 0, 0, 0, sqrt(17/570)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(42/230945), 0, 0, 0, sqrt(2/323), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/41990), 0, sqrt(7/646)/2, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/4199), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/646), 0, -sqrt(21/41990), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/323), 0, 0, 0, 4*sqrt(42/230945), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(17/570), 0, 0, 0, 0, 0, -sqrt(39/7106), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(22/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -23/(2*sqrt(25194)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(14/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/3230), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/3230), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(21/41990))/2, 0, 0, 0, 0, 0,
        -2*sqrt(11/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0, 0, 0, 0, 0, -1/2*sqrt(33/1615), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -4*sqrt(3/46189), 0, 0, 0, 0, 0, -1/2*1/sqrt(646), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -3*sqrt(3/92378), 0, 0, 0, sqrt(7/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(91/35530), 0, (3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -8*sqrt(3/20995), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(7/4199))/2, 0, sqrt(91/35530), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(7/1938), 0, 0, 0, -3*sqrt(3/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/(2*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/1615)/2, 0,
        0, 0, 0, 0, sqrt(13/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(11/4845), 0, 0, 0, 0, 0,
        (7*sqrt(21/41990))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/3230)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/969)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/646)/6, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/323)/6, 0, 0, 0, sqrt(143/1615)/3, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(154/62985), 0, 0, 0, sqrt(11/3230)/6, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(7/20995)/6, 0, 0, 0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -71/(6*sqrt(92378)), 0, 0, 0, -1/3*sqrt(14/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(19/2431), 0,
        0, 0, (-7*sqrt(7/4199))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16*sqrt(2/138567), 0, -1/2*sqrt(7/41990), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -41/sqrt(692835), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(7/41990)/2, 0, 16*sqrt(2/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (7*sqrt(7/4199))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/323)/3, 0,
        0, 0, 71/(6*sqrt(92378)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/969)/2, 0, 0, 0, -1/6*sqrt(7/20995), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(11/3230), 0, 0, 0, -sqrt(154/62985), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/3*sqrt(143/1615), 0, 0, 0, -1/6*sqrt(77/323), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/6*sqrt(143/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(143/969), 0, -1/3*sqrt(143/3230), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/12*sqrt(143/323), 0, sqrt(1001/1615)/12, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(11/8398)/6, 0, sqrt(77/969)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (11*sqrt(11/125970))/2, 0, sqrt(11/646)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (29*sqrt(13/17765))/12, 0,
        -1/6*sqrt(17/494), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (47*sqrt(7/46189))/12, 0, -61/(4*sqrt(62985)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/92378), 0, -197/(4*sqrt(692835)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 23/sqrt(277134), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 197/(4*sqrt(692835)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61/(4*sqrt(62985)), 0,
        (-47*sqrt(7/46189))/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/494)/6, 0, (-29*sqrt(13/17765))/12, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(11/646), 0, (-11*sqrt(11/125970))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/4*sqrt(77/969), 0, -1/6*sqrt(11/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/12*sqrt(1001/1615), 0, sqrt(143/323)/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/3230)/3, 0,
        sqrt(143/969)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/1938)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/1938), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(110/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -9/(2*sqrt(8398)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 4*sqrt(2/138567), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (7*sqrt(35/92378))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 6*sqrt(10/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (7*sqrt(35/92378))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(2/138567), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9/(2*sqrt(8398)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(110/12597), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/1938), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/1938)/2, 0, sqrt(143/3230)/3, 0, -1/4*sqrt(143/969), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/12*sqrt(1001/1615), 0, -1/12*sqrt(143/323), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/4*sqrt(77/969), 0, sqrt(11/8398)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/6*sqrt(11/646), 0, (11*sqrt(11/125970))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(17/494)/6, 0, (29*sqrt(13/17765))/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        61/(4*sqrt(62985)), 0, (47*sqrt(7/46189))/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 197/(4*sqrt(692835)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23/sqrt(277134), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/92378), 0, 197/(4*sqrt(692835)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (47*sqrt(7/46189))/12, 0, 61/(4*sqrt(62985)), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (29*sqrt(13/17765))/12, 0, sqrt(17/494)/6, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(11/125970))/2, 0, -1/6*sqrt(11/646), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(11/8398)/6, 0, -1/4*sqrt(77/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/12*sqrt(143/323), 0, -1/12*sqrt(1001/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/4*sqrt(143/969), 0, sqrt(143/3230)/3, 0, 0, 0, sqrt(143/646)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/3*sqrt(143/1615), 0, 0, 0, sqrt(77/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/6*sqrt(11/3230), 0, 0, 0, sqrt(154/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/969)/2, 0,
        0, 0, sqrt(7/20995)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/323)/3, 0, 0, 0,
        -71/(6*sqrt(92378)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/4199))/6, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/41990)/2, 0, -16*sqrt(2/138567), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -41/sqrt(692835), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16*sqrt(2/138567), 0, sqrt(7/41990)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(19/2431), 0, 0, 0, (7*sqrt(7/4199))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -71/(6*sqrt(92378)), 0, 0, 0, sqrt(14/323)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(7/20995)/6, 0, 0, 0, sqrt(11/969)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(154/62985), 0, 0, 0, -1/6*sqrt(11/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/323)/6, 0,
        0, 0, -1/3*sqrt(143/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(143/646)/6, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(77/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(11/4845), 0, 0, 0, 0, 0,
        (-7*sqrt(21/41990))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/1615)/2, 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/1938), 0, 0, 0, 3*sqrt(3/92378), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-3*sqrt(7/4199))/2, 0, -sqrt(91/35530), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -8*sqrt(3/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(91/35530), 0, (-3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(3/92378), 0, 0, 0, -1/2*sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(3/46189), 0,
        0, 0, 0, 0, 1/(2*sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/969), 0, 0, 0,
        0, 0, sqrt(33/1615)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(21/41990))/2, 0, 0, 0, 0, 0,
        2*sqrt(11/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/3230), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/969), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(11/3230)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/4845), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23/(2*sqrt(25194)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(22/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(17/570), 0, 0, 0, 0, 0, sqrt(39/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(2/323), 0, 0, 0, -4*sqrt(42/230945), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(7/646), 0, sqrt(21/41990), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(2/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(21/41990), 0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(42/230945), 0,
        0, 0, -sqrt(2/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/7106), 0, 0, 0, 0, 0,
        -1/2*sqrt(17/570), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(6/4199), 0, 0, 0, 0, 0, 0, 0, -sqrt(22/4845), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 23/(2*sqrt(25194)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(14/4845), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(11/3230)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(1938), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/1938), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(969), 0,
        0, 0, 0, 0, 5*sqrt(21/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/(2*sqrt(1938)), 0, 0, 0,
        -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/646)/2, 0, sqrt(35/4199), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(5/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/4199), 0,
        sqrt(15/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(7/8398), 0, 0, 0, 5/(2*sqrt(1938)), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(21/92378), 0, 0, 0, 0, 0, 1/sqrt(969), 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(15/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(15/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/2*sqrt(5/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(1938), 0,
        0, 0, 0, 0, 0,
    ]),
    # split

    (5, 8, 8): np.array([
        0, 0, 0, 0, 0, 1/sqrt(3553), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(3/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(7/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/4199), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -(1/sqrt(3553)), 0, 0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(3/646), 0, 0, 0, 3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(7/646), 0, -3*sqrt(3/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 3*sqrt(3/4199), 0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -3*sqrt(7/8398), 0, 0, 0, -1/2*sqrt(3/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(7/8398), 0, 0,
        0, 0, 0, -(1/sqrt(3553)), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/4199), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(3/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(3553), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/3553), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(5/7106))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/3553), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/7106))/2, 0, 0, 0, 0,
        0, -3/sqrt(8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/323), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/646)/2, 0, 3/sqrt(8398), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(30/4199), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(8398), 0, sqrt(15/646)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/323), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 3/sqrt(8398), 0, 0, 0, 0, 0, (5*sqrt(5/7106))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(30/4199), 0, 0, 0, 0, 0, 0, 0, sqrt(6/3553), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/646),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/323), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(5/7106))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/3553), 0, 0, 0, 0, 0, 0,
        0, 2*sqrt(13/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/627)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/1122)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(13/10659), 0, 0, 0, 0, 0, sqrt(7/1938)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(17/627), 0, 0, 0, 0, 0, -1/2*sqrt(5/12597), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(19/1122), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(7/1938), 0, 0, 0, -sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(5/12597)/2, 0, sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 4/sqrt(4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(33/8398), 0, sqrt(5/12597)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/8398), 0, 0,
        0, -1/2*sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(4199), 0, 0, 0, 0, 0, -1/2*sqrt(19/1122),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/12597), 0, 0, 0, 0, 0, -1/2*sqrt(17/627), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1938)/2, 0, 0, 0, 0, 0, -2*sqrt(13/10659), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(19/1122)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(17/627)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 2*sqrt(13/10659), 0, 0, 0, 0, 0, -sqrt(91/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-3*sqrt(13/7106))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(91/10659), 0, 0, 0, -1/2*sqrt(5/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(13/7106))/2,
        0, 0, 0, sqrt(14/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/10659)/2, 0, 0,
        0, (3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(14/10659), 0, 0, 0, sqrt(19/1326)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(19/1326), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/4199), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(19/1326), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/4199), 0, 0, 0, (-3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(19/1326)/2, 0, 0, 0, -sqrt(14/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (3*sqrt(7/4199))/2, 0, 0, 0, sqrt(5/10659)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/10659),
        0, 0, 0, (3*sqrt(13/7106))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/10659), 0, 0,
        0, sqrt(91/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(13/7106))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/10659), 0, 0, 0, sqrt(65/7106), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(65/7106), 0, sqrt(13/10659)/4, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(13/10659), 0, -1/4*sqrt(455/10659), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(455/10659)/4, 0, (-5*sqrt(5/7106))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/7106))/2, 0, -47/(2*sqrt(277134)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 47/(2*sqrt(277134)), 0, -1/4*sqrt(5/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(5/12597)/4, 0, sqrt(77/4199)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/4*sqrt(77/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(55/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/8398), 0, -1/4*sqrt(77/4199),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/4, 0, sqrt(5/12597)/4, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(5/12597), 0, 47/(2*sqrt(277134)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -47/(2*sqrt(277134)), 0, (5*sqrt(5/7106))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(5/7106))/2, 0, sqrt(455/10659)/4, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(455/10659), 0, -1/4*sqrt(13/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(13/10659)/4, 0, -sqrt(65/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(65/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 2*sqrt(26/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(13/21318))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(26/10659), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(39/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 3*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 83/(2*sqrt(277134)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(22/12597), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/25194))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (-5*sqrt(11/25194))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2*sqrt(22/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -83/(2*sqrt(277134)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(6/46189), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7106)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 2*sqrt(26/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (7*sqrt(13/21318))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(26/10659), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(65/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/4*sqrt(13/10659), 0, -sqrt(65/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(455/10659)/4, 0, -1/4*sqrt(13/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/7106))/2, 0, sqrt(455/10659)/4,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 47/(2*sqrt(277134)), 0, (5*sqrt(5/7106))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/12597)/4, 0, 47/(2*sqrt(277134)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/4*sqrt(77/4199), 0, sqrt(5/12597)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(55/8398), 0, -1/4*sqrt(77/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/8398), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/4199)/4, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(5/12597), 0, sqrt(77/4199)/4, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -47/(2*sqrt(277134)), 0, -1/4*sqrt(5/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-5*sqrt(5/7106))/2, 0, -47/(2*sqrt(277134)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(455/10659), 0, (-5*sqrt(5/7106))/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/10659)/4, 0, -1/4*sqrt(455/10659), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/7106), 0, sqrt(13/10659)/4, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(65/7106), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/10659), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(13/7106))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/10659)/2, 0, 0, 0, sqrt(91/10659), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(14/10659), 0, 0, 0, (3*sqrt(13/7106))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-3*sqrt(7/4199))/2, 0, 0, 0, sqrt(5/10659)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(19/1326), 0, 0,
        0, -sqrt(14/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/4199), 0, 0, 0, (-3*sqrt(7/4199))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(19/1326), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(11/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(19/1326)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(7/4199))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(14/10659), 0, 0, 0, sqrt(19/1326)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/10659), 0, 0, 0, (3*sqrt(7/4199))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (-3*sqrt(13/7106))/2, 0, 0, 0, sqrt(14/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(91/10659), 0, 0, 0, -1/2*sqrt(5/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-3*sqrt(13/7106))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/10659), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -2*sqrt(13/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(17/627), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(19/1122), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/1938), 0, 0, 0, 0, 0, -2*sqrt(13/10659),
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/12597)/2, 0, 0, 0, 0, 0, -1/2*sqrt(17/627), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 4/sqrt(4199), 0, 0, 0, 0, 0, -1/2*sqrt(19/1122), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(33/8398), 0, 0, 0, -1/2*sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(33/8398), 0, sqrt(5/12597)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(4199), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/12597), 0, sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(7/1938)/2, 0, 0, 0, -sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(19/1122)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/627)/2, 0, 0,
        0, 0, 0, -1/2*sqrt(5/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(13/10659), 0, 0, 0, 0, 0, sqrt(7/1938)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/1122)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/627)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 2*sqrt(13/10659), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(6/3553), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/7106))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(2/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(15/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(30/4199), 0, 0,
        0, 0, 0, 0, 0, sqrt(6/3553), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/sqrt(8398), 0, 0, 0, 0,
        0, (5*sqrt(5/7106))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/323), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(8398), 0, sqrt(15/646)/2, 0, 0, 0, 0, 0, 0,
        0, -sqrt(30/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/646), 0, 3/sqrt(8398),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/323), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(5/7106))/2, 0, 0, 0, 0, 0, -3/sqrt(8398), 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(6/3553), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(2/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-5*sqrt(5/7106))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/3553), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -(1/sqrt(3553)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(3/646), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, 0, 0, -(1/sqrt(3553)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 3*sqrt(7/8398), 0, 0, 0, -1/2*sqrt(3/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -3*sqrt(3/4199), 0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0, sqrt(3/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(7/646)/2, 0, -3*sqrt(3/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(3/646)/2, 0, 0, 0, 3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(3553), 0, 0,
        0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 3*sqrt(3/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/646)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/sqrt(3553), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (6, 6, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/58786), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(33/58786), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(15/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(55/8398), 0, 0, 0, -sqrt(11/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/323), 0,
        -1/2*sqrt(55/2261), 0, 0, 0, sqrt(11/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(55/2261)/2, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/4522), 0, 0, 0,
        sqrt(55/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/8398), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/8398), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/58786), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/58786), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -5*sqrt(11/58786), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 12/sqrt(29393), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(3/4199), 0, 0, 0, 0, 0, sqrt(33/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(22/4199), 0, 0, 0, sqrt(33/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(33/4199), 0,
        sqrt(11/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(11/4522), 0, -1/2*sqrt(33/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/4522), 0,
        0, 0, sqrt(22/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/4522), 0, 0, 0, 0, 0,
        -3*sqrt(3/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12/sqrt(29393), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/58786), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 12/sqrt(29393), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 89/sqrt(646646), 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/4522), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -9*sqrt(15/323323), 0, 0, 0, 0, 0, -sqrt(3/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(6/46189), 0, 0, 0, sqrt(5/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/8398), 0,
        sqrt(3/646), 0, 0, 0, 0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(3/646), 0, sqrt(5/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(5/4522), 0, 0, 0, 2*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/2261), 0, 0, 0,
        0, 0, -9*sqrt(15/323323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(5/4522), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -12/sqrt(29393), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/8398), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/4199), 0, 0, 0, 0, 0, sqrt(33/4522), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -9*sqrt(15/323323), 0, 0, 0, 0, 0, -sqrt(3/2261), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(19/34034), 0, 0, 0, 0, 0, -2*sqrt(3/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(26/24871), 0, 0, 0, -(1/sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/4862), 0,
        sqrt(5/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(5/4199), 0, sqrt(19/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(646), 0, 0, 0, -sqrt(26/24871), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/2261), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/2261), 0, 0, 0, 0, 0,
        9*sqrt(15/323323), 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/4522), 0, 0, 0, 0, 0, 3*sqrt(3/4199), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/8398), 0, 0, 0,
        -sqrt(11/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(22/4199), 0, 0, 0, sqrt(33/4522), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(6/46189), 0, 0, 0, sqrt(5/4522), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(26/24871), 0, 0, 0, -(1/sqrt(646)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -71/sqrt(646646), 0, 0, 0, -3*sqrt(2/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (27*sqrt(5/323323))/2, 0,
        (-3*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/92378), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/4199))/2, 0, (27*sqrt(5/323323))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3*sqrt(2/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(646), 0, 0, 0, sqrt(26/24871), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(5/4522), 0, 0, 0,
        -2*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/4522), 0, 0, 0, -sqrt(22/4199), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/4522), 0, 0, 0, -sqrt(55/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/323), 0,
        -1/2*sqrt(55/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(33/4199), 0, sqrt(11/4522), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/8398), 0, sqrt(3/646), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(19/4862), 0, sqrt(5/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (27*sqrt(5/323323))/2, 0, (-3*sqrt(3/4199))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(2/323323), 0,
        -6*sqrt(5/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(6/46189), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(5/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (3*sqrt(3/4199))/2, 0, (-27*sqrt(5/323323))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(5/4199), 0, -sqrt(19/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/646), 0,
        -sqrt(5/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/4522), 0, sqrt(33/4199)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/2261)/2, 0, sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2*sqrt(7/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(21/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(6/46189), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(14/46189), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(6/46189), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/92378), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(7/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(11/646), 0, 0, 0, sqrt(55/2261)/2, 0, -1/2*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(11/4522), 0, -1/2*sqrt(33/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(3/646), 0, sqrt(5/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(5/4199), 0, sqrt(19/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (3*sqrt(3/4199))/2, 0, (27*sqrt(5/323323))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(5/46189), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(6/46189), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(2/323323), 0, 6*sqrt(5/46189), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (27*sqrt(5/323323))/2, 0, (3*sqrt(3/4199))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/4862), 0, -1/2*sqrt(5/4199), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(5/8398), 0, -sqrt(3/646), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(33/4199), 0, -sqrt(11/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(11/323), 0, sqrt(55/2261)/2, 0, sqrt(11/4522), 0, 0, 0, sqrt(55/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(33/4522), 0, 0, 0, sqrt(22/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(5/4522), 0, 0, 0, 2*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(646), 0, 0, 0, -sqrt(26/24871), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3*sqrt(2/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(3/4199))/2, 0,
        (-27*sqrt(5/323323))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(21/92378), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (27*sqrt(5/323323))/2, 0, (3*sqrt(3/4199))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -71/sqrt(646646), 0, 0, 0, 3*sqrt(2/4199), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(26/24871), 0, 0, 0, 1/sqrt(646), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(6/46189), 0, 0, 0, -sqrt(5/4522), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(22/4199), 0, 0, 0, -sqrt(33/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(55/8398), 0, 0, 0, sqrt(11/4522), 0, 0, 0, 0, 0, -sqrt(33/8398), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(33/4522), 0, 0, 0, 0, 0, -3*sqrt(3/4199), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(3/2261), 0, 0, 0, 0, 0, -9*sqrt(15/323323), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(3/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        1/sqrt(646), 0, 0, 0, sqrt(26/24871), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/4199), 0,
        -sqrt(19/4862), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2*sqrt(7/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/4862), 0,
        -1/2*sqrt(5/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(26/24871), 0, 0, 0, 1/sqrt(646), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(19/34034), 0, 0, 0, 0, 0, 2*sqrt(3/2261), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -9*sqrt(15/323323), 0, 0, 0, 0, 0, sqrt(3/2261), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3*sqrt(3/4199), 0, 0, 0, 0, 0, -sqrt(33/4522), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/8398), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12/sqrt(29393), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3*sqrt(5/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(3/2261), 0, 0, 0, 0, 0, 9*sqrt(15/323323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(5/4522), 0, 0, 0, -2*sqrt(6/46189), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/646), 0,
        -sqrt(5/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -3*sqrt(7/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(5/8398), 0, -sqrt(3/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(6/46189), 0, 0, 0,
        -sqrt(5/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9*sqrt(15/323323), 0, 0, 0, 0, 0, sqrt(3/2261), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 89/sqrt(646646), 0, 0, 0, 0, 0, 0, 0, 3*sqrt(5/4522), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 12/sqrt(29393), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(15/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/58786), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -12/sqrt(29393), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(33/4522), 0, 0, 0, 0, 0, 3*sqrt(3/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(33/4522), 0, 0, 0, -sqrt(22/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/4522), 0,
        sqrt(33/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(33/4199), 0, -sqrt(11/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(22/4199), 0,
        0, 0, -sqrt(33/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/4199), 0, 0, 0, 0, 0,
        -sqrt(33/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 12/sqrt(29393), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -5*sqrt(11/58786), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(33/58786), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/58786), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(11/4522), 0, 0, 0, -sqrt(55/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/2261)/2, 0,
        sqrt(11/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -1/2*sqrt(11/323), 0, sqrt(55/2261)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(55/8398), 0, 0, 0, sqrt(11/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/8398), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/8398), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/58786), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(11/58786), 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (6, 7, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(1615)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 18/sqrt(146965), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(2/4199), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/4199), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(2/2261), 0, 0, 0, -9*sqrt(2/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (3*sqrt(3/2261))/2, 0, 2*sqrt(3/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(2/1615), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(3/1615), 0, (3*sqrt(3/2261))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 9*sqrt(2/20995), 0, 0, 0, sqrt(2/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -3*sqrt(3/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(2/4199), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -18/sqrt(146965), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(2/11305), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 1/(2*sqrt(1615)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -29/(2*sqrt(67830)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(51/8645), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -5/sqrt(6783), 0, 0, 0, 0, 0, sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(19/714), 0, 0, 0, -3/sqrt(8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-13*sqrt(3/22610))/2,
        0, -(1/sqrt(20995)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(7/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(20995), 0, (-13*sqrt(3/22610))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/sqrt(8398),
        0, 0, 0, -1/2*sqrt(19/714), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/8398), 0, 0, 0, 0,
        0, -5/sqrt(6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(51/8645), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -23*sqrt(3/146965), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -29/(2*sqrt(67830)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/2*sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1938), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (41*sqrt(11/881790))/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 5*sqrt(2/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(11/13566))/2,
        0, 0, 0, 0, 0, sqrt(3/293930), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/22610), 0, 0,
        0, sqrt(6/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/3230), 0, -sqrt(33/8398), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(154/20995), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/8398), 0, -1/2*sqrt(11/3230),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(6/4199), 0, 0, 0, sqrt(11/22610), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(3/293930), 0, 0, 0, 0, 0, (5*sqrt(11/13566))/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 3*sqrt(66/146965), 0, 0, 0, 0, 0, 0, 0, 5*sqrt(2/6783), 0, 0, 0, 0, 0, 0,
        0, 0, 0, (41*sqrt(11/881790))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(11/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/646)/2,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(5/2261),
        0, 0, 0, 0, 0, -1/2*sqrt(55/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/2261), 0, 0,
        0, 0, 0, sqrt(11/29393)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/4522)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/646)/2, 0, 0, 0, 15/sqrt(58786), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/4199)/2, 0, -sqrt(15/8398), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(15/8398), 0, sqrt(33/4199)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -15/sqrt(58786), 0, 0, 0, sqrt(11/646)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 12/sqrt(29393), 0, 0, 0, 0, 0, sqrt(33/4522)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(11/29393)/2, 0, 0, 0, 0, 0, -1/2*sqrt(5/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(55/8398),
        0, 0, 0, 0, 0, -2*sqrt(5/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(15/646), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/323), 0, 0, 0, 0,
        0, 0, 0, sqrt(91/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(130/2261)/3, 0, 0,
        0, (2*sqrt(2/323))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(5/2261))/6, 0, 0, 0, -1/2*sqrt(5/12597),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(2/6783), 0, 0, 0, -1/3*sqrt(110/4199), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(11/323), 0, 0, 0, -61/(6*sqrt(29393)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(22/4199)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(55/4199)/2, 0, 5/sqrt(88179), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(70/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -5/sqrt(88179), 0, sqrt(55/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -5*sqrt(2/29393), 0, 0, 0, sqrt(22/4199)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -61/(6*sqrt(29393)),
        0, 0, 0, -1/6*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(110/4199), 0, 0,
        0, -4*sqrt(2/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(5/12597), 0, 0, 0, (-5*sqrt(5/2261))/6,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (2*sqrt(2/323))/3, 0, 0, 0, sqrt(130/2261)/3, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/323)/6, 0, 0, 0, -1/3*sqrt(13/646), 0, (-7*sqrt(13/4845))/4, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (13*sqrt(13/2261))/12, 0, -1/12*sqrt(13/1615), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 23/(4*sqrt(33915)), 0, 67/(6*sqrt(41990)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -13/(6*sqrt(3230)), 0, sqrt(19/1326)/2, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-23*sqrt(11/41990))/6, 0, sqrt(17/247)/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (-5*sqrt(11/12597))/4, 0, (-25*sqrt(5/29393))/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 5/(4*sqrt(12597)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 5*sqrt(5/25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(15/58786),
        0, 5/(4*sqrt(12597)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-25*sqrt(5/29393))/12, 0, (-5*sqrt(11/12597))/4,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/247)/12, 0, (-23*sqrt(11/41990))/6, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/1326)/2, 0, -13/(6*sqrt(3230)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 67/(6*sqrt(41990)), 0, 23/(4*sqrt(33915)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/12*sqrt(13/1615), 0, (13*sqrt(13/2261))/12, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-7*sqrt(13/4845))/4, 0, -1/3*sqrt(13/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -1/2*sqrt(91/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(13/3230), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/9690))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(14/62985), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(77/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -5*sqrt(7/25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-5*sqrt(5/8398))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(5/8398))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/25194), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(77/8398)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -2*sqrt(14/62985), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(7/9690))/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/3230), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/1938)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(13/4845))/4,
        0, -1/3*sqrt(13/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/1615)/12, 0, (13*sqrt(13/2261))/12, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -67/(6*sqrt(41990)), 0, 23/(4*sqrt(33915)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(19/1326), 0, -13/(6*sqrt(3230)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -1/12*sqrt(17/247), 0, (-23*sqrt(11/41990))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (25*sqrt(5/29393))/12,
        0, (-5*sqrt(11/12597))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(15/58786), 0, 5/(4*sqrt(12597)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/25194), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -5/(4*sqrt(12597)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (5*sqrt(11/12597))/4, 0, (-25*sqrt(5/29393))/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (23*sqrt(11/41990))/6,
        0, sqrt(17/247)/12, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 13/(6*sqrt(3230)), 0, sqrt(19/1326)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -23/(4*sqrt(33915)), 0, 67/(6*sqrt(41990)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (-13*sqrt(13/2261))/12, 0, -1/12*sqrt(13/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(13/646)/3, 0, (-7*sqrt(13/4845))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/6*sqrt(91/323), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, (-2*sqrt(2/323))/3, 0, 0, 0, sqrt(130/2261)/3, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(5/12597)/2, 0, 0, 0, (-5*sqrt(5/2261))/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(110/4199)/3, 0, 0, 0, -4*sqrt(2/6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61/(6*sqrt(29393)), 0, 0,
        0, -1/6*sqrt(11/323), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(2/29393), 0, 0, 0, sqrt(22/4199)/3, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/sqrt(88179), 0, sqrt(55/4199)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(70/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(55/4199), 0, 5/sqrt(88179), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(22/4199), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/323)/6, 0, 0, 0, -61/(6*sqrt(29393)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(2/6783), 0, 0, 0, -1/3*sqrt(110/4199), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (5*sqrt(5/2261))/6, 0, 0, 0, -1/2*sqrt(5/12597), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/3*sqrt(130/2261), 0, 0, 0, (2*sqrt(2/323))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(91/323)/6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(7/323)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(15/646)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/8398)/2,
        0, 0, 0, 0, 0, -2*sqrt(5/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/29393), 0, 0, 0, 0,
        0, -1/2*sqrt(5/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, -12/sqrt(29393), 0, 0, 0, 0, 0, sqrt(33/4522)/2, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 15/sqrt(58786), 0, 0, 0, sqrt(11/646)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(15/8398), 0, sqrt(33/4199)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(33/4199), 0, -sqrt(15/8398), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(11/646), 0, 0, 0, 15/sqrt(58786), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(33/4522), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(5/2261)/2, 0, 0, 0, 0, 0, sqrt(11/29393)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(5/2261),
        0, 0, 0, 0, 0, -1/2*sqrt(55/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(15/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/323), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -1/2*sqrt(7/646), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/1938), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-41*sqrt(11/881790))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(66/146965), 0, 0, 0, 0, 0, 0, 0, 5*sqrt(2/6783), 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(3/293930), 0, 0, 0, 0, 0, (5*sqrt(11/13566))/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(6/4199), 0, 0, 0, sqrt(11/22610), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(33/8398), 0, -1/2*sqrt(11/3230), 0, 0, 0, 0, 0, 0, 0, sqrt(154/20995), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/3230)/2, 0, -sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(11/22610), 0, 0, 0, sqrt(6/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (-5*sqrt(11/13566))/2, 0, 0, 0, 0, 0, sqrt(3/293930), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(2/6783), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, (41*sqrt(11/881790))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/1938), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/646)/2, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/1938)/2, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/(2*sqrt(67830)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 23*sqrt(3/146965), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(51/8645), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(33/8398), 0, 0, 0, 0, 0, -5/sqrt(6783), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -3/sqrt(8398), 0, 0, 0, -1/2*sqrt(19/714), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(20995)),
        0, (-13*sqrt(3/22610))/2, 0, 0, 0, 0, 0, sqrt(7/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (13*sqrt(3/22610))/2, 0, -(1/sqrt(20995)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/714)/2,
        0, 0, 0, -3/sqrt(8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/sqrt(6783), 0, 0, 0, 0,
        0, sqrt(33/8398), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(51/8645),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -29/(2*sqrt(67830)), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(7/1938), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*1/sqrt(1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -3*sqrt(2/11305), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 18/sqrt(146965), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -3*sqrt(2/4199), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/4199),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9*sqrt(2/20995), 0, 0,
        0, sqrt(2/2261), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/1615), 0, (3*sqrt(3/2261))/2, 0, 0,
        0, -3*sqrt(2/1615), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-3*sqrt(3/2261))/2, 0, 2*sqrt(3/1615),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/2261), 0, 0, 0, -9*sqrt(2/20995), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/4199), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(2/4199), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 18/sqrt(146965), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 1/(2*sqrt(1615)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (6, 8, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(35/7429)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(42/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -6/sqrt(7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(70/96577), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(77/96577), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(70/96577), 0, 0, 0, -sqrt(2/7429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -6/sqrt(7429), 0, -1/2*sqrt(35/7429), 0, 0, 0, sqrt(42/7429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/7429)/2, 0, -6/sqrt(7429), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/7429), 0, 0, 0, 3*sqrt(70/96577), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(77/96577), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(70/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -6/sqrt(7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -1/2*sqrt(35/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(2/7429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(11/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-9*sqrt(3/14858))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(7/14858))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(3/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 9*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -3*sqrt(7/193154), 0, 0, 0, 0, 0, sqrt(11/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(7/193154), 0, 0, 0, (9*sqrt(3/14858))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        9*sqrt(3/96577), 0, (7*sqrt(7/14858))/2, 0, 0, 0, 0, 0, -5*sqrt(3/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-7*sqrt(7/14858))/2, 0, 9*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-9*sqrt(3/14858))/2, 0, 0, 0, -3*sqrt(7/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(11/7429), 0, 0, 0,
        0, 0, -3*sqrt(7/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        9*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/14858))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (9*sqrt(3/14858))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(11/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(30/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(19/782)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(55/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/14858)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(66/96577), 0, 0, 0, 0, 0,
        0, 0, -sqrt(30/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(55/193154), 0, 0, 0, 0, 0, -1/2*sqrt(19/782), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(42/96577), 0, 0, 0, -sqrt(55/14858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(55/193154), 0, -1/2*sqrt(33/14858), 0, 0, 0, 0, 0, 0, 0, -sqrt(66/96577), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/14858)/2, 0, 3*sqrt(55/193154), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/14858), 0, 0, 0, -3*sqrt(42/96577), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(19/782)/2, 0, 0, 0, 0, 0, 3*sqrt(55/193154), 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(30/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -1/2*sqrt(33/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(55/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(19/782), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(30/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -2*sqrt(13/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/(2*sqrt(7429)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(14858)), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/14858)/2, 0, 0, 0, 0, 0, 2*sqrt(13/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, (5*sqrt(55/96577))/2, 0, 0, 0, 0, 0, 11/(2*sqrt(7429)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        4*sqrt(33/96577), 0, 0, 0, 0, 0, 3/(2*sqrt(14858)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9/sqrt(193154), 0,
        0, 0, -1/2*sqrt(77/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9/sqrt(193154), 0, (-5*sqrt(55/96577))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(33/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (5*sqrt(55/96577))/2, 0, -9/sqrt(193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(77/14858)/2, 0, 0, 0, -9/sqrt(193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(14858)), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/(2*sqrt(7429)), 0, 0, 0, 0, 0, (-5*sqrt(55/96577))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(13/7429), 0, 0, 0, 0, 0, -1/2*sqrt(77/14858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3/(2*sqrt(14858)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 11/(2*sqrt(7429)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(13/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(182/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(13/7429)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2*sqrt(10/22287), 0, 0, 0, -sqrt(182/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(7/22287))/2, 0,
        0, 0, -1/2*sqrt(13/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/96577), 0, 0, 0, 2*sqrt(10/22287), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/289731)/2, 0, 0, 0, (7*sqrt(7/22287))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(26/7429), 0, 0, 0, sqrt(154/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -3*sqrt(35/96577), 0, -1/2*sqrt(11/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(26/7429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/289731)/2, 0, -3*sqrt(35/96577), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-7*sqrt(7/22287))/2, 0, 0, 0, -1/2*sqrt(11/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2*sqrt(10/22287), 0, 0, 0, sqrt(154/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/7429)/2, 0,
        0, 0, (7*sqrt(7/22287))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(182/22287), 0, 0, 0, 2*sqrt(10/22287), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/2*sqrt(13/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(182/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(91/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(455/22287)/4, 0, sqrt(91/14858), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(13/22287))/4, 0, -1/4*sqrt(455/22287), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(7/14858))/2, 0, (-11*sqrt(13/22287))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-5*sqrt(35/579462))/2, 0, (-3*sqrt(7/14858))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/4*sqrt(1001/22287), 0, (5*sqrt(35/579462))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-29*sqrt(5/96577))/4, 0, sqrt(1001/22287)/4, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(7/193154), 0, (29*sqrt(5/96577))/4, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(7/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-29*sqrt(5/96577))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/4*sqrt(1001/22287), 0, (29*sqrt(5/96577))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(35/579462))/2, 0, sqrt(1001/22287)/4, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(7/14858))/2, 0, (5*sqrt(35/579462))/2, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(13/22287))/4, 0, (-3*sqrt(7/14858))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(455/22287)/4, 0, (-11*sqrt(13/22287))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(91/14858), 0, -1/4*sqrt(455/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/14858), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(26/22287), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-13*sqrt(13/44574))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(13/44574))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 32*sqrt(2/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (31*sqrt(3/193154))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 1/sqrt(579462), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-5*sqrt(17/34086))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -10*sqrt(6/96577), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(17/34086))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(579462), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (31*sqrt(3/193154))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 32*sqrt(2/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(13/44574))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(39/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-13*sqrt(13/44574))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 2*sqrt(26/22287), 0, -sqrt(91/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(91/14858), 0, sqrt(455/22287)/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(455/22287)/4, 0,
        (11*sqrt(13/22287))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(13/22287))/4, 0, (3*sqrt(7/14858))/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(7/14858))/2, 0, (-5*sqrt(35/579462))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(35/579462))/2, 0, -1/4*sqrt(1001/22287), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/4*sqrt(1001/22287), 0, (-29*sqrt(5/96577))/4, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, (-29*sqrt(5/96577))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(7/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -5*sqrt(7/193154), 0, (-29*sqrt(5/96577))/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-29*sqrt(5/96577))/4, 0, -1/4*sqrt(1001/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -1/4*sqrt(1001/22287), 0, (-5*sqrt(35/579462))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(35/579462))/2, 0,
        (3*sqrt(7/14858))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (3*sqrt(7/14858))/2, 0, (11*sqrt(13/22287))/4, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (11*sqrt(13/22287))/4, 0, sqrt(455/22287)/4, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(455/22287)/4, 0, -sqrt(91/14858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/14858), 0, 0, 0, sqrt(182/22287), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/7429)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(182/22287), 0, 0, 0, -2*sqrt(10/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(13/7429)/2, 0, 0, 0, (-7*sqrt(7/22287))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2*sqrt(10/22287), 0, 0, 0, -sqrt(154/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-7*sqrt(7/22287))/2, 0, 0, 0, sqrt(11/289731)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/96577), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/289731)/2, 0, 3*sqrt(35/96577), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(26/7429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(35/96577), 0, sqrt(11/289731)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(26/7429), 0, 0, 0, -sqrt(154/96577), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(11/289731)/2, 0, 0, 0, (-7*sqrt(7/22287))/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(154/96577), 0, 0, 0, -2*sqrt(10/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-7*sqrt(7/22287))/2, 0, 0, 0, sqrt(13/7429)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -2*sqrt(10/22287), 0, 0, 0, sqrt(182/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(13/7429)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(182/22287), 0,
        0, 0, 0, 0, -2*sqrt(13/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -11/(2*sqrt(7429)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3/(2*sqrt(14858)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(13/7429), 0, 0, 0, 0, 0, sqrt(77/14858)/2, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -11/(2*sqrt(7429)), 0, 0, 0, 0, 0, (5*sqrt(55/96577))/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(14858)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(77/14858)/2, 0, 0, 0, 9/sqrt(193154), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (5*sqrt(55/96577))/2, 0, 9/sqrt(193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(33/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -9/sqrt(193154), 0, (5*sqrt(55/96577))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -9/sqrt(193154), 0, 0, 0, sqrt(77/14858)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(33/96577), 0, 0, 0,
        0, 0, -3/(2*sqrt(14858)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(55/96577))/2, 0, 0, 0, 0, 0,
        -11/(2*sqrt(7429)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/14858)/2, 0, 0, 0, 0, 0, -2*sqrt(13/7429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3/(2*sqrt(14858)), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -11/(2*sqrt(7429)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -2*sqrt(13/7429), 0, 0, 0, 0, 0, 0, 0, sqrt(30/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/782)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/14858)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(30/7429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/782)/2, 0, 0, 0,
        0, 0, -3*sqrt(55/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/14858), 0, 0, 0, 3*sqrt(42/96577), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/14858)/2, 0, -3*sqrt(55/193154), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(66/96577), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(55/193154), 0, sqrt(33/14858)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(42/96577), 0, 0, 0, sqrt(55/14858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 3*sqrt(55/193154), 0, 0, 0, 0, 0, sqrt(19/782)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(66/96577), 0, 0, 0, 0, 0, 0, 0, sqrt(30/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(33/14858)/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/14858), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/782)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(30/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(11/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-9*sqrt(3/14858))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-7*sqrt(7/14858))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9*sqrt(3/96577), 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(11/7429), 0, 0, 0, 0, 0, 3*sqrt(7/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, (-9*sqrt(3/14858))/2, 0, 0, 0, 3*sqrt(7/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        (-7*sqrt(7/14858))/2, 0, -9*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(3/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 9*sqrt(3/96577), 0, (-7*sqrt(7/14858))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(7/193154), 0, 0, 0, (-9*sqrt(3/14858))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(7/193154), 0, 0, 0,
        0, 0, -sqrt(11/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 9*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(3/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, (-7*sqrt(7/14858))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, (-9*sqrt(3/14858))/2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(11/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/7429)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 6/sqrt(7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(70/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(77/96577), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/7429), 0, 0, 0, -3*sqrt(70/96577), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/7429)/2, 0, 6/sqrt(7429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(42/7429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -6/sqrt(7429), 0, sqrt(35/7429)/2, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(70/96577), 0, 0, 0, sqrt(2/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3*sqrt(77/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 3*sqrt(70/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -6/sqrt(7429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(42/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(35/7429)/2, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(2/7429), 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (7, 7, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/222870), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(39/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(21/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(77/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(105/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/37145), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(13/111435), 0, -sqrt(13/14858), 0,
        sqrt(91/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/14858), 0, -7*sqrt(13/111435), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/37145), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(105/14858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(39/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        29*sqrt(13/1560090), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -22*sqrt(3/260015), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(3/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/74290), 0, 0, 0, 3*sqrt(39/104006), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(13/37145), 0, 5*sqrt(13/52003), 0, 0, 0, -13*sqrt(13/222870), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(13/52003), 0, 2*sqrt(13/37145), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(39/104006), 0, 0, 0, sqrt(3/74290), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(7429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -22*sqrt(3/260015), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(39/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(21/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -22*sqrt(3/260015), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -83*sqrt(5/4056234), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 43*sqrt(3/6760390), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/96577), 0, 0, 0, 0, 0, -15*sqrt(3/104006), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(17/5681), 0, 0, 0, -9*sqrt(3/52003), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 61/sqrt(965770), 0, -16/sqrt(780045), 0, 0, 0, 0, 0, -sqrt(35/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 16/sqrt(780045), 0, 61/sqrt(965770), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 9*sqrt(3/52003), 0, 0, 0, -sqrt(17/5681), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        15*sqrt(3/104006), 0, 0, 0, 0, 0, sqrt(33/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 43*sqrt(3/6760390), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22*sqrt(3/260015), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 43*sqrt(3/6760390), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -157/sqrt(20281170), 0, 0, 0, 0, 0, 0, 0, 5*sqrt(33/104006), 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(858/260015), 0, 0, 0, 0, 0, 5*sqrt(3/104006), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -2*sqrt(66/96577), 0, 0, 0, -29/sqrt(520030), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(2/289731), 0,
        -sqrt(17/4370), 0, 0, 0, 0, 0, 0, 0, sqrt(133/50830), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(17/4370), 0, 5*sqrt(2/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        29/sqrt(520030), 0, 0, 0, -2*sqrt(66/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(3/104006), 0, 0, 0,
        0, 0, sqrt(858/260015), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(33/104006), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -43*sqrt(3/6760390), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(77/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(105/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(33/96577), 0, 0, 0, 0, 0, -15*sqrt(3/104006), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(858/260015), 0, 0, 0, 0, 0, 5*sqrt(3/104006), 0, 0, 0, 0, 0, 0, 0, 0, 0, 311/sqrt(20281170), 0, 0, 0,
        0, 0, 2*sqrt(55/52003), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/676039), 0, 0, 0, sqrt(33/37145), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/7429), 0, -4*sqrt(22/482885), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 7*sqrt(77/579462), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        4*sqrt(22/482885), 0, -sqrt(13/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/37145), 0, 0, 0,
        -sqrt(15/676039), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(55/52003), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(3/104006), 0, 0, 0, 0, 0, -sqrt(858/260015), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 15*sqrt(3/104006), 0, 0, 0, 0, 0, -sqrt(33/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 4/sqrt(7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(105/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(3/74290), 0, 0, 0, 3*sqrt(39/104006), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(17/5681), 0, 0, 0, -9*sqrt(3/52003), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(66/96577), 0, 0, 0,
        -29/sqrt(520030), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/676039), 0, 0, 0, sqrt(33/37145), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 55*sqrt(5/4056234), 0, 0, 0, sqrt(330/96577), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -20*sqrt(5/676039), 0, 5*sqrt(11/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        5*sqrt(7/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(11/289731), 0, -20*sqrt(5/676039), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(330/96577), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/37145), 0, 0, 0, sqrt(15/676039), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 29/sqrt(520030), 0, 0, 0, 2*sqrt(66/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        9*sqrt(3/52003), 0, 0, 0, sqrt(17/5681), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(39/104006), 0, 0, 0,
        -sqrt(3/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(273/37145), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -7*sqrt(13/111435), 0, -sqrt(13/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        2*sqrt(13/37145), 0, 5*sqrt(13/52003), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61/sqrt(965770), 0, -16/sqrt(780045), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(2/289731), 0, -sqrt(17/4370), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/7429), 0, -4*sqrt(22/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -20*sqrt(5/676039), 0, 5*sqrt(11/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -25*sqrt(5/4056234), 0, 10*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(15/193154), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -10*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(11/289731), 0, 20*sqrt(5/676039), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 4*sqrt(22/482885), 0, sqrt(13/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(17/4370), 0, -5*sqrt(2/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16/sqrt(780045), 0, -61/sqrt(965770), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(13/52003), 0, -2*sqrt(13/37145), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/14858), 0, 7*sqrt(13/111435), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(91/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -13*sqrt(13/222870), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(35/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(133/50830), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(77/579462), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/193154), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(15/193154), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(70/289731), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(15/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(7/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 7*sqrt(77/579462), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(133/50830), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(35/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -13*sqrt(13/222870), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/14858), 0,
        sqrt(13/14858), 0, -7*sqrt(13/111435), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(13/52003), 0,
        2*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 16/sqrt(780045), 0, 61/sqrt(965770), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/4370), 0, 5*sqrt(2/289731), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(22/482885), 0, -sqrt(13/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(11/289731), 0, -20*sqrt(5/676039), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -10*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(15/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -25*sqrt(5/4056234), 0, -10*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -20*sqrt(5/676039), 0, -5*sqrt(11/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(13/7429), 0, 4*sqrt(22/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(2/289731), 0,
        sqrt(17/4370), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 61/sqrt(965770), 0, 16/sqrt(780045), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(13/37145), 0, -5*sqrt(13/52003), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(13/111435), 0, sqrt(13/14858), 0, 0, 0, sqrt(273/37145), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(39/104006), 0, 0, 0, sqrt(3/74290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9*sqrt(3/52003), 0, 0, 0, -sqrt(17/5681), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 29/sqrt(520030), 0, 0, 0, -2*sqrt(66/96577), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(33/37145), 0, 0, 0, -sqrt(15/676039), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(330/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -5*sqrt(11/289731), 0, 20*sqrt(5/676039), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 5*sqrt(7/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -20*sqrt(5/676039), 0, -5*sqrt(11/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 55*sqrt(5/4056234), 0, 0, 0,
        -sqrt(330/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/676039), 0, 0, 0, -sqrt(33/37145), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(66/96577), 0, 0, 0, 29/sqrt(520030), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(17/5681), 0, 0, 0, 9*sqrt(3/52003), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(3/74290), 0, 0, 0, -3*sqrt(39/104006), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(273/37145), 0, 0, 0, 0, 0, 0, 0, -sqrt(105/14858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(7429), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 15*sqrt(3/104006), 0, 0, 0, 0, 0, sqrt(33/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -5*sqrt(3/104006), 0, 0, 0, 0, 0, sqrt(858/260015), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -2*sqrt(55/52003), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/37145), 0,
        0, 0, sqrt(15/676039), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(22/482885), 0, sqrt(13/7429), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        7*sqrt(77/579462), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/7429), 0, 4*sqrt(22/482885), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(15/676039), 0, 0, 0, -sqrt(33/37145), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 311/sqrt(20281170), 0, 0, 0, 0, 0, -2*sqrt(55/52003), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(858/260015), 0, 0, 0, 0, 0, -5*sqrt(3/104006), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(33/96577), 0, 0, 0, 0, 0, 15*sqrt(3/104006), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -4/sqrt(7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(105/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 43*sqrt(3/6760390), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(33/104006), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(3/104006), 0, 0, 0, 0, 0,
        -sqrt(858/260015), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 29/sqrt(520030), 0, 0, 0, 2*sqrt(66/96577), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/4370), 0, -5*sqrt(2/289731), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(133/50830), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(2/289731), 0, sqrt(17/4370), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(66/96577), 0, 0, 0, 29/sqrt(520030), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(858/260015), 0, 0, 0, 0, 0, -5*sqrt(3/104006), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -157/sqrt(20281170), 0, 0, 0, 0, 0, 0, 0, -5*sqrt(33/104006), 0, 0, 0, 0, 0, 0, 0, 0, 0, 43*sqrt(3/6760390), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(3/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/14858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(21/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -22*sqrt(3/260015), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -43*sqrt(3/6760390), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 15*sqrt(3/104006), 0, 0, 0, 0, 0, -sqrt(33/96577), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 9*sqrt(3/52003), 0, 0, 0, sqrt(17/5681), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 16/sqrt(780045), 0, -61/sqrt(965770), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(35/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 61/sqrt(965770), 0, 16/sqrt(780045), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(17/5681), 0, 0, 0, 9*sqrt(3/52003), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(33/96577), 0, 0, 0, 0, 0, 15*sqrt(3/104006), 0, 0, 0, 0, 0, 0, 0, 0, 0, 43*sqrt(3/6760390), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -83*sqrt(5/4056234), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -22*sqrt(3/260015), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(39/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 22*sqrt(3/260015), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 4/sqrt(7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(39/104006), 0, 0, 0, -sqrt(3/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(13/52003), 0,
        -2*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -13*sqrt(13/222870), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 2*sqrt(13/37145), 0, -5*sqrt(13/52003), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(3/74290), 0, 0, 0, -3*sqrt(39/104006), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4/sqrt(7429), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -22*sqrt(3/260015), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 29*sqrt(13/1560090), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(39/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/37145), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(77/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(105/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(273/37145), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/14858), 0, 7*sqrt(13/111435), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(91/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -7*sqrt(13/111435), 0, sqrt(13/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/37145), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(105/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(21/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(39/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/222870), 0, 0, 0,
        0, 0, 0, 0, 0,
    ]),
    # split

    (7, 8, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, sqrt(13/44574), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/7429), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/14858), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/44574),
        0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/14858), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 3*sqrt(13/37145), 0, -sqrt(13/44574), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/14858),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(11/14858), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(39/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(13/44574), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(65/44574), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/22287), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -2*sqrt(39/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(21/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/44574), 0, 0, 0, -sqrt(21/14858), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/22287), 0, 2*sqrt(39/37145), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(91/74290),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(39/37145), 0, sqrt(91/22287), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/14858), 0, 0, 0, sqrt(65/44574), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(21/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(39/37145),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(91/74290), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/22287), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(65/44574), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(55/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 5*sqrt(5/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(7/37145),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(51/56810), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(55/14858), 0, 0, 0, 0, 0, 3*sqrt(35/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -5*sqrt(5/22287), 0, 0, 0, -3*sqrt(35/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(7/37145),
        0, sqrt(51/56810), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(51/56810), 0, -4*sqrt(7/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(35/96577),
        0, 0, 0, -5*sqrt(5/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(35/96577), 0, 0, 0, 0,
        0, -sqrt(55/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(51/56810), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 3*sqrt(3/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 4*sqrt(7/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 5*sqrt(5/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(55/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(11/44574), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(55/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -(1/sqrt(14858)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(19/11730), 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(11/44574), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/14858), 0, 0, 0, 0, 0, 9*sqrt(2/96577),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(14858), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(19/11730), 0, -9*sqrt(2/96577), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -47*sqrt(3/965770), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9*sqrt(2/96577), 0, -sqrt(19/11730), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(14858), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -9*sqrt(2/96577), 0, 0, 0, 0, 0, sqrt(55/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 47*sqrt(3/965770),
        0, 0, 0, 0, 0, 0, 0, 5*sqrt(11/44574), 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/11730), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(14858)), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(55/14858), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(11/44574), 0, 0, 0, 0, 0, 0, 0, 5*sqrt(13/44574),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/sqrt(44574), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(3/7429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -5*sqrt(13/44574), 0, 0, 0, 0, 0, -sqrt(77/22287), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -5/sqrt(44574), 0, 0, 0, 0, 0, -8*sqrt(22/1448655), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 2*sqrt(3/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(77/22287), 0, 0, 0, 9*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8*sqrt(22/1448655),
        0, -9*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -3*sqrt(11/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9*sqrt(3/96577),
        0, 8*sqrt(22/1448655), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9*sqrt(3/96577), 0, 0, 0, sqrt(77/22287),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/193154), 0, 0, 0, 0, 0, 2*sqrt(3/7429), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -8*sqrt(22/1448655), 0, 0, 0, 0, 0, -5/sqrt(44574), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(77/22287), 0, 0, 0, 0, 0, -5*sqrt(13/44574), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -2*sqrt(3/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 5/sqrt(44574), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 5*sqrt(13/44574), 0, 0, 0, 0, 0, -sqrt(91/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(13/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/14858),
        0, 0, 0, sqrt(17/4370), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/22287), 0, 0,
        0, sqrt(7/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(17/4370), 0, 0, 0, -sqrt(154/289731),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(7/7429), 0, 0, 0, -5*sqrt(11/96577), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(154/289731), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(11/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15*sqrt(3/193154), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(11/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -15*sqrt(3/193154), 0, 0, 0, sqrt(154/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -5*sqrt(11/96577), 0, 0, 0, -sqrt(7/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/289731),
        0, 0, 0, -sqrt(17/4370), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/7429), 0, 0,
        0, -sqrt(13/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(17/4370), 0, 0, 0, sqrt(91/14858),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/22287), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/14858), 0, 0, 0, sqrt(455/14858)/3, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(455/14858), 0, -sqrt(91/22287), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/22287), 0, -4*sqrt(13/111435), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 4*sqrt(13/111435), 0, (7*sqrt(7/74290))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, (-7*sqrt(7/74290))/3, 0, 8*sqrt(14/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -8*sqrt(14/289731), 0, sqrt(385/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -sqrt(385/289731), 0, -10/(3*sqrt(96577)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10/(3*sqrt(96577)),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(35/193154),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(35/193154), 0, 10/(3*sqrt(96577)), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -10/(3*sqrt(96577)), 0, -sqrt(385/289731), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(385/289731), 0, -8*sqrt(14/289731), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 8*sqrt(14/289731), 0, (-7*sqrt(7/74290))/3, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/74290))/3, 0, 4*sqrt(13/111435), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -4*sqrt(13/111435), 0, sqrt(91/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(91/22287), 0, -1/3*sqrt(455/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(455/14858)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(130/7429)/3,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-5*sqrt(65/14858))/3, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(247/3910)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 149/(3*sqrt(965770)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/193154),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-43*sqrt(5/193154))/3, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-35*sqrt(5/193154))/3, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, (35*sqrt(5/193154))/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (43*sqrt(5/193154))/3,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(5/193154), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -149/(3*sqrt(965770)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(247/3910), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (5*sqrt(65/14858))/3,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(130/7429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -1/3*sqrt(455/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(91/22287), 0, -1/3*sqrt(455/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(13/111435),
        0, sqrt(91/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (-7*sqrt(7/74290))/3, 0, 4*sqrt(13/111435), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -8*sqrt(14/289731), 0, (-7*sqrt(7/74290))/3, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(385/289731), 0, -8*sqrt(14/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 10/(3*sqrt(96577)), 0, -sqrt(385/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(35/193154),
        0, 10/(3*sqrt(96577)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(35/193154), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -10/(3*sqrt(96577)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(385/289731), 0, -10/(3*sqrt(96577)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 8*sqrt(14/289731), 0, sqrt(385/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, (7*sqrt(7/74290))/3,
        0, 8*sqrt(14/289731), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(13/111435), 0, (7*sqrt(7/74290))/3, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/22287), 0, -4*sqrt(13/111435), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(455/14858)/3, 0, -sqrt(91/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(455/14858)/3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(91/14858), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/22287), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(17/4370), 0, 0, 0, sqrt(91/14858), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(7/7429), 0, 0, 0, -sqrt(13/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(154/289731),
        0, 0, 0, -sqrt(17/4370), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(11/96577), 0, 0, 0, -sqrt(7/7429),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 15*sqrt(3/193154), 0, 0, 0, sqrt(154/289731), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(11/96577), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -15*sqrt(3/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(11/96577),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(154/289731), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(7/7429), 0, 0, 0, -5*sqrt(11/96577), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(17/4370), 0, 0, 0, -sqrt(154/289731), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(13/22287), 0, 0, 0, sqrt(7/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/14858),
        0, 0, 0, sqrt(17/4370), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/22287),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/14858), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -5*sqrt(13/44574), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5/sqrt(44574),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(3/7429), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(77/22287), 0, 0, 0, 0, 0, -5*sqrt(13/44574), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 8*sqrt(22/1448655), 0, 0, 0, 0, 0, -5/sqrt(44574), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -3*sqrt(11/193154), 0, 0, 0, 0, 0, 2*sqrt(3/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 9*sqrt(3/96577), 0, 0, 0, sqrt(77/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -9*sqrt(3/96577),
        0, 8*sqrt(22/1448655), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/193154), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -8*sqrt(22/1448655), 0, -9*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -sqrt(77/22287), 0, 0, 0, 9*sqrt(3/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(3/7429),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5/sqrt(44574), 0, 0, 0, 0,
        0, -8*sqrt(22/1448655), 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(13/44574), 0, 0, 0, 0, 0, -sqrt(77/22287), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(3/7429), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 5/sqrt(44574), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 5*sqrt(13/44574), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(11/44574), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(55/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 1/sqrt(14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(19/11730),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -47*sqrt(3/965770), 0, 0, 0, 0,
        0, 0, 0, 5*sqrt(11/44574), 0, 0, 0, 0, 0, 0, 0, 0, 0, 9*sqrt(2/96577), 0, 0, 0, 0, 0, sqrt(55/14858),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/sqrt(14858), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, -9*sqrt(2/96577), 0, -sqrt(19/11730), 0, 0, 0, 0, 0, 0, 0, 47*sqrt(3/965770),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(19/11730), 0, -9*sqrt(2/96577), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -(1/sqrt(14858)), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(55/14858), 0, 0, 0, 0, 0, 9*sqrt(2/96577), 0, 0, 0, 0, 0, 0,
        0, 0, 0, -5*sqrt(11/44574), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(19/11730), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -(1/sqrt(14858)), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(55/14858),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(11/44574), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(55/14858),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/22287), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(7/37145), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -sqrt(51/56810), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 3*sqrt(35/96577), 0, 0, 0, 0, 0, -sqrt(55/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, -3*sqrt(35/96577), 0, 0, 0, -5*sqrt(5/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(51/56810),
        0, -4*sqrt(7/37145), 0, 0, 0, 0, 0, 3*sqrt(3/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 4*sqrt(7/37145), 0, sqrt(51/56810), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(5/22287),
        0, 0, 0, -3*sqrt(35/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(55/14858), 0, 0, 0, 0,
        0, 3*sqrt(35/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(51/56810),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4*sqrt(7/37145), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 5*sqrt(5/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(55/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(65/44574), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, sqrt(91/22287), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(91/74290),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(39/37145), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/14858), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(21/14858), 0, 0, 0, sqrt(65/44574), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(39/37145), 0, sqrt(91/22287), 0, 0, 0, -3*sqrt(91/74290), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/22287), 0, 2*sqrt(39/37145), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(65/44574), 0, 0, 0, -sqrt(21/14858), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, sqrt(21/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, -2*sqrt(39/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(91/22287),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(65/44574), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(13/44574), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/14858), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, -sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, -3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/37145),
        0, -sqrt(13/44574), 0, sqrt(39/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(13/44574),
        0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429),
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(11/14858), 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/14858), 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/7429), 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, sqrt(13/44574), 0, 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split

    (8, 8, 8): np.array([
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(26/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(429/74290), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0, sqrt(26/37145), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(13/74290), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(39/7429), 0, 3*sqrt(13/74290), 0, -7*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(13/74290), 0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/74290), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/37145), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(65/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(33/37145), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0, -sqrt(273/74290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/7429), 0, 0, 0, sqrt(65/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(33/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(273/74290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(429/74290), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/37145), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(65/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(21/37145), 0, 0, 0, 0, 0, sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(21/37145), 0, 0, 0, 3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0,
        0, 0, 0, 0, 0, 0, sqrt(65/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/37145), 0,
        0, 0, sqrt(21/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(429/74290), 0, 0, 0, 0, 0,
        sqrt(21/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/193154), 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(6/96577), 0, 0, 0, 0, 0, -sqrt(33/74290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(154/482885), 0, 0, 0, 3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -4*sqrt(6/96577), 0, 3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/193154), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0, -4*sqrt(6/96577), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0, 3*sqrt(154/482885), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0, -4*sqrt(6/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/74290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(429/74290), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(33/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(21/37145), 0, 0, 0, 0, 0, sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -4*sqrt(6/96577), 0, 0, 0, 0, 0, -sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, -73/sqrt(965770), 0,
        0, 0, 0, 0, -2*sqrt(33/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(33/482885), 0, 0, 0,
        -sqrt(21/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(33/482885), 0, 4*sqrt(6/96577), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -73/sqrt(965770), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -4*sqrt(6/96577), 0, 3*sqrt(33/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/37145), 0,
        0, 0, 3*sqrt(33/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(33/37145), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0, 4*sqrt(6/96577), 0, 0, 0,
        0, 0, 0, 0, 0, 0, -sqrt(429/74290), 0, 0, 0, 0, 0, -sqrt(21/37145), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(33/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(3/14858), 0, 0, 0, -sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/37145), 0, 0, 0,
        3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(154/482885), 0, 0, 0, 3*sqrt(3/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(33/482885), 0, 0, 0, -sqrt(21/37145), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -37/sqrt(965770), 0, 0, 0, -3*sqrt(154/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 6*sqrt(7/96577), 0, -3*sqrt(33/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -37/sqrt(965770), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(33/482885), 0, 6*sqrt(7/96577), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(154/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(21/37145), 0, 0, 0, -3*sqrt(33/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(3/14858), 0, 0, 0, -3*sqrt(154/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/37145), 0, 0, 0,
        -sqrt(21/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, 3*sqrt(3/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, 3*sqrt(13/74290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -4*sqrt(6/96577), 0, 3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(33/482885), 0,
        4*sqrt(6/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(7/96577), 0, -3*sqrt(33/482885), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(5/193154), 0, -6*sqrt(7/96577), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 7*sqrt(5/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 6*sqrt(7/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(33/482885), 0,
        -6*sqrt(7/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(6/96577), 0, -3*sqrt(33/482885), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0, 4*sqrt(6/96577), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0,
        -sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(13/74290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(26/37145), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(65/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -5*sqrt(5/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -73/sqrt(965770), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -37/sqrt(965770), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(5/193154), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(10/96577), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 7*sqrt(5/193154), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -37/sqrt(965770), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -73/sqrt(965770), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(65/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(65/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -7*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(26/37145), 0, -3*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0,
        sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0, -4*sqrt(6/96577), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(6/96577), 0, 3*sqrt(33/482885), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(33/482885), 0, 6*sqrt(7/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 6*sqrt(7/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 7*sqrt(5/193154), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 7*sqrt(5/193154), 0, 6*sqrt(7/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        6*sqrt(7/96577), 0, 3*sqrt(33/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(33/482885), 0,
        -4*sqrt(6/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(6/96577), 0, -3*sqrt(5/14858), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, -3*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(13/37145), 0, 0, 0, sqrt(21/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(3/14858), 0, 0, 0, 3*sqrt(154/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/37145), 0,
        0, 0, 3*sqrt(33/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(154/482885), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(33/482885), 0, -6*sqrt(7/96577), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -37/sqrt(965770), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6*sqrt(7/96577), 0, 3*sqrt(33/482885), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -37/sqrt(965770), 0, 0, 0, 3*sqrt(154/482885), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 3*sqrt(33/482885), 0, 0, 0, sqrt(21/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3*sqrt(154/482885), 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(21/37145), 0, 0, 0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(3/14858), 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/37145), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0,
        0, 0, -sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(33/37145), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(429/74290), 0, 0, 0, 0, 0, sqrt(21/37145), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0, -4*sqrt(6/96577), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 2*sqrt(33/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(21/37145), 0, 0, 0, -3*sqrt(33/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -4*sqrt(6/96577), 0, -3*sqrt(33/482885), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -73/sqrt(965770), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 3*sqrt(33/482885), 0, -4*sqrt(6/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(33/482885), 0,
        0, 0, sqrt(21/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -73/sqrt(965770), 0, 0, 0, 0, 0,
        2*sqrt(33/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(6/96577), 0, 0, 0, 0, 0, sqrt(33/74290), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/37145), 0, 0, 0, 0, 0, -sqrt(429/74290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 2*sqrt(33/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0,
        4*sqrt(6/96577), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0, -3*sqrt(154/482885), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0, 4*sqrt(6/96577), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -5*sqrt(5/193154), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -4*sqrt(6/96577), 0, -3*sqrt(5/14858), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(154/482885), 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -4*sqrt(6/96577), 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -5*sqrt(5/193154), 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, -sqrt(429/74290), 0, 0, 0, 0, 0, -sqrt(21/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(13/37145), 0, 0, 0, -sqrt(21/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(65/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/37145), 0,
        0, 0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(21/37145), 0, 0, 0, 0, 0,
        -sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(5/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(65/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2*sqrt(33/37145), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, 3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(3/14858), 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 2*sqrt(33/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        -3*sqrt(3/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(65/14858), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, -3*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(39/7429), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0, -sqrt(39/7429), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -7*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(39/7429), 0, -3*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/37145), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(33/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, -3*sqrt(13/37145), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, sqrt(39/7429), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -7*sqrt(13/74290), 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 3*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(11/14858), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 3*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(26/37145), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, -sqrt(429/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        3*sqrt(11/14858), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -sqrt(429/74290), 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, sqrt(273/74290), 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, -3*sqrt(13/74290), 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, sqrt(26/37145), 0, 0, 0, 0, 0, 0, 0, 0,
    ]),
    # split
}
